if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function(elt /*,from*/ ) {
    var len = this.length;
    var from = Number(arguments[1]) || 0;
    from = (from < 0) ? Math.ceil(from) : Math.floor(from);
    if (from < 0) {
      from += len;
    }
    for (; from < len; from++) {
      if (from in this && this[from] === elt) {
        return from;
      }
    }
    return -1;
  };
}

if (!Date.now) {
  Date.now = function now() {
    return new Date().getTime();
  };
}

var pharosModule;
if (window.googleMapApiInvalid === true) {
  pharosModule = angular.module('pharoscontrol', ['ngRoute', 'pascalprecht.translate', 'ui.bootstrap', 'pharosComm', 'chart.js']);
} else {
  pharosModule = angular.module('pharoscontrol', ['ngRoute', 'pascalprecht.translate', 'ui.bootstrap', 'pharosComm', 'chart.js', 'uiGmapgoogle-maps']);

  pharosModule.config(["uiGmapGoogleMapApiProvider", function(GoogleMapApi) {
    GoogleMapApi.configure({
      key: 'AIzaSyBODcxicW3MBaptaVE8T_hVEd5hnQLQxsQ',
      libraries: 'places'
    });
  }])
}

pharosModule.config(["$routeProvider", "$controllerProvider", "$provide", "$filterProvider",
  function($routeProvider, $controllerProvider, $provide, $filterProvider) {

    pharosModule.controllerProvider = $controllerProvider;
    pharosModule.routeProvider = $routeProvider;
    pharosModule.provide = $provide;
    pharosModule.filter = $filterProvider.register;
  }
]);


/*pharosModule.config(function($stateProvider, $urlRouterProvider){
	$urlRouterProvider.otherwise('/');

	var stateObjs = {
		"app":{
			name: "app",
			url: "/",
			views: {
				"content@": {
					templateUrl: "components/pages/login/content.html"
				}
			},
			js: ["./js/controllers/device.js"]
		},
		"device": {
			name: "app.device",
			url: "device",
			views: {
				"content@": {
					templateUrl: "components/pages/device/device.html",
					persist: true
				}
			},
			controller: "device",
			js: ["./js/controllers/device.js"]
		},
		"detail": {
			name: "app.device.detail",
			url: "/detail",
			views: {
				"content@": {
					templateUrl: "components/pages/device/detail.html"
				}
			},
			controller: "detail",
			js: []
		},
		"firmware": {
			name: "app.firmware",
			url: "firmware",
			views: {
				"content@": {
					templateUrl: "components/pages/firmware/firmware.html",
					persist: true
				}
			},
			controller: "firmware",
			js: ['./js/controllers/firmware.js']
		},
		"task": {
			name: "app.task",
			url: "task",
			views: {
				"content@": {
					templateUrl: "components/pages/task/task.html",
					persiset: true
				}
			},
			controller: "task",
			js: ["./js/controllers/task.js"]
		},
		"trigger": {
			name: "app.trigger",
			url: "trigger",
			views: {
				"content@": {
					templateUrl: "components/pages/trigger/trigger.html",
					persiset: true
				}
			},
			controller: "trigger",
			js: ['./js/controllers/trigger.js']
		},
		"user": {
			name: "app.user",
			url: "user",
			views: {
				"content@": {
					templateUrl: "components/pages/user/account.html",
				}
			},
			controller: "user",
			js: ["./js/controllers/account.js"]
		},
		"log": {
			name: "app.log",
			url: "log",
			views: {
				'content@': {
					templateUrl: "components/pages/log/log.html",
				}
			},
			controller: "log",
			js: ['./js/controllers/log.js']
		}
	};
	for(var item in stateObjs){
		if(angular.isObject(stateObjs[item])){
			var fn = (function(obj){
				var js = obj.js;
				return ["$q", "$rootScope", function($q, $rootScope){
						var def = $q.defer();

						if(js.length !== 0){
							$script(js, function() {
								$rootScope.$apply(function() {
									def.resolve();
								});
							});
						}else{
							// $rootScope.$apply(function() {
								def.resolve();
							// });
						}
						return def.promise;
					}];
			})(stateObjs[item])

			var route = {
				url: stateObjs[item].url,
				views: stateObjs[item].views,
				controller: stateObjs[item].controller,
				resolve:{
					delay: fn
				}
			}
			$stateProvider.state(stateObjs[item].name,route);
		}
	}
});*/

/*
 * register $state & $stateParams in $rootScope to get current
 * state in sidebar
 */
pharosModule.run(['$rootScope', '$module', '$user', function($rootScope, $module, $user) {
  // $rootScope.$state = $state;
  // $rootScope.$stateParams = $stateParams;

  if (!$user.getCookie("NAME")) {
    location.href = "./login.html";
  }
  var user = $user.getCookie("NAME").split("&amp");
  $module.config(user[0], user[1]);

  $rootScope.rootRole = user[1];
}]);

pharosModule.factory("$module", ["$user", "$route", "$rootScope", function($user, $route, $rootScope) {
  var stateObjs = {
    "device": {
      name: "device",
      url: "/device",
      text: "NAV.DEVICE",
      templateUrl: "components/pages/device.html",
      controller: "device",
      js: ["./js/controllers/device.js"]
    },
    "firmware": {
      name: "firmware",
      url: "/firmware",
      text: "NAV.FIRMWARE",
      templateUrl: "components/pages/firmware.html",
      controller: "firmware",
      js: ['./js/controllers/firmware.js']
    },
    "task": {
      name: "task",
      url: "/task",
      text: "NAV.TASK",
      templateUrl: "components/pages/task.html",
      controller: "task",
      js: ["./js/controllers/task.js"]
    },
    "trigger": {
      name: "trigger",
      url: "/trigger",
      text: "NAV.TRIGGER",
      templateUrl: "components/pages/trigger.html",
      controller: "trigger",
      js: ['./js/controllers/trigger.js']
    },
    "user": {
      name: "user",
      url: "/user",
      text: "NAV.ACCOUNT",
      templateUrl: "components/pages/account.html",
      controller: "account",
      js: ["./js/controllers/account.js"]
    },
    "log": {
      name: "log",
      url: "/log",
      text: "NAV.LOG",
      templateUrl: "components/pages/log.html",
      controller: "log",
      js: ['./js/controllers/log.js']
    }
  };

  var roleRoutes = {
    "GUEST": ["device", "task", "trigger", "log"],
    "MANAGER": ["device", "firmware", "task", "trigger", "log"],
    "ADMIN": ["device", "firmware", "task", "trigger", "user", "log"]
  };

  var routeArray = [];

  var _module = {
    username: "",
    navigators: [],
    current: "",
    config: function(username, userRole) {
      if (username) {
        this.username = username;
      }
      // var userRole = $user.getCookie("NAME").split("&amp")[1];
      if (userRole) {
        routeArray = roleRoutes[userRole];
      }

      for (var index = 0, len = routeArray.length; index < len; index++) {
        var item = routeArray[index];

        if (!angular.isObject(stateObjs[item])) {
          continue;
        }

        var obj = stateObjs[item];
        this.navigators.push(obj);

        var fn = (function(obj) {
          var js = obj.js;

          return ["$q", "$rootScope", function($q, $rootScope) {
            var delay = $q.defer();
            $script(js, function() {
              $rootScope.$apply(function() {
                delay.resolve();
              });
            });
            return delay.promise;
          }];
        })(obj);

        var route = {
          templateUrl: obj.templateUrl,
          controller: obj.controller,
          resolve: {
            delay: fn
          }
        };
        pharosModule.routeProvider.when(obj.url, route);
      }
      pharosModule.routeProvider.otherwise({
        redirectTo: "/device"
      });
      $route.reload();
    },
    constructor: function(router, fn) {
      $rootScope.$on("$routeChangeSuccess", function(e, current, pre) {
        if (angular.isDefined(current) && angular.isDefined(current.controller) && router.toLowerCase() === current.controller.toLowerCase()) {
          fn();
        }
      });
    },
    destory: function(router, fn) {
      $rootScope.$on("$routeChangeStart", function(e, next, current) {
        if (angular.isDefined(current) && angular.isDefined(current.controller) && router.toLowerCase() === current.controller.toLowerCase()) {
          fn();
        }
      });
    }
  };
  $rootScope.$on("$routeChangeSuccess", function(e, current, pre) {
    _module.current = current.controller;
  });

  return _module;
}]);


pharosModule.controller("navController", ["$scope", "$form", "$url", "$translate", "$user", "$proxy","$interval", "$timeout",
  function($scope, $form, $url, $translate, $user, $proxy, $interval, $timeout) {

    var userUrl = $url.format("/misc/");

    $scope.logout = function() {
      $proxy.request({
        url: userUrl
      }, {
        "REQUEST": "LOGOUT"
      }, function() {
        $user.delCookie("NAME");
        location.href = "./login.html";
      }, function(err_msg) {
        // situation of guest been deleted by admin
        if(err_msg === "USER_HANDLER.USER_NOT_FIND"){
          $user.delCookie("NAME");
          location.href = "./login.html";
        }
      }, function() {});
    };

    var config = {
      proxy: {
        url: userUrl
      },
      fields: [{
        name: "role"
      }, {
        name: "username",
        allowBlank: false,
      }, {
        name: "oldPassword",
        allowBlank: false,
        encryption: {
          name: "hex_sha1"
        }
      }, {
        name: "password",
        allowBlank: false,
        encryption: {
          name: "hex_sha1"
        }
      }, {
        name: "confirmPassword",
        allowBlank: false,
        encryption: {
          name: "hex_sha1"
        }
      }, {
        name: "email",
        allowBlank: false,
        vtype: "email"
      }, {
        name: "telephone",
        vtype: "phone_number"
      }, {
        name: "note"
      }],
      // validator: function(scope){
      // 	return true;
      // },
      autoLoad: false
    };
    $form.config($scope, config);

    $scope.changePswCtrl = function() {
      $scope.changePsw = !$scope.changePsw;
    }

    $scope.errorMsg = {
        title: "NAV.ERROR",
        content: "DEVICE_HANDLER.UNKNOWN_ERROR",
        okBtn: {
            handler: function() {}
        },
        cancelBtn: {
            show: false
        }
    };

    $scope.adminSettingMsg = {
      title: "NAV.MY_SETTING",
      okBtn: {
        handler: function() {
          if ($scope.changePsw) {
            $form.serialize($scope, ["oldPassword", "password", "confirmPassword"]);
          }
          $form.submit($scope, {
            "REQUEST": "EDIT_MY_PROFILE"
          }, function(data) {
            $scope.adminSettingMsg.show = false;
            if (!$scope.changePsw) {
              $scope.logout();
            }
          }, function(err_msg) {
            $scope.adminSettingMsg.msg_errtip = err_msg;
            // $scope.adminSettingMsg.show = false;
            // $form.clear($scope);
            // $scope.errorMsg.content = err_msg;
            // $scope.errorMsg.show = true;
          }, function(){}, false, undefined, undefined, false);

        }
      },
      cancelBtn: {
        handler: function() {
          $scope.adminSettingMsg.show = false;
          $form.clear($scope);
        }
      },
      autoClose: false
    }

    $scope.showAdminSettting = function() {
      $form.clear($scope);
      $form.load($scope, {
        "REQUEST": "GET_MY_PROFILE"
      }, function(data) {
        // form init

        var options = {
          "ADMIN": {
            description: "ACCOUNT.ADMINISTRATOR",
            value: "ADMIN"
          },
          "MANAGER": {
            description: "ACCOUNT.MANAGER",
            value: "MANAGER"
          },
          "GUEST": {
            description: "ACCOUNT.GUEST",
            value: "GUEST"
          }
        }

        $scope.form.data.role.options = [{
          description: options[data.role].description,
          value: options[data.role].value
        }];

        $scope.form.data.role.data = data.role;
        $scope.changePsw = true;

        if(data.passwordUpdateTime && data.passwordUpdateTime.time){
          var date = new Date(data.passwordUpdateTime.time);
          var year = date.getFullYear();
          var month = date.getMonth() + 1;
          if((month + "").length === 1){
            month = "0" + month;
          }

          var day = date.getDate() + "";
          if(day.length === 1){
            day = "0" + day;
          }

          var h = date.getHours() + "";
          if(h.length === 1){
            h = "0" + h;
          }
          var m = date.getMinutes() + "";
          if(m.length === 1){
            m = "0" + m;
          }
          var s = date.getSeconds() + "";
          if(s.length === 1){
            s = "0" + s;
          }
          $scope.pswLastchangedDate = day + "/" + month + "/" + year + " " + h + ":" + m + ":" + s;
        } else {
          $scope.pswLastchangedDate = "N/A";
        }

        $scope.form.data.username.disabled = true;
        $scope.adminSettingMsg.msg_errtip = "";
        $scope.adminSettingMsg.show = true;
      }, function() {

      })
    }

    function heartBeat(){
      $proxy.request({
        url: userUrl
      }, {
        "REQUEST": "HEART_BEAT"
      }, function() {
        // console.log("heart beat success");
      }, function() {
        clearTimeout(heartId);
        heartId = false;
        $scope.sessionDownMsg.show=true;
      }, function() {
      });
    }

    $scope.$on("Unauthorized401", function(){
      clearTimeout(heartId);
      heartId = false;
      $scope.sessionDownMsg.show=true;
    })

    var heartTime = 7000;
    var heartId = setTimeout(function(){
      heartBeat();
      if(heartId){
        heartId = setTimeout(arguments.callee, heartTime);
      }
    }, heartTime);

    $scope.sessionDownMsg = {
      title: "NAV.ERROR",
      okBtn: {
        handler: function() {
          // $scope.logout();
          location.href = "./login.html";
        }
      },
      cancelBtn: {
        show: false
      },
      autoClose: false
    }

    var MAX_LENGTH = {
        "oldPassword": 50,
        "password": 50,
        "confirmPassword": 50,
        "email": 50,
        "telephone": 30
    }

    $scope.$watch("changePsw", function(nVal) {
        if (nVal === true) {
          $scope.form.data.oldPassword.inputData = "";
          $scope.form.data.password.inputData = "";
          $scope.form.data.confirmPassword.inputData = "";
        }
    });


    var temailKeep;
    $scope.$watch("form.data.email.data", function(nVal) {
        var emailMaxLength = MAX_LENGTH["email"];
        if (nVal.length && nVal.length === emailMaxLength) {
            temailKeep = nVal;
        }

        if (nVal.length && nVal.length > emailMaxLength) {
            // $scope.form.data.email.data = nVal.slice(0, emailMaxLength);
            $scope.form.data.email.data = temailKeep;
        }
    });

    var tphoneKeep;
    $scope.$watch("form.data.telephone.data", function(nVal) {
        var telephoneMaxLength = MAX_LENGTH["telephone"];
        if (nVal.length && nVal.length === telephoneMaxLength) {
            tphoneKeep = nVal;
        }

        if (nVal.length && nVal.length > telephoneMaxLength) {
            // $scope.form.data.telephone.data = nVal.slice(0, telephoneMaxLength);
            $scope.form.data.telephone.data = tphoneKeep;
        }
    });

    $scope.$watch("form.data.oldPassword.inputData", function(nVal) {
      var oldPasswordMaxLength = MAX_LENGTH["oldPassword"];
      if (nVal && nVal.length && nVal.length > oldPasswordMaxLength) {
          $scope.form.data.oldPassword.inputData = nVal.slice(0, oldPasswordMaxLength);
      }
    });

    $scope.$watch("form.data.password.inputData", function(nVal) {
      var passwordMaxLength = MAX_LENGTH["password"];
      if (nVal && nVal.length && nVal.length > passwordMaxLength) {
          $scope.form.data.password.inputData = nVal.slice(0, passwordMaxLength);
      }

      var cfmPwd = $scope.form.data.confirmPassword.inputData;
      if (cfmPwd != "") {
        if (nVal === cfmPwd) {
          $scope.form.data.confirmPassword.valid = true;
          $scope.form.data.confirmPassword.validate = function() {
            return true;
          };
        } else {
          $scope.form.data.confirmPassword.valid = false;
          $scope.form.data.confirmPassword.validate = function() {
            return false;
          };
          $scope.form.data.confirmPassword.validate.errorTip = $translate.instant("ACCOUNT.PASSWORD_BESAME");
        }
      }
    });

    $scope.$watch("form.data.confirmPassword.inputData", function(nVal) {
      var confirmPasswordMaxLength = MAX_LENGTH["confirmPassword"];
      if (nVal && nVal.length && nVal.length > confirmPasswordMaxLength) {
          $scope.form.data.confirmPassword.inputData = nVal.slice(0, confirmPasswordMaxLength);
      }

      var newPwd = $scope.form.data.password.inputData;
      if (newPwd === nVal) {
        $scope.form.data.confirmPassword.valid = true;
        $scope.form.data.confirmPassword.validate = function() {
          return true;
        };
      } else {
        $scope.form.data.confirmPassword.valid = false;
        $scope.form.data.confirmPassword.validate = function() {
          return false;
        };
        $scope.form.data.confirmPassword.validate.errorTip = $translate.instant("ACCOUNT.PASSWORD_BESAME");
      }
    });
  }
]);
