pharosModule.controllerProvider.register("account", [
    "$scope",
    "$proxy",
    "$url",
    "$grid",
    "$timeout",
    '$toolBarSrv',
    "$translate",
    "$interval",
    "$form",
    "$user",
    function($scope, $proxy, $url, $grid, $timeout, $toolBarSrv, $translate, $interval, $form, $user) {
        var userUrl = $url.format("/user/");

        // 清空遗留的 toptool
        angular.element(document.getElementById("menubar-container")).empty();

        var miscUrl = $url.format("/misc/");
        $scope.isCurUserRootAdmin = false;
        $proxy.request({
            url: miscUrl
        }, {
            "REQUEST": "GET_MY_PROFILE"
        }, function(data) {
            $scope.curUserID = data.userID;
            if (data.userID === 1) {
                $scope.isCurUserRootAdmin = true;
            }
        });

        $scope.accountMenu = {};
        $scope.information = {};
        $scope.information.curFolder = {};
        $scope.accountMenu.data = {
            accountTree: {
                "children": [
                    {
                        "name": "ACCOUNT.ADMINISTRATOR",
                        "type": "ADMIN",
                        "isLeaf": true,
                        "uuid": "ADMINISTRATOR"
                    }, {
                        "name": "ACCOUNT.MANAGER",
                        "type": "MANAGER",
                        "isLeaf": true,
                        "uuid": "MANAGER"
                    }, {
                        "name": "ACCOUNT.GUEST",
                        "type": "GUEST",
                        "isLeaf": true,
                        "uuid": "GUEST"
                    }
                ],
                "name": "ACCOUNT.ACCOUNTS",
                "type": "ALL",
                "uuid": "ACCOUNTS"
            }
        };
        $scope.menuConfig = {
            editable: false
        };
        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "ACCOUNT.NAME",
                    name: "username"
                }, {
                    show: "ACCOUNT.ROLE",
                    name: "role",
                    format: function(data) {
                        switch (data) {
                            case "ADMIN":
                                return $translate.instant("ACCOUNT.ADMINISTRATOR");
                            case "MANAGER":
                                return $translate.instant("ACCOUNT.MANAGER");
                            case "GUEST":
                                return $translate.instant("ACCOUNT.GUEST");
                        }
                    }
                }, {
                    show: "ACCOUNT.LOGIN",
                    name: "logined",
                    format: function(data) {
                        if (data === true) {
                            return $translate.instant("ACCOUNT.YES");
                        } else {
                            return $translate.instant("ACCOUNT.NO");
                        }
                    }
                }, {
                    show: "ACCOUNT.EMAIL",
                    name: "email"
                }, {
                    show: "ACCOUNT.TELEPHONE",
                    name: "telephone"
                }, {
                    show: "ACCOUNT.NOTES",
                    name: "note"
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        $scope.dataGroup = function(type) {
            $scope.gridConfig.grouping = function(item) {
                if (type == "ALL" || type == angular.uppercase(item.role.data)) {
                    return true;
                }
            }
        };

        var options = {
            proxy: {
                url: userUrl
            },
            key: "user",
            fields: [
                {
                    name: "email"
                }, {
                    name: "logined"
                }, {
                    name: "note"
                }, {
                    name: "password"
                }, {
                    name: "role"
                }, {
                    name: "session"
                }, {
                    name: "telephone"
                }, {
                    name: "username"
                }
            ],
            editor: {
                fields: [
                    {
                        name: "username",
                        allowBlank: false,
                        vtype: "accountname",
                        maxLength: 50
                    }, {
                        name: "password",
                        allowBlank: false,
                        maxLength: 50,
                        encryption: {
                            name: "hex_sha1"
                        }
                    }, {
                        name: "confirmPassword",
                        allowBlank: false,
                        maxLength: 50,
                        encryption: {
                            name: "hex_sha1"
                        }
                    }, {
                        name: "email",
                        maxLength: 50,
                        allowBlank: false,
                        vtype: "email"
                    }, {
                        name: "telephone",
                        maxLength: 30,
                        vtype: "phone_number"
                    }, {
                        name: "note"
                    }, {
                        name: "role"
                    }
                ],
                validator: function(scope) {
                    var formData = scope.form.data;
                    var psw = formData.password.inputData;
                    var confirmpsw = formData.confirmPassword.inputData;
                    if (psw !== confirmpsw) {
                        return false;
                    }
                    return true;
                }
            }
        };
        $grid.config($scope, options);

        $scope.delTipMsg = {
            title: "FORM.WARNING",
            content: "ACCOUNT.DEL_WARNING",
            okBtn: {
                handler: function() {
                    $scope.grid.selectedIndexs = [];
                }
            },
            cancelBtn: {
                show: false
            },
            size: "sm"
        };
        var delAccount = function() {
            var selfFlag = false;
            var selectedIndexs = $scope.grid.selectedIndexs
            if (selectedIndexs.length) {
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    var selectedData = $scope.grid.data[selectedIndexs[index]];
                    if (selectedData.logined.data === true && selectedData.key === $scope.curUserID) {
                        selfFlag = true;
                        break;
                    }
                }
                if (selfFlag) {
                    $scope.delTipMsg.show = true;
                } else {
                    $scope.grid.startRemove(selectedIndexs);
                }
            }
        };

        var adminOptions = [
            {
                description: "ACCOUNT.ADMINISTRATOR",
                value: "ADMIN"
            }
        ];

        var normalOptions = [
            {
                description: "ACCOUNT.ADMINISTRATOR",
                value: "ADMIN"
            }, {
                description: "ACCOUNT.MANAGER",
                value: "MANAGER"
            }, {
                description: "ACCOUNT.GUEST",
                value: "GUEST"
            }
        ];

        $scope.form.data.role.options = normalOptions;
        // $scope.form.data.password.encryption = {
        // };
        // $scope.form.data.confirmPassword.encryption = {
        // };

        function getCurFolderRole() {
            var type = $scope.information.curFolder.type;
            return type === "ALL"
                ? "MANAGER"
                : type;
        }

        var addAccount = function() {
            $scope.form.data.role.data = getCurFolderRole();
            $scope.form.data.role.options = normalOptions;
            $scope.grid.startAdd({
                "okHandlerGenerator": function(scope, msgObj) {
                    var success = function() {
                        msgObj.show = false;
                        $form.clear($scope);
                    };
                    var failure = function(err_msg) {
                        msgObj.msg_errtip = err_msg;
                        // $scope.form.data.role.data = getCurFolderRole();
                        // $scope.form.data.username.valid = false;
                    }
                    var error = angular.noop;
                    return function() {
                        // data, success, failure, error, loadData
                        scope.grid.insert({}, success, failure, error, {
                            showPrompt: false,
                            clearData: false
                        });
                    }
                }
            });
        };
        var editAccount = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                var gridData = $scope.grid.data[selectedIndexs[0]];

                var isRootAdmin = gridData.key === 1
                    ? true
                    : false;

                var isAdmin = gridData.role.data === "ADMIN"
                    ? true
                    : false;

                // if ($scope.isCurUserRootAdmin) {
                //     if (isRootAdmin) {
                //         $scope.form.data.role.options = adminOptions;
                //     } else {
                //         $scope.form.data.role.options = normalOptions;
                //     }
                // } else {
                //     if (isAdmin) {
                //         $scope.form.data.role.options = adminOptions;
                //     } else {
                //         $scope.form.data.role.options = normalOptions;
                //     }
                // }

                if (gridData.key === $scope.curUserID) {
                    $scope.form.data.role.options = adminOptions;
                } else {
                    $scope.form.data.role.options = normalOptions;
                }

                $scope.grid.startEdit(selectedIndexs[0], {
                    "okHandlerGenerator": function(scope, msgObj) {
                        var success = function() {
                            msgObj.show = false;
                            $form.clear($scope);
                        };
                        var failure = function(err_msg) {
                            msgObj.msg_errtip = err_msg;
                        }
                        var error = angular.noop;
                        return function() {
                            // data, success, failure, error, loadData
                            scope.grid.update({}, success, failure, error, undefined, {
                                showPrompt: false,
                                clearData: false
                            });
                        }
                    }
                });
            }
        };
        // toolbar setting
        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "ACCOUNT.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: editAccount
                    }, {
                        name: "ACCOUNT.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delAccount
                    }
                ]
            },
            search: true,
            others: [
                {
                    name: "ACCOUNT.ADD",
                    className: "add",
                    operate: addAccount
                }
            ]
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                })
                if (nVal.length) {
                    $toolBarSrv.setEnable($scope.toolbarConfig);
                } else {
                    $toolBarSrv.setDisable($scope.toolbarConfig);
                }
            }
        }, true);

        var MAX_LENGTH = {
            "username": 50,
            "password": 50,
            "confirmPassword": 50,
            "email": 50,
            "telephone": 30
        }
        
        $scope.$watch("form.data.username.data", function(nVal) {
            var usernameMaxLength = MAX_LENGTH["username"];
            if (nVal.length && nVal.length > usernameMaxLength) {
                $scope.form.data.username.data = nVal.slice(0, usernameMaxLength);
            }
        });

        var emailKeep;
        $scope.$watch("form.data.email.data", function(nVal) {
            var emailMaxLength = MAX_LENGTH["email"];
            if (nVal.length && nVal.length === emailMaxLength) {
                emailKeep = nVal;
            }

            if (nVal.length && nVal.length > emailMaxLength) {
                // $scope.form.data.email.data = nVal.slice(0, emailMaxLength);
                $scope.form.data.email.data = emailKeep;
            }
        });

        var phoneKeep;
        $scope.$watch("form.data.telephone.data", function(nVal) {
            var telephoneMaxLength = MAX_LENGTH["telephone"];
            if (nVal.length && nVal.length === telephoneMaxLength) {
                phoneKeep = nVal;
            }

            if (nVal.length && nVal.length > telephoneMaxLength) {
                // $scope.form.data.telephone.data = nVal.slice(0, telephoneMaxLength);
                $scope.form.data.telephone.data = phoneKeep;
            }
        });

        $scope.$watch("form.data.password.inputData", function(nVal) {
            var passwordMaxLength = MAX_LENGTH["password"];
            if (nVal && nVal.length && nVal.length > passwordMaxLength) {
                $scope.form.data.password.inputData = nVal.slice(0, passwordMaxLength);
            }

            var cfmPwd = $scope.form.data.confirmPassword.inputData;
            if (cfmPwd != "") {
                if (nVal === cfmPwd) {
                    $scope.form.data.confirmPassword.valid = true;
                    $scope.form.data.confirmPassword.validate = function() {
                        return true;
                    };
                } else {
                    $scope.form.data.confirmPassword.valid = false;
                    $scope.form.data.confirmPassword.validate = function() {
                        return false;
                    };
                    $scope.form.data.confirmPassword.validate.errorTip = $translate.instant("ACCOUNT.PASSWORD_BESAME");
                }
            }
        });

        $scope.$watch("form.data.confirmPassword.inputData", function(nVal) {
            var confirmPasswordMaxLength = MAX_LENGTH["confirmPassword"];
            if (nVal && nVal.length && nVal.length > confirmPasswordMaxLength) {
                $scope.form.data.confirmPassword.inputData = nVal.slice(0, confirmPasswordMaxLength);
            }

            var newPwd = $scope.form.data.password.inputData;
            if (newPwd === nVal) {
                $scope.form.data.confirmPassword.valid = true;
                $scope.form.data.confirmPassword.validate = function() {
                    return true;
                };
            } else {
                $scope.form.data.confirmPassword.valid = false;
                $scope.form.data.confirmPassword.validate = function() {
                    return false;
                };
                $scope.form.data.confirmPassword.validate.errorTip = $translate.instant("ACCOUNT.PASSWORD_BESAME");
            }
        });

        function getListInfo(scope, data) {
            var i,
                len,
                item;
            if (scope.information) {
                len = data.length;
                scope.information.listInfo = {
                    accountsNum: len,
                    adminNum: 0,
                    managerNum: 0,
                    guestNum: 0
                };
                for (i = 0; i < len; i++) {
                    item = data[i];
                    switch (item.role.data) {
                        case "ADMIN":
                            scope.information.listInfo.adminNum++;
                            break;
                        case "MANAGER":
                            scope.information.listInfo.managerNum++;
                            break;
                        case "GUEST":
                            scope.information.listInfo.guestNum++;
                            break;
                    }
                }
            }
        }

        function formatNum(str, num) {
            if (!str)
                return;
            var index = str.indexOf("\("),
                string;
            if (index === -1) {
                string = str + "(" + num + ")";
            } else {
                string = str.slice(0, index) + "(" + num + ")";
            }
            return string;
        }

        function updateAccounteNum(scope, data) {
            var arr,
                accounts,
                admin,
                manager,
                guest,
                listInfo;
            getListInfo(scope, data);
            if (!scope.information.accountmenu_arr || scope.information.accountmenu_arr.length === 0) {
                scope.information.accountmenu_arr = [];
                angular.forEach(angular.element(document.getElementById("account-menu")).find("span"), function(value) {
                    var $value = angular.element(value);
                    if ($value.hasClass("currentfolder")) {
                        scope.information.accountmenu_arr.push(value);
                    }
                })
            }
            arr = scope.information.accountmenu_arr;
            accounts = angular.element(arr[0]);
            admin = angular.element(arr[1]);
            manager = angular.element(arr[2]);
            guest = angular.element(arr[3]);

            listInfo = scope.information.listInfo;
            accounts.html(formatNum(accounts.html(), listInfo.accountsNum));
            admin.html(formatNum(admin.html(), listInfo.adminNum));
            manager.html(formatNum(manager.html(), listInfo.managerNum));
            guest.html(formatNum(guest.html(), listInfo.guestNum));
        }

        var updateAccounteNumId = $interval(function() {
            updateAccounteNum($scope, $scope.grid.data);
        }, 1000);

        function accountRefreshList() {
            return $interval(function() {
                accountRefresh && $proxy.request({
                    url: userUrl
                }, {
                    "REQUEST": "GET_USER_LIST"
                }, function(data) {
                    $scope.grid.loadData(data, "load", false, false);
                }, function() {});
            }, 2000);
        }
        var accountRefresh = accountRefreshList();

        $scope.$on("$destroy", function() {
            $interval.cancel(accountRefresh);
            $interval.cancel(updateAccounteNumId);
            accountRefresh = false;
        });

        $scope.$on("onSearching", function() {
            $interval.cancel(accountRefresh);
            accountRefresh = false;
        });

        $scope.$on("stopSearching", function() {
            accountRefresh = accountRefreshList();
            accountRefresh = true;
        });

        $scope.$watch("grid.data", function(nV, oV) {
            if (nV !== oV) {
                // $timeout(function() {
                updateAccounteNum($scope, nV);
                // }, 200);
            }
        });
    }
]);
