pharosModule.controllerProvider.register("device", ["$scope", "$rootScope", "$proxy", "$grid", "$url", "$form", "$interval", "$q", "$translate", "$timeout", "$infoComm", "$tool", "$toolBarSrv", "$msg",
  function($scope, $rootScope, $proxy, $grid, $url, $form, $interval, $q, $translate, $timeout, $infoComm, $tool, $toolBarSrv, $msg) {

    var deviceUrl = $url.format("/device/");
    var firmwareUrl = $url.format("/firmware/");

    var config = {
      "all": {
        columns: [{
          type: "check",
          width: 36,
          inverse: false
        }, {
          show: "DEVICE.DEVICENAME",
          name: "deviceName",
          inverse: false //can be inversed, default is true
        }, {
          show: "DEVICE.STATUS",
          name: "deviceState",
          format: function(data) {
            var _data = angular.uppercase(data);
            switch (_data) {
              case "MANAGED":
                return $translate.instant("DEVICE.STATUS_MANAGED");
              case "UNMANAGED":
                return $translate.instant("DEVICE.STATUS_UNMANAGED");
              case "CONNECTING":
                return $translate.instant("DEVICE.STATUS_CONNECTING");
              case "REBOOTING":
                return $translate.instant("DEVICE.STATUS_REBOOTING");
              case "UPGRADING":
                return $translate.instant("DEVICE.STATUS_UPGRADING");
              case "ERROR":
                return $translate.instant("DEVICE.STATUS_ERROR2");
              case "INVALID_CREDENTIAL":
                return $translate.instant("DEVICE.STATUS_INVALID_CREDENTIAL");
            }
          }
        }, {
          show: "DEVICE.MAC_ADDRESS",
          name: "macAddress",
          width: 188,
          selected: false //show or not, false === not show; true or undefined === show
        }, {
          show: "DEVICE.IP_ADDRESS",
          name: "ipAddress",
          width: 160
        }, {
          show: "DEVICE.PRODUCT",
          name: "product",
          width: 338,
          selected: false
        }, {
          show: "DEVICE.VERSION",
          name: "version",
          width: 338
        }, {
          show: "DEVICE.MODE",
          name: "wirelessMode",
          format: function(data) {
            switch (data) {
              case 0:
                return $translate.instant("DEVICE.MODE_AP");
              case 1:
                return $translate.instant("DEVICE.MODE_CLIENT");
              case 2:
                return $translate.instant("DEVICE.MODE_REPEATER");
              case 3:
                return $translate.instant("DEVICE.MODE_BRIDGE");
              case 4:
                return $translate.instant("DEVICE.MODE_AP_ROUTER");
              case 5:
                return $translate.instant("DEVICE.MODE_AP_CLIENTROUTER");
              default:
                return $translate.instant("DEVICE.N_A");
            }
          }
        }, {
          show: "DEVICE.SSID",
          name: "essid",
          width: 188,
          selected: false
        }, {
          show: "DEVICE.ROOT_AP_SSID",
          name: "rootAPEssid",
          width: 188,
          selected: false
        }, {
          show: "DEVICE.CLIENT_NUM",
          name: "clientNum",
          selected: false
        }, {
          show: "DEVICE.TRANSMIT_CCQ",
          name: "ccq",
          format: function(data) {
            if (data === -1) {
              return $translate.instant("DEVICE.N_A");
            } else {
              return data;
            }
          }
        }, {
          show: "DEVICE.SNR",
          name: "signal",
          format: function(data) {
            if (data === -1) {
              return $translate.instant("DEVICE.N_A");
            } else {
              return data;
            }
          }
        }, {
          show: "DEVICE.TX_RATE_UNIT",
          name: "txRate",
          format: function(data){
            return (data/1024).toFixed(2);
          }
        }, {
          show: "DEVICE.RX_RATE_UNIT",
          name: "rxRate",
          format: function(data){
            return (data/1024).toFixed(2);
          }
        }, {
          show: "DEVICE.TX_TOTAL",
          name: "txTotal",
          format: function(data){
            var b = 1;
            var k = b*1024;
            var m = k*1024;
            var g = m*1024;
            var _data, _str;
            if(data/g > 1){
              _str = $translate.instant("DEVICE.TX_TOTAL_UNIT_G");
              _data = (data/g).toFixed(2);
              _data += "GB";
            } else if(data/m > 1){
              _str = $translate.instant("DEVICE.TX_TOTAL_UNIT_M");
              _data = (data/m).toFixed(2);
              _data += "MB";
            } else if(data/k > 1){
              _str = $translate.instant("DEVICE.TX_TOTAL_UNIT_K");
              _data = (data/k).toFixed(2);
              _data += "KB";
            } else {
              _str = $translate.instant("DEVICE.TX_TOTAL_UNIT_B");
              _data = data;
              _data += "B";
            }
            // config["all"]["columns"][15].show = _str;
            return _data;
          },
          selected: false
        }, {
          show: "DEVICE.RX_TOTAL",
          name: "rxTotal",
          format: function(data){
            var b = 1;
            var k = b*1024;
            var m = k*1024;
            var g = m*1024;
            var _data, _str;
            if(data/g > 1){
              _str = $translate.instant("DEVICE.RX_TOTAL_UNIT_G");
              _data = (data/g).toFixed(2);
              _data += "GB";
            } else if(data/m > 1){
              _str = $translate.instant("DEVICE.RX_TOTAL_UNIT_M");
              _data = (data/m).toFixed(2);
              _data += "MB";
            } else if(data/k > 1){
              _str = $translate.instant("DEVICE.RX_TOTAL_UNIT_K");
              _data = (data/k).toFixed(2);
              _data += "KB";
            } else {
              _str = $translate.instant("DEVICE.RX_TOTAL_UNIT_B");
              _data = data;
              _data += "B";
            }
            // config["all"]["columns"][16].show = _str;
            return _data;
          },
          selected: false
        }, {
          show: "DEVICE.CPU_LOAD_UNIT",
          name: "cpuCurrent",
          format: function(data){
            return (data*100).toFixed(2);
          },
          selected: false
        }, {
          show: "DEVICE.CPU_FREQUENCY_UNIT",
          name: "cpuMax",
          selected: false
        }, {
          show: "DEVICE.MEMORY_USAGE_UNIT",
          name: "memFree",
          format: function(data){
            return (data*100).toFixed(2);
          },
          selected: false
        }, {
          show: "DEVICE.MEMORY_SIZE_UNIT",
          name: "memTotal",
          format: function(data){
            return (data/1024).toFixed(2);
          },
          selected: false
        }, {
          show: "DEVICE.DESCRIPTION",
          name: "description",
          width: 338,
          selected: false
        }],
        grouping: function(item) {
          return true;
        }
      }
    };
    $scope.deviceConfig = config["all"];

    var getHideFields = function(){
      var cookieEnable = !!(navigator && navigator.cookieEnabled);
      var hideFields = [];
      var existCookie = false;
      if(cookieEnable){
        var cookie = document.cookie;
        var cookies = cookie.split(';');
        var suffix;
        var key = "DEVICE_HIDE_FIELDS=";
        existCookie = cookies.some(function(value){
          if(suffix = value.indexOf(key) != -1){
            hideFields = value.substr(suffix + key.length).split("&amp");
            return true;
          }
          return false;
        });
        if(!existCookie){
          config["all"].columns.forEach(function(value){
            if(value.selected === false){
              hideFields.push(value.name)
            }
          });
          document.cookie = key + hideFields.join("&amp");
        }else{
          config["all"].columns.forEach(function(value){
            if(hideFields.indexOf(value.name) != -1){
              value.selected = false;
            }else{
              value.selected = true;
            }
          });
        }
      }else{
        config["all"].columns.forEach(function(value){
          if(value.selected === false){
            hideFields.push(value.name)
          }
        });
      }
      return hideFields;
    }
    $scope.deviceConfig.hideFields = getHideFields();

    $scope.deviceConfig.setHideFields = function(name, operate){
      var cookieEnable = !!(navigator && navigator.cookieEnabled);
      var hideFields = [];
      if(cookieEnable){
        var cookie = document.cookie;
        var cookies = cookie.split(';');
        var suffix;
        var key = "DEVICE_HIDE_FIELDS=";
        //find cookie
        cookies.some(function(value){
          suffix = value.indexOf(key)
          if(suffix != -1){
            str = value.substr(suffix + key.length);
            hideFields = str == "" ? [] : str.split("&amp");
            return true;
          }
          return false;
        });
        if(operate == "add"){
          if(hideFields.indexOf(name) == -1){
            hideFields.push(name);
          }
        }else{
          hideFields.splice(name, 1);
        }
        document.cookie = key + hideFields.join("&amp");
      }
    }

    $scope.dataGrouping = function(condition) {
      $scope.deviceConfig.grouping = function(item) {
        if (angular.isArray(condition)) {
          for (var index = 0, len = condition.length; index < len; index++) {
            if (condition[index] == item.key) {
              return true;
            }
          }
        } else if (angular.isObject(condition)) {
          if (filter(condition)) {
            return true;
          }
        } else if (angular.isString(condition)) {
          if (condition === "Auto") {
            var status = item.deviceState,
              foldername = $scope.information.curFolder.name;
            if (foldername.toUpperCase() == "AUTO GROUPING") return true;
            if (foldername.toUpperCase() === "MANAGED" && status.data === "MANAGED") return true;
            if (foldername.toUpperCase() === "UNMANAGED" && status.data === "UNMANAGED") return true;
          }
        } else {
          return true;
        }

        function filter(expression) {
          if (expression.type === "complex") {
            if (expression.operator === "&&") {
              return filter(expression.condition[0]) && filter(expression.condition[1]);
            } else if (expression.operator === "||") {
              return filter(expression.condition[0]) || filter(expression.condition[1]);
            }
          } else if (expression.type === "simple") {
            return handleSimpleExpression(item, expression);
          }
        }
      };
    };

    var options = {
      proxy: {
        url: deviceUrl
      },
      key: "device",
      fields: [{
        name: "ccq"
      }, {
        name: "clientNum"
      }, {
        name: "cpuCurrent"
      }, {
        name: "cpuMax"
      }, {
        name: "createDate"
      }, {
        name: "description"
      }, {
        name: "deviceName"
      }, {
        name: "deviceState"
      }, {
        name: "disconnecting"
      }, {
        name: "essid"
      }, {
        name: "host"
      }, {
        name: "ipAddrList"
      }, {
        name: "ipAddress"
      }, {
        name: "lastConnectTime"
      }, {
        name: "latitude"
      }, {
        name: "longitude"
      }, {
        name: "macAddress"
      }, {
        name: "machine_code"
      }, {
        name: "manage_protocol"
      }, {
        name: "memFree"
      }, {
        name: "memTotal"
      }, {
        name: "org_code"
      }, {
        name: "originalDeviceName"
      }, {
        name: "port_id"
      }, {
        name: "processing"
      }, {
        name: "product"
      }, {
        name: "region_code"
      }, {
        name: "rootAPEssid"
      }, {
        name: "rootAPBssid"
      }, {
        name: "rootAPBssidCached"
      }, {
        name: "rxLatency"
      }, {
        name: "rxRate"
      }, {
        name: "rxTotal"
      }, {
        name: "signal"
      }, {
        name: "sshPassword"
      }, {
        name: "sshPort"
      }, {
        name: "sshUsername"
      }, {
        name: "tmpVersion"
      }, {
        name: "txLatency"
      }, {
        name: "txRate"
      }, {
        name: "txTotal"
      }, {
        name: "upgradeCount"
      }, {
        name: "uplinkType"
      }, {
        name: "version"
      }, {
        name: "webUIPort"
      }, {
        name: "wirelessMode"
      }],
      editor: {
        fields: [{
          name: "ipAddress",
          allowBlank: false,
          vtype: "ip"
        }, {
          name: "description"
        }, {
          name: "withSshInfo"
        }, {
          name: "sshUsername",
          allowBlank: false
        }, {
          name: "sshPassword",
          allowBlank: false,
          encryption: {
            name: "noop"
          }
        }, {
          name: "sshPort",
          allowBlank: false
        }],
        validator: function(scope) {
          var data = scope.form.data,
            withSshInfo = data.withSshInfo.data,
            sshUsername, sshPassword, sshPort;
          if (withSshInfo === 1) {
            sshUsername = data.sshUsername.data;
            sshPassword = data.sshPassword.inputData;
            sshPort = data.sshPort.data;
            if (sshUsername === '' || sshPassword === '' || sshPort === '') {
              return false;
            }
          }
          return true;
        }
      }
    }
    $grid.config($scope, options);

    function handleSimpleExpression(item, expression){
      var data = item[expression.field].data;
      var value = expression.value;
      var field = expression.field;
      for ( var i = 0, len = config["all"]["columns"].length; i < len; i++ ){
        var col = config["all"]["columns"][i];
        if( col.name && col.name === field && col.format ){
            data = col.format(data);
        }

        if( field === "macAddress" ){
          data = data.split("-").join("");
          data = data.split(":").join("");
          value = value.split("-").join("");
          value = value.split(":").join("");
        }
      }

      switch (expression.comparator) {
        case "contains":
          data = (data + "").toLowerCase();
          value = (value + "").toLowerCase();
          return data.indexOf(value) == -1 ? false : true;
        case "startswith":
          data = (data + "").toLowerCase();
          value = (value + "").toLowerCase();
          return data.indexOf(value) == 0 ? true : false;
        case "=":
          data = (data + "").toLowerCase();
          value = (value + "").toLowerCase();
          return data === value;
        case "!=":
          data = (data + "").toLowerCase();
          value = (value + "").toLowerCase();
          return data !== value;
        case ">":
          if(typeof data === "number"){
            value = parseInt(value);
            return data > value;
          }
          return data > value;
        case "<":
          if(typeof data === "number"){
            value = parseInt(value);
            return data < value
          }
          return data < value;
      }
    }

    function getListInfo(scope, data) {
      var i, len, item;
      if (scope.information) {
        len = data.length;
        scope.information.listInfo = {
          totalDeviceNum: len,
          managedDeviceNum: 0,
          unmanagedDeviceNum: 0
        };
        for (i = 0; i < len; i++) {
          item = data[i];
          if (item.deviceState === "MANAGED") {
            scope.information.listInfo.managedDeviceNum++;
          } else if (item.deviceState === "UNMANAGED") {
            scope.information.listInfo.unmanagedDeviceNum++;
          }
        }
      }
    }

    function formatNum(str, num) {
      if (!str) return;
      var index = str.indexOf("\("),
        string;
      if (index === -1) {
        string = str + "(" + num + ")";
      } else {
        string = str.slice(0, index) + "(" + num + ")";
      }
      return string;
    }

    function getGroupingNum(condition) {
      function filter(expression, item) {
        if (expression.type === "complex") {
          if (expression.operator === "&&") {
            return filter(expression.condition[0], item) && filter(expression.condition[1], item);
          } else if (expression.operator === "||") {
            return filter(expression.condition[0], item) || filter(expression.condition[1], item);
          }
        } else if (expression.type === "simple") {
          return handleSimpleExpression(item, expression);
        }
      }

      var resultNum = 0;
      if (angular.isObject(condition)) {
        angular.forEach($scope.grid.data, function(item) {
          if (filter(condition, item)) {
            resultNum++;
          }
        });
      }
      return resultNum;
    }

    function updateListNumInMenu(scope, data) {
      var arr, listInfo, totalNum, managedNum, unmanagedNum;
      var all, managed, unmanaged;
      if (!scope.information || !data) return;

      getListInfo($scope, data);

      // if (!scope.information.automenu_arr || scope.information.automenu_arr.length < 4) {
        scope.information.automenu_arr = [];
        angular.forEach(angular.element(document.getElementById("device-automenu")).find("span"), function(value) {
          var $value = angular.element(value);
          if ($value.hasClass("currentfolder")) {
            scope.information.automenu_arr.push(value);
          }
        })
      // }

      arr = scope.information.automenu_arr;
      listInfo = scope.information.listInfo;
      totalNum = listInfo.totalDeviceNum;
      managedNum = listInfo.managedDeviceNum;
      unmanagedNum = listInfo.unmanagedDeviceNum;

      if (arr && arr.length) {
        all = angular.element(arr[0]);
        auto = angular.element(arr[1]);
        managed = angular.element(arr[2]);
        unmanaged = angular.element(arr[3]);
        all.html(formatNum(all.html(), totalNum));
        auto.html(formatNum(auto.html(), totalNum));
        managed.html(formatNum(managed.html(), managedNum));
        unmanaged.html(formatNum(unmanaged.html(), unmanagedNum));
        // auto grouping 添加了新规则
        if (arr.length > 4) {
          var automenuChildren = scope.childMenu.autoMenu.data.autoTree.children;
          var i = 2,
            count = arr.length - 4,
            len = automenuChildren.length,
            condition;

          for (; i < len; i++) {
            condition = automenuChildren[i].expression;
            var ele = angular.element(arr[i + 2])
            var eleNum = getGroupingNum(condition);
            ele.html(formatNum(ele.html(), eleNum));
          }

        }
      }
    }

    /* ------------------------------------------------------------------------ */
    // 2s refresh device list
    var deviceRefreshflag = true;
    function deviceRefreshList() {
      return $interval(function() {
        deviceRefreshflag && $proxy.request({
          url: deviceUrl
        }, {
          "REQUEST": "GET_DEVICE_LIST"
        }, function(data) {
          updateListNumInMenu($scope, data);

          $scope.grid.loadData(data, "load", false, false);
        }, function() {});
      }, 2000);
    }
    var deviceRefresh = deviceRefreshList();

    $scope.$on("$destroy", function() {
      $interval.cancel(deviceRefresh);
      deviceRefreshflag = false;
    });

    $scope.$on("onSearching", function() {
        $interval.cancel(deviceRefresh);
        deviceRefreshflag = false;
    });

    $scope.$on("stopSearching", function() {
      deviceRefresh = deviceRefreshList();
      deviceRefreshflag = true;
    });
    /* ------------------------------------------------------------------------ */

    // chart start
    // ---------------------------------------------------------------------------
    Chart.defaults.global.colors = ['#803690', '#00ADF9', '#250D71', '#FDB45C', '#333333', '#19951b', '#C11C66', '#bbd9cb', '#c87ac7']
    $scope.chartAttrColorHash = [];
    $scope.graphChart = {
      labels: [" ", " ", " ", " ", " ", " ", " "],
      series: ['Select'],
      data: [
        [0, 0, 0, 0, 0, 0, 0]
      ],
      onClick: function(points, evt) {
        // console.log(points, evt);
      },
      datasetOverride: [{
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }, {
        fill: false
      }],
      options: {
        animation: false,
        yAxes: [{
          ticks: {
            beginAtZero: true
          }
        }]
      }
    }

    function resetChart() {
      $scope.graphChart.series = ['Select'];
      $scope.graphChart.data = [0, 0, 0, 0, 0, 0, 0];
      $scope.chartAttrColorHash = [];
    }

    function updateChartLabels() {
      var date = new Date();
      var hour = date.getHours();
      var minutes = date.getMinutes();
      var seconds = date.getSeconds();
      hour = hour < 10 ? '0' + hour : hour;
      minutes = minutes < 10 ? '0' + minutes : minutes;
      seconds = seconds < 10 ? '0' + seconds : seconds;

      $scope.graphChart.labels.push(hour + ":" + minutes + ":" + seconds);
      $scope.graphChart.labels.shift();
    }

    function converseAttrAndData(attr, data) {
        var result = {
          "attr": attr,
          "data": data
        };

        function handleXxRate(data, type){
          var b = 1;
          var k = b*1024;
          var m = k*1024;
          var g = m*1024;
          var _data, _str;
          if(data/g > 1){
            _str = $translate.instant("DEVICE." + type + "_TOTAL_UNIT_G");
            _data = (data/g).toFixed(2);
          } else if(data/m > 1){
            _str = $translate.instant("DEVICE." + type + "_TOTAL_UNIT_M");
            _data = (data/m).toFixed(2);
          } else if(data/k > 1){
            _str = $translate.instant("DEVICE." + type + "_TOTAL_UNIT_K");
            _data = (data/k).toFixed(2);
          } else {
            _str = $translate.instant("DEVICE." + type + "_TOTAL_UNIT_B");
            _data = data;
          }
          return {
            "attr": _str,
            "data": _data
          }
        }

        switch (attr) {
            case "txRate":
                result.attr = $translate.instant("DEVICE.TX_RATE_UNIT");
                result.data = (result.data/1024).toFixed(2);
                break;
            case "rxRate":
                result.attr = $translate.instant("DEVICE.RX_RATE_UNIT");
                result.data = (result.data/1024).toFixed(2);
                break;
            case "cpuCurrent":
                result.attr = $translate.instant("DEVICE.CPU_LOAD_UNIT");
                result.data = (result.data*100).toFixed(2);
                break;
            case "memFree":
                result.attr = $translate.instant("DEVICE.MEMORY_USAGE_UNIT");
                result.data = (result.data*100).toFixed(2);
                break;
            case "clientNum":
                result.attr = $translate.instant("DEVICE.CLIENT_NUM");
                break;
            case "txTotal":
                var _r =handleXxRate(result.data, "TX");
                result.attr = _r.attr;
                result.data = _r.data;
                break;
            case "rxTotal":
                var _r =handleXxRate(result.data, "RX");
                result.attr = _r.attr;
                result.data = _r.data;
                break;
            case "signal":
                result.attr = $translate.instant("DEVICE.SNR_UNIT");
                break;
            case "ccq":
                result.attr = $translate.instant("DEVICE.TRANSMIT_CCQ");
                break;
        }
        return result;
    }

    function updateChartDatas() {
      var deviceData = $scope.grid.data[$scope.graphIndex];
      var showItem = $scope.graphOption.options[$scope.graphOption.comboIndex];

      var i = 0,
        len = showItem.attrs.length;
      var attr, attrData;

      if (!showItem || len === 0) {
        $interval.cancel($scope.btnDrawChartId);
        $scope.isChartDrawing = false;
        $scope.graphConfig.data = '';
        resetChart();
        return;
      }

      $scope.graphChart.series = [];
      $scope.chartAttrColorHash = [];
      for (; i < len; i++) {
        attr = showItem.attrs[i].attr;

        attrData = deviceData[attr].data;
        var result = converseAttrAndData(attr, attrData);
        var _attr = result.attr;
        attrData = result.data;

        $scope.graphChart.series.push(attr);
        $scope.chartAttrColorHash.push({
          'name': _attr,
          'index': i
        });

        if (!$scope.graphChart.data[i]) {
          $scope.graphChart.data[i] = [0, 0, 0, 0, 0, 0, 0];
        }
        $scope.graphChart.data[i].push(attrData);

        // for test
        // $scope.graphChart.data[i].push( Math.floor(Math.random() * 100 + 1) );

        // 顶多只显示七个点
        if ($scope.graphChart.data[i].length > 7) $scope.graphChart.data[i].shift();
      }
      $scope.graphChart.data.length = $scope.graphChart.series.length;
    }

    function drawChart() {
      $scope.btnDrawChartId = $interval(function() {
        updateChartLabels();
        updateChartDatas();
      }, 2000);
    }
    $scope.btnDrawChartId;
    $scope.isChartDrawing = false;
    $scope.btnDrawChart = function() {
      // 没有选择什么项目就点击开始
      if (!$scope.isChartDrawing && $scope.graphConfig.data === '') return;

      if ($scope.isChartDrawing) {
        $interval.cancel($scope.btnDrawChartId);
      } else {
        drawChart();
      }
      $scope.isChartDrawing = !$scope.isChartDrawing;
    }

    var deviceChart = function() {
      var selectedIndexs = $scope.grid.selectedIndexs;
      if (selectedIndexs.length === 1) {

        if (window.googleMapApiInvalid) {
          $scope.notSupportEditMsg.content = "DEVICE.NOT_SUPPORT_CHART";
          $scope.notSupportEditMsg.show = true;
        } else {
          $scope.graphIndex = selectedIndexs[0];
          // $scope.graphOption.options.length ? $scope.attrOption.data = $scope.graphOption.options[0].attrs : "";
          $proxy.request({
            url: deviceUrl
          }, {
            "REQUEST": "GET_CHART_OPTIONS",
            "DATA": {
              "deviceID": $scope.grid.data[$scope.graphIndex].key
            }
          }, function(data) {
            if(data.length){
              $scope.graphOption.options = data;
              $scope.attrOption.data = $scope.graphOption.options[0].attrs;
            }

            $scope.chartSwitch.data = 'option';
            $scope.chartMsg.show = true;
          }, function() {});
        }
      }
    }
    $scope.chartMsg = {
      title: "DEVICE.GRAPH",
      okBtn: {
        show: false
      },
      cancelBtn: {
        show: false
      }
      // size: "lg"
    };

    $scope.addChartMsg = {
      title: "DEVICE.ADDSET",
      okBtn: {
        handler: function() {
          var graphName = $scope.graphName.data;
          var attrOption = $scope.attrOption.data;
          var options = $scope.graphOption.options,
            len = options.length,
            i, item;
          if (len) {
            for (i = 0; i < len; i++) {
              item = options[i];
              if (item["name"] === graphName) {
                $scope.addChartMsg.repeatOfSetName = true;
                return;
              }
            }
          }
          if (!attrOption.length) {
            $scope.addChartMsg.noSelectedItem = true;
            return;
          }
          if (graphName !== "" && attrOption.length) {
            // var _data = angular.copy($scope.graphOption.options);
            // _data.push({
            //   "name": graphName,
            //   "attrs": attrOption
            // })
            // $proxy.request({
            //   url: deviceUrl
            // }, {
            //   "REQUEST": "EDIT_CHART_OPTIONS",
            //   "DATA": {
            //     "deviceID": $scope.grid.data[$scope.graphIndex].key,
            //     "data": _data
            //   }
            // }, function(data) {
              $scope.graphOption.options.push({
                "name": graphName,
                "attrs": attrOption
              });
              $scope.graphName.data = "";
              $scope.attrOption.data = $scope.graphOption.options[$scope.graphOption.selectedIndex].attrs;

              $scope.addChartMsg.show = false;
            // }, function() {});
          }
        }
      },
      cancelBtn: {
        handler: function() {
          $scope.graphName.data = "";
          $scope.attrOption.data = [];
          $scope.addChartMsg.show = false;
          $scope.addChartMsg.noSelectedItem = false;
          $scope.addChartMsg.repeatOfSetName = false;
        }
      },
      autoClose: false,
      repeatOfSetName: false,
      noSelectedItem: false
    };

    $scope.graphOption = {
      fields: [{
        showName: "DEVICE.ATTR_SET",
        name: "name"
      }],
      options: []
    };
    $scope.attrOption = {
      fields: [{
        showName: "DEVICE.ATTRIBUTE",
        name: "name"
      }],
      editable: true,
      options: [{
        "name": "DEVICE.TX_RATE",
        "attr": "txRate",
        "yaxis": 5
      }, {
        "name": "DEVICE.RX_RATE",
        "attr": "rxRate",
        "yaxis": 5
      }, {
        "name": "DEVICE.CPU_LOAD",
        "attr": "cpuCurrent",
        "yaxis": 4
      }, {
        "name": "DEVICE.MEMORY_USAGE",
        "attr": "memFree",
        "yaxis": 4
      }, {
        "name": "DEVICE.CLIENT_NUM",
        "attr": "clientNum",
        "yaxis": 3
      }, {
        "name": "DEVICE.TX_TOTAL",
        "attr": "txTotal",
        "yaxis": 2
      }, {
        "name": "DEVICE.RX_TOTAL",
        "attr": "rxTotal",
        "yaxis": 2
      }, {
        "name": "DEVICE.SNR",
        "attr": "signal",
        "yaxis": 1
      }, {
        "name": "DEVICE.TRANSMIT_CCQ",
        "attr": "ccq",
        "yaxis": 0
      }],
      dataFields: {
        fields: ["attr", "yaxis"],
        key: "attr"
      }
    };
    $scope.changeAttrs = function(index) {
      $scope.attrOption.data = $scope.graphOption.options[index].attrs;
    };

    $scope.graphName = {
      valid: true,
      allowBlank: false,
      data: ""
    };
    $scope.startAddOption = function() {
      $scope.graphName.data = "";
      $scope.attrOption.data = [];
      $scope.addChartMsg.show = true;
    };

    $scope.chartSwitch = {
      options: [{
        "description": "DEVICE.OPTION",
        "value": "option"
      }, {
        "description": "DEVICE.GRAPH",
        "value": "graph"
      }]
    };

    $scope.graphConfig = {
      data: ""
    };

    $scope.$watch('chartMsg.show', function(nV, oV) {
      if (nV === false) {
        $interval.cancel($scope.btnDrawChartId);
        $scope.isChartDrawing = false;

        if($scope.graphIndex == undefined){
          return;
        }

        var _data = angular.copy($scope.graphOption.options);
        var deviceID = $scope.grid.data[$scope.graphIndex].key;
        $proxy.request({
          url: deviceUrl
        }, {
          "REQUEST": "EDIT_CHART_OPTIONS",
          "DATA": {
            "deviceID": deviceID,
            "data": _data
          }
        }, function() {}, function() {});
      }
    })

    $scope.$watch("graphOption.options.length", function(nVal) {
      var options = [];
      options.push({
        name: "DEVICE.SELECT",
        value: ""
      });

      if (nVal) {
        for (var index = 0, len = nVal; index < len; index++) {
          var option = {};
          option.name = $scope.graphOption.options[index].name;
          option.value = index;

          options.push(option);
        }

        $scope.graphConfig.options = options;
      } else if (nVal === 0) {
        $scope.graphConfig.options = options;
        $interval.cancel($scope.btnDrawChartId);
        $scope.isChartDrawing = false;
        $scope.graphConfig.data = '';
        resetChart();
      }
    });

    var attrs = [];
    $scope.graphConfig.changeHandler = function(nVal) {
      if (nVal || nVal === 0) {
        var option = $scope.graphOption.options[nVal];
        attrs = option ? option.attrs : [];
        $scope.graphOption.comboIndex = nVal;

        // 热切换
        if ($scope.isChartDrawing) {
          $interval.cancel($scope.btnDrawChartId);
          resetChart();
          drawChart();
        }
      }
    };
    // ---------------------------------------------------------------------------
    // chart end

    // device operate
    $scope.live = false;
    var liveChange = function(type) {
      $scope.live = type == "live";
      if ($scope.grid.selectedIndexs.length) $scope.grid.selectedIndexs = [];
    }

    $scope.$on("switchLive", function(){
      $scope.live = false;
      $timeout(function(){
        $scope.live = true;
      }, 30);
    })

    // discovery start
    // ---------------------------------------------------------------------------
    $scope.progressBar = {
      stop: function(uuid) {
        // var request = $scope.discoveryType.data === "auto" ? "DISCOVERY_STOP" : "IPSCAN_STOP";

        if(!uuid){
          return;
        }

        if($scope.progressBar.isCompleted === true){
          $scope.discoveryMsg.show = false;
          $scope.discoveryMsg.resetStatus();
          return;
        }
        var request = "DISCOVERY_STOP";
        $proxy.request({
          url: deviceUrl
        }, {
          "REQUEST": request,
          "DATA": {
            "uuid": uuid
          }
        }, function() {
          $interval.cancel(dealDiscovery.polling);
          // $scope.discoveryMsg.show = false;
          $scope.discoveryMsg.resetStatus();
          setDiscoveryMsgTitle(false, $translate.instant("DEVICE.CANCELLED"));
        }, function() {});
      },
      progress: -1,
      progressUuid: null,
      isCompleted: false
    }

    $scope.discoveryOperate = {
      discoveryNavState: "new",
      tab: function(e, name) {
        var $ele = angular.element(e.target);
        angular.forEach($ele.parent().find("span"), function(element, index) {
          angular.element(element).removeClass("active");
        })
        $ele.addClass("active");
        $scope.discoveryOperate.discoveryNavState = name;
      }
    }

    function setDiscoveryMsgTitle(taskName, taskState){
      $scope.discoveryMsg.title = "";
      if(taskName){
        $scope.discoveryMsg.replaceTitle = [];
        $scope.discoveryMsg.replaceTitle[0] = taskName;
      }
      if(taskState){
        $scope.discoveryMsg.replaceTitle[1] = $translate.instant("DEVICE.STATUS") + ": " + taskState;
      }
    }

    var dealDiscovery = function(pollingReq, uuid) {
      // newfour
      // $scope.discoveryMsg.show = true;
      $scope.discoveryMsg.title = "DEVICE.DISCOVERY_DEVICE";
      $scope.discoveryMsg.replaceTitle = false;
      $scope.discoveryMsg.resetStatus();

      function organizDeviceList(sourceDeviceList, targetList) {
        var i = 0,
          len = sourceDeviceList.length,
          options = [];

        for (; i < len; i++) {
          options.push({
            "deviceName": sourceDeviceList[i]["deviceName"],
            "ipAddress": sourceDeviceList[i]["ipAddress"],
            "key": sourceDeviceList[i]["deviceID"]
          });
        }
        targetList.options = options;
      }

      var ipscanPollingCount = 0;
      dealDiscovery.polling = $interval(function() {
        $proxy.request({
          url: deviceUrl
        }, {
          "REQUEST": pollingReq,
          "DATA": {
            "uuid": uuid
          }
        }, function(data) {

          $scope.discoveryMsg.show = true;

          setDiscoveryMsgTitle(data.taskName, data.taskState);

          // IPSCAN_POLLING 后端没有 processing, 此处设置一个进度条的值
          $scope.progressBar.progress = pollingReq === "IPSCAN_POLLING" ? ( ipscanPollingCount === 99 ? 99 : ipscanPollingCount++) : data.processing;
          $scope.progressBar.progressUuid = data.uuid;

          if (data && data.taskJsonString) {
            var newDevicesList = data.taskJsonString.newDevicesList,
              onlineDevicesList = data.taskJsonString.existedDevicesList,
              offlineDevicesList = data.taskJsonString.failDevicesList;
            if (newDevicesList.length){
              organizDeviceList(newDevicesList, $scope.newDevice);
            } else {
              $scope.newDevice.options = [];
            }
            if (onlineDevicesList.length){
              organizDeviceList(onlineDevicesList, $scope.onlineDevice);
            } else {
              $scope.onlineDevice.options = [];
            }
            if (offlineDevicesList.length){
              organizDeviceList(offlineDevicesList, $scope.offlineDevice);
            } else {
              $scope.offlineDevice.options = [];
            }
          }

          if (angular.uppercase(data.taskState) == "COMPLETED") {
            $interval.cancel(dealDiscovery.polling);
            // $scope.discoveryMsg.resetStatus();
            $scope.progressBar.progress = 100;
            $scope.progressBar.isCompleted = true;

          }
        }, function(err_msg) {
          $interval.cancel(dealDiscovery.polling);
          $scope.discoveryMsg.resetStatus();
          //error tip
        }, function() {
          $interval.cancel(dealDiscovery.polling);
          $scope.discoveryMsg.resetStatus();
        });
      }, 1000);
      $scope.$on("$destroy", function() {
        $interval.cancel(dealDiscovery.polling);
        $scope.discoveryMsg.resetStatus();
      });
    };

    $scope.discovery = {};
    var discoveryOPtions = {
      proxy: {
        url: deviceUrl
      },
      fields: [{
        name: "range",
        allowBlank: false,
        vtype: "ip_netmask"
      }],
      autoLoad: false
    };
    $form.config($scope.discovery, discoveryOPtions);

    function showDiscoveryConfigMsg() {
      $scope.discoveryConfigMsg.msg_errtip = '';
      $scope.discoveryConfigMsg.show = true;
    }

    function hideDiscoveryConfigMsg() {
      $scope.discoveryConfigMsg.msg_errtip = '';
      $scope.discoveryConfigMsg.show = false;
    }

    $scope.discoveryConfigMsg = {
      title: "DEVICE.DISCOVERY",
      okBtn: {
        handler: function() {
          if ($scope.discoveryType.data === "auto") {
            $form.serialize($scope.discovery, ["range"]);
            $form.submit($scope.discovery, {
              "REQUEST": "DISCOVERY"
            }, function(data) {
              hideDiscoveryConfigMsg();
              dealDiscovery("DISCOVERY_POLLING", data.uuid);
            }, function(err_msg) {
              $scope.discoveryConfigMsg.msg_errtip = err_msg;
            }, function() {}, false);
          } else if ($scope.discoveryType.data === "custom") {
            $form.submit($scope.discovery, {
              "REQUEST": "IPSCAN"
            }, function(data) {
              hideDiscoveryConfigMsg();
              dealDiscovery("IPSCAN_POLLING", data.uuid);
            }, function(err_msg) {
              $scope.discoveryConfigMsg.msg_errtip = err_msg;
            }, function() {}, false);
          }
        }
      },
      cancelBtn: {
        handler: function() {
          $form.clear($scope.discovery);
          hideDiscoveryConfigMsg();
        }
      },
      autoClose: false
    };

    $scope.discoveryMsg = {
      title: "DEVICE.DISCOVERY_DEVICE",
      okBtn: {
        show: false
      },
      cancelBtn: {
        show: false
      },
      close: function() {
          $interval.cancel(dealDiscovery.polling);
          $scope.progressBar.stop($scope.progressBar.progressUuid);
          $scope.discoveryMsg.resetStatus();
      },
      resetStatus: function() {
        $scope.progressBar.progress = 0;
        $scope.progressBar.isCompleted = false;
        $scope.progressBar.progressUuid = null;
      }
    };

    $scope.$watch("discoveryType.data", function(nV, oV) {
      if (nV !== oV && nV === "auto") {
        $form.clear($scope.discovery);
        $scope.discovery.form.data.range.disabled = true;
      }
      if (nV !== oV && nV === "custom") {
        $scope.discovery.form.data.range.disabled = false;
      }
    })

    $scope.newDevice = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }],
      showIndex: true
    };
    $scope.onlineDevice = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }],
      showIndex: true
    };
    $scope.offlineDevice = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }],
      showIndex: true
    };

    $scope.discoveryType = {
      data: "auto",
      options: [{
        value: "auto",
        description: "DEVICE.DISCOVERY_AUTO"
      }, {
        value: "custom",
        description: "DEVICE.DISCOVERY_CUSTOM"
      }]
    };

    var discovery = function() {
      $scope.discoveryType.data = "auto";
      $scope.discovery.form.data.range.disabled = true;
      showDiscoveryConfigMsg();
    };

    // ---------------------------------------------------------------------------
    // discovery end

    // start/stop managing start
    // ---------------------------------------------------------------------------
    var manage = function(type) {
      var managedDevices = [];
      var unmanagedDevices = [];
      var promises = [];

      var len = $scope.grid.selectedIndexs.length;
      if (len > 0) {
        var selectedIndexs = $scope.grid.selectedIndexs;
        for (var index = 0; index < len; index++) {
          var device = $scope.grid.data[selectedIndexs[index]];
          if (angular.uppercase(device.deviceState.data) == "MANAGED") {
            if (type == "start") {
              continue;
            }
            managedDevices.push(device.key);
          } else if (angular.uppercase(device.deviceState.data) == "UNMANAGED") {
            if (type == "stop") {
              continue;
            }
            unmanagedDevices.push(device.key);
          } else {
            if (type == "start") {
              unmanagedDevices.push(device.key);
            } else {
              managedDevices.push(device.key);
            }
          }
        }

        if (managedDevices.length !== 0) {
          var startDef = $q.defer();
          promises.push(startDef.promise);
          $proxy.request({
            url: deviceUrl
          }, {
            "REQUEST": "DISCONNECT_DEVICE",
            "DATA": {
              "deviceIDList": managedDevices
            }
          }, function(data) {
            startDef.resolve(data);
          }, function() {}, function() {});
        }
        if (unmanagedDevices.length !== 0) {
          var stopDef = $q.defer();
          promises.push(stopDef.promise);
          $proxy.request({
            url: deviceUrl
          }, {
            "REQUEST": "CONNECT_DEVICE",
            "DATA": {
              "deviceIDList": unmanagedDevices
            }
          }, function(data) {
            stopDef.resolve(data);
          }, function() {}, function() {});
        }

        $q.all(promises).then(function(data) {
          for (var pIndex = 0, plen = data.length; pIndex < plen; pIndex++) {
            var resData = data[pIndex];
            if (resData) {
              for (var index = 0, len = resData.length; index < len; index++) {
                for (var sindex = 0, slen = selectedIndexs.length; sindex < slen; sindex++) {
                  if (resData[index].deviceID == $scope.grid.data[selectedIndexs[sindex]].key) {
                    $scope.grid.data[selectedIndexs[sindex]].deviceState.data = resData[index].deviceState;
                  }
                }
              }
            }
          }
        });
      }
    };
    // ---------------------------------------------------------------------------
    // start/stop managing end

    // reboot start
    // ---------------------------------------------------------------------------
    // reboot device ---->change to submit
    $scope.rebootMsg = {
      title: "DEVICE.REBOOT_CONFIRM",
      okBtn: {
        handler: function() {
          if ($scope.rebootDevice.data.length !== 0) {
            for (var index = 0, len = $scope.rebootDevice.data.length; index < len; index++) {
              var item = $scope.grid.keyToIndex.indexOf($scope.rebootDevice.data[index]);
              if (item !== -1) {
                // $scope.grid.data[item].deviceState.data = "rebooting";
              }
            }
            var completedDeviceLen = 0,
              failedDeviceLen = 0;
            $proxy.request({
              url: deviceUrl
            }, {
              "REQUEST": "REBOOT_DEVICE",
              "DATA": {
                "deviceIDList": $scope.rebootDevice.data
              }
            }, function(data) {
              $scope.rebootDevice.data = [];
              if (data && data.uuid) {
                var polling = $interval(function() {
                  $proxy.request({
                    url: deviceUrl
                  }, {
                    "REQUEST": "REBOOT_DEVICE_POLLING",
                    "DATA": {
                      "uuid": data.uuid
                    }
                  }, function(data) {
                    if (data && angular.uppercase(data.taskState) === "COMPLETED") {
                      $interval.cancel(polling);
                      // deal with failed devices
                    }
                    if (completedDeviceLen !== data.completedDeviceList.length) {
                      for (var index = 0, len = data.completedDeviceList.length; index < len; index++) {
                        var item = $scope.grid.keyToIndex.indexOf(data.completedDeviceList[index]);
                        if (item !== -1) {
                          $scope.grid.data[item].deviceState.data = "MANAGED";
                        }
                      }
                      completedDeviceLen = data.completedDeviceList.length;
                    }
                    if (failedDeviceLen !== data.failedDeviceList.length) {
                      for (var index = 0, len = data.failedDeviceList.length; index < len; index++) {
                        var item = $scope.grid.keyToIndex.indexOf(data.failedDeviceList[index]);
                        if (item !== -1) {
                          $scope.grid.data[item].deviceState.data = "ERROR";
                        }
                      }
                      failedDeviceLen = data.failedDeviceList.length;
                    }
                  }, function() {
                    $interval.cancel(polling);
                    // error tips
                  }, function() {
                    $interval.cancel(polling);
                    // error tips
                  });
                }, 1000);
                $scope.$on("$destroy", function() {
                  $interval.cancel(polling);
                });
              }

              $scope.rebootMsg.show = false;
              $scope.rebootMsg.msg_errtip = '';
            }, function(err_msg) {
              $scope.rebootDevice.data = [];
              $scope.rebootMsg.msg_errtip = err_msg;
            }, function() {});
          }
        }
      },
      cancelBtn: {
        handler: function() {
          $scope.rebootDevice.data = [];
          $scope.rebootMsg.msg_errtip = '';
          $scope.rebootMsg.show = false;
        }
      },
      autoClose: false
    };

    $scope.rebootDevice = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }],
      editable: true
    }
    var reboot = function() {
      var options = [];
      var selectedIndexs = $scope.grid.selectedIndexs;
      if (selectedIndexs.length !== 0) {
        for (var index = 0, len = selectedIndexs.length; index < len; index++) {
          var selectedData = $scope.grid.data[selectedIndexs[index]];
          if (angular.uppercase(selectedData.deviceState.data) === "MANAGED") {
            var option = {};
            /*var fields = $scope.rebootDevice.fields
            for(var findex = 0,flen = fields.length; findex < flen; findex++){
            	options[fields[findex].name] =  selectedData[fields[findex].name].data;
            }*/
            option["deviceName"] = selectedData["deviceName"].data;
            option["ipAddress"] = selectedData["ipAddress"].data;
            option.key = selectedData.key;
            options.push(option);
          }
        }
        $scope.rebootDevice.options = options;
        $scope.rebootMsg.show = true;
      }
    };

    // ---------------------------------------------------------------------------
    // reboot end


    // upgrade start
    // ---------------------------------------------------------------------------
    // upgrade device ---> change to submit
    $scope.upgradeMsg = {
      title: "DEVICE.UPGRADE_CONFIRM",
      okBtn: {
        handler: function() {
          if ($scope.upgradeDevice.data.length !== 0) {
            for (var index = 0, len = $scope.upgradeDevice.data; index < len; index++) {
              var item = $scope.grid.keyToIndex.indexOf($scope.upgradeDevice.data[index]);
              if (item !== -1) {
                $scope.grid.data[item].deviceState.data = "upgrading";
              }
            }

            var completedDeviceLen = 0,
              failedDeviceLen = 0;
            $proxy.request({
              url: deviceUrl
            }, {
              "REQUEST": "UPGRADE_DEVICE",
              "DATA": {
                "upgradePairList": $scope.upgradeDevice.data
              }
            }, function(data) {
              $scope.upgradeDevice.data = [];
              if (data && data.uuid) {
                var polling = $interval(function() {
                  $proxy.request({
                    url: deviceUrl
                  }, {
                    "REQUEST": "UPGRADE_DEVICE_POLLING",
                    "DATA": {
                      "uuid": data.uuid
                    }
                  }, function(data) {
                    if (data && angular.uppercase(data.taskState) === "COMPLETED") {
                      $interval.cancel(polling);
                    }
                    if (completedDeviceLen !== data.completedDeviceList.length) {
                      for (var index = 0, len = data.completedDeviceList.length; index < len; index++) {
                        var item = $scope.grid.keyToIndex.indexOf(data.completedDeviceList[index]);
                        if (item !== -1) {
                          $scope.grid.data[item].deviceState.data = "MANAGED";
                        }
                      }
                      completedDeviceLen = data.completedDeviceList.length;
                    }
                    if (failedDeviceLen !== data.failedDeviceList.length) {
                      for (var index = 0, len = data.failedDeviceList.length; index < len; index++) {
                        var item = $scope.grid.keyToIndex.indexOf(data.failedDeviceList[index]);
                        if (item !== -1) {
                          $scope.grid.data[item].deviceState.data = "ERROR";
                        }
                      }
                      failedDeviceLen = data.failedDeviceList.length;
                    }
                  }, function() {
                    $interval.cancel(polling);
                  }, function() {
                    $interval.cancel(polling);
                  });
                }, 1000);
                $scope.$on("$destroy", function() {
                  $interval.cancel(polling);
                });
              }
              $scope.upgradeMsg.show = false;
              $scope.upgradeMsg.msg_errtip = '';
            }, function(err_msg) {
              $scope.upgradeDevice.data = [];
              $scope.upgradeMsg.msg_errtip = err_msg;
            }, function() {});
          }
        }
      },
      cancelBtn: {
        handler: function() {
          $scope.upgradeDevice.data = [];
          $scope.upgradeMsg.show = false;
          $scope.upgradeMsg.msg_errtip = '';
        }
      },
      autoClose: false
    };

    $scope.upgradeDevice = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName",
        inputCls: "col-11"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress",
        inputCls: "col-10"
      }, {
        showName: "DEVICE.FIRMWARE",
        name: "firmwareID",
        type: "comboField",
        inputCls: "xxl"
      }],
      dataFields: {
        fields: ["deviceID", "firmwareID"],
        key: "deviceID",
        allowBlank: false
      },
      editable: true
    };
    var upgrade = function() {
      var options = [];
      var selectedIndexs = $scope.grid.selectedIndexs;
      if (selectedIndexs.length !== 0) {
        firmwareDef = $q.defer();
        $proxy.request({
          url: firmwareUrl
        }, {
          "REQUEST": "GET_FIRMWARE_LIST"
        }, function(data) {
          firmwareDef.resolve(data);
        }, function() {
          firmwareDef.resolve("failed");
        }, function() {
          firmwareDef.resolve("error");
        });
        firmwareDef.promise.then(function(data) {
          for (var index = 0, len = selectedIndexs.length; index < len; index++) {
            var selectedData = $scope.grid.data[selectedIndexs[index]];
            if (angular.uppercase(selectedData.deviceState.data === "MANAGED")) {
              var firmwareID = {};
              var firmwareOptions = [];
              if (data && data !== "error" && data !== "failed") {
                var defaultData = "";
                var product = selectedData.product.data;
                var version = selectedData.version.data;
                for (var findex = 0, flen = data.length; findex < flen; findex++) {
                  var firmwareDevices = data[findex].description.split(";");
                  firmwareDevices.pop();
                  if (firmwareDevices.indexOf(product) !== -1 && data[findex].isActive) {
                    var firmwareOption = {};
                    firmwareOption.name = data[findex].firmwareFileName;
                    firmwareOption.value = data[findex].firmwareID;

                    if (data[findex].version + " Build " + data[findex].buildDate === version) {
                      firmwareOption.name += $translate.instant("DEVICE.INUSE");
                      defaultData = firmwareOption.value;
                    }
                    firmwareOptions.push(firmwareOption);
                  }
                }
                firmwareID.options = firmwareOptions;
                firmwareID.data = defaultData ? defaultData : firmwareOptions.length !== 0 ? firmwareOptions[0].value : "";

                for (var uIndex = 0, ulen = $scope.upgradeDevice.options.length; uIndex < ulen; uIndex++) {
                  if ($scope.upgradeDevice.options[uIndex]["deviceID"] == selectedData.key) {
                    $scope.upgradeDevice.options[uIndex]["firmwareID"] = firmwareID;
                    if (!firmwareID.data) {
                      $scope.upgradeDevice.data.splice(uIndex, 1);
                    }
                    (function(uIndex, firmwareID) {
                      $scope.upgradeDevice.options[uIndex]["firmwareID"].changeHandler = function(nVal) {
                        for (var index = 0, len = $scope.upgradeDevice.data.length; index < len; index++) {
                          if ($scope.upgradeDevice.options[uIndex].deviceID == $scope.upgradeDevice.data[index].deviceID) {
                            break;
                          }
                        }
                        if (index < len) {
                          $scope.upgradeDevice.data[index]["firmwareID"] = nVal;
                        }
                      }
                    })(uIndex, firmwareID);
                    break;
                  }
                }
              }
            }
          }
        });

        for (var index = 0, len = selectedIndexs.length; index < len; index++) {
          var selectedData = $scope.grid.data[selectedIndexs[index]];
          if (angular.uppercase(selectedData.deviceState.data === "MANAGED")) {
            var option = {};
            option["deviceName"] = selectedData["deviceName"].data;
            option["ipAddress"] = selectedData["ipAddress"].data;
            option["deviceID"] = selectedData.key;
            options.push(option);
          }
        }
        $scope.upgradeDevice.options = options;
        $scope.upgradeMsg.show = true;
      }
    };

    // ---------------------------------------------------------------------------
    // upgrade end

    // ping start
    // ---------------------------------------------------------------------------
    // ping device
    $scope.pingForm = {};
    var pingOPtions = {
      proxy: {
        url: deviceUrl
      },
      fields: [{
        name: "count",
        vtype: "number"
      }, {
        name: "timeout",
      }, {
        name: "deviceIDList"
      }],
      autoLoad: false
    };
    $form.config($scope.pingForm, pingOPtions);
    $scope.pingForm.form.data.deviceIDList = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }, {
        showName: "DEVICE.STATUS",
        name: "pingStatus"
      }],
      editable: false,
      showIndex: true
    };

    $scope.pingConfigMsg = {
      title: "DEVICE.PING_CONFIRM",
      okBtn: {
        show: false
      },
      cancelBtn: {
        show: false
      },
      autoClose: false
    };

    var pingPolling;
    $scope.isPingPolling = false;
    $scope.startPing = function() {
      if ($scope.isPingPolling) return;
      var data = [];
      for (var i = 0, len = $scope.grid.selectedIndexs.length; i < len; i++) {
        var index = $scope.grid.selectedIndexs[i];
        data.push($scope.grid.data[index].key);
      }
      $scope.pingForm.form.data.deviceIDList.data = data;

      var timeout = $scope.pingForm.form.data.timeout.data;
      var count = $scope.pingForm.form.data.count.data;
      var deviceIDList = data;

      $proxy.request({
        url: deviceUrl
      }, {
        "REQUEST": "PING",
        "DATA": {
          "timeout": timeout,
          "count": count,
          "deviceIDList": deviceIDList
        }
      }, function(data) {
        $scope.pingConfigMsg.msg_errtip = '';

        if (data && data.uuid) {
          pingPolling = $interval(function() {
            $proxy.request({
              url: deviceUrl
            }, {
              "REQUEST": "PING_POLLING",
              "DATA": {
                uuid: data.uuid
              }
            }, function(data) {
              $scope.pingConfigMsg.msg_errtip = '';

              var i = 0,
                ilen = $scope.pingForm.form.data.deviceIDList.options.length;
              var j = 0,
                jlen = data.pingPairList.length;
              for (i = 0; i < ilen; i++) {
                for (j = 0; j < jlen; j++) {
                  if (data.pingPairList[j].deviceID === $scope.pingForm.form.data.deviceIDList.options[i].key) {
                    var sent = data.pingPairList[j].sent;
                    var received = data.pingPairList[j].received;
                    var loss = data.pingPairList[j].loss;
                    var avg = data.pingPairList[j].rtt;
                    sent = "Sent = " + sent;
                    received = ", Received = " + received;
                    loss = loss === 'N/A' ? ", Loss = " + loss : ", Loss = " + loss + "%";
                    avg = avg === 'N/A' ? ", Avg = " + avg : ", Avg = " + avg + "ms";
                    var pingStatus = sent + received + loss + avg;
                    $scope.pingForm.form.data.deviceIDList.options[i]["pingStatus"] = pingStatus;
                  }
                }
              }
              if (data && angular.uppercase(data.taskState) === "COMPLETED") {
                $interval.cancel(pingPolling);
                $scope.isPingPolling = false;
              }
            }, function(err_msg) {
              $scope.pingConfigMsg.msg_errtip = err_msg;
              $interval.cancel(pingPolling);
              $scope.isPingPolling = false;
            }, function() {
              $interval.cancel(pingPolling);
              $scope.isPingPolling = false;
            });
          }, 2000);
          $scope.isPingPolling = true;
        }
      }, function(err_msg) {
        $scope.pingConfigMsg.msg_errtip = err_msg;
      })
    };
    $scope.$on("$destroy", function() {
      $interval.cancel(pingPolling);
      $scope.isPingPolling = false;
    });
    $scope.$watch("pingConfigMsg.show", function(nV, oV) {
      if (nV !== oV && nV === false) {
        $interval.cancel(pingPolling);
        $scope.pingConfigMsg.msg_errtip = '';
        $scope.isPingPolling = false;
        $form.clear($scope.pingForm);
      }
    });

    // $scope.pingMsg = {
    // 	okBtn:{
    // 		show: false
    // 	},
    // 	cancelBtn:{
    // 		show: false
    // 	}
    // };
    $scope.pingResult = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }]
    };
    var pingDevice = function() {
      var options = [];
      var selectedIndexs = $scope.grid.selectedIndexs;
      if (selectedIndexs.length !== 0) {
        for (var index = 0, len = selectedIndexs.length; index < len; index++) {
          var selectedData = $scope.grid.data[selectedIndexs[index]];
          var option = {};
          option["deviceName"] = selectedData["deviceName"].data;
          option["ipAddress"] = selectedData["ipAddress"].data;
          option["pingStatus"] = "Sent =  ,Received =  ,Loss =  , Avg =  ";
          option.key = selectedData.key;
          options.push(option);
        }
        $scope.pingForm.form.data.deviceIDList.options = options;
        $scope.pingForm.form.data.count.data = 4;
        $scope.pingForm.form.data.timeout.data = 1;
        $scope.pingConfigMsg.show = true;
      }
    };

    // ---------------------------------------------------------------------------
    // ping end

    // for ie
    $scope.form.data.withSshInfo.changeHandler = function(nVal) {
      var fields = ["sshUsername", "sshPassword", "sshPort"];
      if (nVal == 0) {
        for (var index = 0, len = fields.length; index < len; index++) {
          $scope.form.data[fields[index]].disabled = true;
        }
      } else if (nVal == 1) {
        for (var index = 0, len = fields.length; index < len; index++) {
          $scope.form.data[fields[index]].disabled = false;
        }
      }
    };


    // add device
    var addDevice = function() {
      $scope.form.data.withSshInfo.data = 0;
      $scope.form.data.sshPassword.inputData = '';
      $scope.grid.startAdd();
    };


    // edit start
    // ---------------------------------------------------------------------------
    // edit device
    $scope.editDevicAddonBtn = {
      name: "DEVICE.START_MANAGE",
      handler: function(editMsg) {
        // 先 edit device 然后再对 unmanaged 设备进行 start managing 操作
        var i, len = $scope.grid.selectedIndexs.length;
        var data = [];
        for (i = 0; i < len; i++) {
          var item = $scope.grid.data[$scope.grid.selectedIndexs[i]];
          if (angular.uppercase(item.deviceState.data) === "UNMANAGED" ||
            item.deviceState.data === "INVALID_CREDENTIAL" ||
            item.deviceState.data === "ERROR") {
            data.push(item.key);
          }
        }

        function connectDevice() {
          $proxy.request({
            url: deviceUrl
          }, {
            "REQUEST": "CONNECT_DEVICE",
            "DATA": {
              "deviceIDList": data
            }
          });
          editMsg.show = false;
        }

        // len > 1 的话表明此时打开的是 editManageMsg 这个弹窗
        if (len === 1) {
          $scope.grid.update({}, function() {
            connectDevice();
          }, function() {}, function() {});
        } else if ($scope.editManageMsg.show) {
          $form.serialize($scope, ["ipAddress", "description", "withSshInfo"]);
          $form.submit($scope, {
            "REQUEST": "EDIT_DEVICE_LOGIN_CREDENTIAL",
            "DATA": {
              "deviceIDList": data
            }
          }, function(data, other) {
            $scope.grid.loadData($scope.form, "update", true);
            connectDevice();
          }, function() {}, function() {});
        }
      }
    }
    var editLoginKeys = [];
    $scope.editManageMsg = {
      title: "DEVICE.EDIT_MANAGING",
      okBtn: {
        handler: function() {
          $form.serialize($scope, ["ipAddress", "description", "withSshInfo"]);
          $form.submit($scope, {
            "REQUEST": "EDIT_DEVICE_LOGIN_CREDENTIAL",
            "DATA": {
              "deviceIDList": editLoginKeys
            }
          }, function(data, other) {
            // update grid
            $scope.grid.loadData($scope.form, "update", true);
            $scope.editManageMsg.show = false;
          }, function(err_msg) {}, function() {});
        }
      },
      cancelBtn: {
        handler: function() {
          $scope.grid.cancelEdit();
          $scope.editManageMsg.show = false;
        }
      },
      autoClose: false
    };
    var editDevice = function() {
      var selectedIndexs = $scope.grid.selectedIndexs;
      var len = selectedIndexs.length;
      if (len > 0 && !$scope.live) {
        // 编辑单个设备
        if (len === 1) {
          var singleData = $scope.grid.data[selectedIndexs[0]];
          // 单个 managed 设备
          if (singleData.deviceState.data === "MANAGED") {
            // tmpVersion >= 2 时设备支持编辑无线参数
            if ($scope.grid.data[selectedIndexs[0]].tmpVersion.data < 2) {
              $scope.notSupportEditMsg.content = "DEVICE.NOT_SUPPORT_EDIT_WIRELESS";
              $scope.notSupportEditMsg.show = true;
            } else {
              $scope.grid.startEdit(selectedIndexs[0], false);
              $scope.editDeviceWireless();
            }
            // 单个 unmanaged 设备
          } else if (singleData.deviceState.data === "UNMANAGED" ||
            singleData.deviceState.data === "INVALID_CREDENTIAL" ||
            singleData.deviceState.data === "ERROR") {
            $scope.grid.startEdit($scope.grid.selectedIndexs[0]);
            $scope.form.data.withSshInfo.data = 0;
          }
          // 编辑多个设备
        } else {
          editLoginKeys = [];
          var managedArr = [];
          var unmanagedArr = [];
          for (var index = 0; index < len; index++) {
            var iData = $scope.grid.data[selectedIndexs[index]];
            if (iData.deviceState.data === "UNMANAGED" ||
              iData.deviceState.data === "INVALID_CREDENTIAL" ||
              iData.deviceState.data === "ERROR") {
              unmanagedArr.push($scope.grid.data[selectedIndexs[index]].key);
            } else if (iData.deviceState.data === "MANAGED") {
              managedArr.push($scope.grid.data[selectedIndexs[index]].key);
            }
          }
          // 多个设备中至少有一个 unmanaged 设备
          if (unmanagedArr.length) {
            editLoginKeys = unmanagedArr;
            $scope.grid.startEdit($scope.grid.selectedIndexs[0], false, $scope.form);
            $scope.form.data.withSshInfo.data = 1;
            $scope.editManageMsg.addonBtn = $scope.editDevicAddonBtn;
            $scope.editManageMsg.show = true;
          } else {
            $scope.notSupportEditMsg.content = "DEVICE.EDIT_MANAGED_MULTIDEVICE_NOTE";
            $scope.notSupportEditMsg.show = true;
          }
        }
      } else if (len > 0 && $scope.live) {
        $scope.$broadcast("liveEditing", {
          len: len,
          selectedIndexs: selectedIndexs
        });
      }
    };
    // ---------------------------------------------------------------------------
    // edit end

    // delete device
    var delDevice = function() {
      var selectedIndexs = $scope.grid.selectedIndexs;
      if (selectedIndexs.length) {
        $scope.grid.startRemove(selectedIndexs, {
            "okHandlerGenerator": function(scope, msgObj, formData) {
                var successPrompt = $msg.create({
                  type: "success",
                  text: "FORM.SUCCESS"
                });
                var failurePrompt = $msg.create({
                  type: "failure",
                  text: "FORM.FAILED"
                });

                var success = function() {
                    msgObj.show = false;
                    successPrompt.show();
                    $rootScope.$broadcast("ev_device_removed", formData.deviceIDList);
                };
                var failure = function(err_msg) {
                    msgObj.show = false;
                    failurePrompt.show();
                }
                var error = angular.noop;
                return function() {
                    $scope.grid.remove({
      								"DATA": formData
      							}, success, failure, error);
                }
            }
        });
      }
    };

    // not support edit wireless
    $scope.notSupportEditMsg = {
      title: "FORM.WARNING",
      content: "DEVICE.NOT_SUPPORT_EDIT_WIRELESS",
      okBtn: {
        handler: function() {}
      },
      cancelBtn: {
        show: false
      }
    }

    /* ------------------------------------------------------------------------ */
    // location msgbox for google map
    $scope.locationMsg = {
      title: "FORM.WARNING",
      content: "FORM.LOCATION_ONLY",
      okBtn: {
        handler: function() {}
      },
      cancelBtn: {
        show: false
      }
    };
    var location = function() {
        var selectedIndexs = $scope.grid.selectedIndexs;
        var deviceIDList = [],
          item;

        if (!selectedIndexs.length) return;

        for (var i = 0, len = selectedIndexs.length; i < len; i++) {
          deviceIDList.push($scope.grid.data[selectedIndexs[i]].key);
        }

        if (!$scope.live) {
          $scope.locationMsg.show = true;
        } else {
          $scope.$broadcast('location', {
            selectedIndexs: selectedIndexs,
            deviceIDList: deviceIDList
          });
        }
      }
      /* ------------------------------------------------------------------------ */

    // toolbar setting
    $scope.toolbarConfig = {
      operator: {
        show: [{
            name: "DEVICE.DELETE",
            className: "delete",
            isDisabled: "disable",
            operate: delDevice
          }, {
            name: "DEVICE.EDIT",
            className: "edit",
            isDisabled: "disable",
            operate: editDevice
          }, {
            name: "DEVICE.UPGRADE",
            className: "upgrade",
            isDisabled: "disable",
            operate: upgrade
          }, {
            name: "DEVICE.REBOOT",
            className: "reboot",
            isDisabled: "disable",
            operate: reboot
          }, {
            name: "DEVICE.GRAPH",
            className: "chart",
            isDisabled: "disable",
            operate: deviceChart
          }
          /*,
          				{
          					name: "DEVICE.LOCATION",
          					className: "location",
          					isDisabled: "disable",
          					operate: location
          				}*/
        ],
        more: [{
          moreText: "DEVICE.MORE",
          name: "DEVICE.OPEN_WEB_UI",
          className: "more",
          type: "link",
          href: "",
          operate: function() {
            var i, len = $scope.grid.selectedIndexs.length;
            if (len !== 0) {
              for (i = 0; i < len; i++) {
                // this.href = "http://" + $scope.grid.data[$scope.grid.selectedIndexs[i]].ipAddress.data;
                window.open("http://" + $scope.grid.data[$scope.grid.selectedIndexs[i]].ipAddress.data);
              }
            }
          }
        }, {
          name: "DEVICE.PING",
          className: "ping",
          operate: pingDevice
        }, {
          name: "DEVICE.START_MANAGE",
          className: "manage('start')",
          operate: function() {
            manage('start');
          }
        }, {
          name: "DEVICE.STOP_MANAGE",
          className: "manage('stop')",
          operate: function() {
            manage('stop');
          }
        }, {
          name: "DEVICE.ADD_TO_GROUP",
          type: "expander",
          operate: function() {},
          slidehandle: function(groupObj) {
            if ($scope.grid.selectedIndexs && $scope.grid.selectedIndexs.length) {
              $infoComm.addToGroup($scope.childMenu, "device", groupObj, function(data) {
                initMenuHandle($scope.childMenu, data);
              });
              $scope.grid.selectedIndexs = [];
            } else {
              $scope.warningMsg.show = true;
            }
          },
          slider_holder: "grouping",
          slide: []
        }, {
          name: "DEVICE.REMOVE_FROM_GROUP",
          operate: function() {
            if ($scope.grid.selectedIndexs && $scope.grid.selectedIndexs.length) {
              $infoComm.removeFromGroup($scope.childMenu, "device", function(data) {
                initMenuHandle($scope.childMenu, data);
              });
              $scope.grid.selectedIndexs = [];
            } else {
              $scope.warningMsg.show = true;
            }
          }
        }]
      },
      live: liveChange,
      search: true,
      others: [{
        name: "DEVICE.DISCOVERY",
        className: "discovery",
        operate: discovery
      }, {
        name: "DEVICE.ADD",
        className: "add",
        operate: addDevice
      }]
    };

    $scope.toolbarConfig.operator.more.isDisabled = "disable";

    function initMenuHandle($scope, data) {
      if (data.autoTree) {
        data.autoTree.rde = "1-0-0";
        $scope.autoMenu.data = {
          autoTree: data.autoTree
        };
      };
      if (data.manualTree) {
        data.manualTree.rde = "1-0-0";
        data.manualTree.deviceIDList = genDeviceIDListPro(data.manualTree);
        $scope.manualMenu.data = {
          manualTree: data.manualTree
        };
      };
      $infoComm.updateSlideGroup($scope, "manual");
    }

    function genDeviceIDListPro(manualTree) {
        var children = manualTree.children;
        var deviceIDList = [];
        if (children && children.length) {
            var i = 0;
            var len = children.length;
            for (; i < len; i++) {
                deviceIDList = deviceIDList.concat(children[i].deviceIDList);
            }
            $tool.uniqueArr(deviceIDList);
        }
        return deviceIDList;
    }

    $scope.information = {};

    $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
      if (nVal !== oVal) {
        nVal.sort(function(a, b) {
          return a - b
        })
        if (nVal.length) {
          $toolBarSrv.setEnable($scope.toolbarConfig);
        } else {
          $toolBarSrv.setDisable($scope.toolbarConfig);
        }

        if (nVal.length === 1) {
          // chart
          $scope.toolbarConfig.operator.show[4].isDisabled = "enable";
        } else if (nVal.length > 1) {
          // chart
          $scope.toolbarConfig.operator.show[4].isDisabled = "disable";
        }
      }
    }, true);

    $scope.$watch("live", function(nV, oV) {
      if (nV !== oV) {
        // 处于 list 状态时不显示 location 按钮
        if (nV === true) {
          $scope.toolbarConfig.operator.show.push({
            name: "DEVICE.LOCATION",
            className: "location",
            isDisabled: "disable",
            operate: location
          });
        } else {
          var len = $scope.toolbarConfig.operator.show.length;
          if ($scope.toolbarConfig.operator.show[len - 1].className === 'location') {
            $scope.toolbarConfig.operator.show.length--;
          }

          getServerLocation();
        }
      }
    });

    $scope.gridItemInfo = {};
    $scope.gridItemInfoConfig = config["all"]["columns"].slice(1);

    $scope.$on("showGridItemInfo", function(e, data) {
      var gridData = $scope.grid.data[data.index];
      var i, len = $scope.gridItemInfoConfig.length,
        item;
      var middle = Math.floor((len + 1) / 2);
      var _data;

      $scope.gridItemInfoLeft = $scope.gridItemInfoConfig.slice(0, middle);
      $scope.gridItemInfoRight = $scope.gridItemInfoConfig.slice(middle);
      for (i = 0; i < middle; i++) {
        item = $scope.gridItemInfoConfig[i];
        _data = gridData[item.name].data;
        if (item.format) _data = item.format(_data);
        $scope.gridItemInfoLeft[item.name] = {
          data: _data
        };
      }
      for (i = middle; i < len; i++) {
        item = $scope.gridItemInfoConfig[i];
        _data = gridData[item.name].data;
        if (item.format) _data = item.format(_data);
        $scope.gridItemInfoRight[item.name] = {
          data: _data
        };
      }
      $scope.dbclickInfo = {
        title: gridData.deviceName.data,
        okBtn: {
          show: false
        },
        cancelBtn: {
          show: false
        },
        autoclose: false,
        backdropClose: true
      };
      $scope.dbclickInfo.show = true;
    });

    $scope.$watch("dbclickInfo.show", function(nV, oV) {
      if (nV !== oV && nV === false) {
        $scope.gridItemInfo = {};
      }
    });

    /* ------------------------------------------- */
    $scope.serverLocation = null;

    function getServerLocation() {
      $proxy.request({
        url: $url.format("/misc/")
      }, {
        "REQUEST": "GET_SERVER_LOCATION"
      }, function(data) {
        $scope.serverLocation = {
          longitude: data.longitude,
          latitude: data.latitude
        };
      });
    }
    getServerLocation();
    /* ------------------------------------------- */
  }
]);

pharosModule.controllerProvider.register("deviceMenu", ["$scope", "$q", "$url", "$proxy", "$tool", '$infoComm', '$timeout', "$translate",
  function($scope, $q, $url, $proxy, $tool, $infoComm, $timeout, $translate) {
    var deviceUrl = $url.format("/device/");
    $scope.$parent.childMenu = $scope;
    function successHandler(responseData, requestData, uuid) {
      var treeName = requestData.autoTree ? "autoTree" : "manualTree";
      var operateName = requestData["new"] ? "new" : requestData["deleted"] ? "deleted" : "modified";
      var item;

      function deleteHandle(treeType, item) {
        var data = $scope[treeType + "Menu"].data[treeType + 'Tree'];
        var i,
          children = data.children,
          len = children.length;
        for (i = 0; i < len; i++) {
          if (item.uuid === children[i].uuid) {
            data.children.splice(i, 1);
            break;
          }
        }
        $timeout(function() {
          var treeNodeArr = $scope.information.treeNodeArrays[$scope.information.curScope];
          treeNodeArr[$scope.information.curTreeNodeIndex - 1].click();
          // 对于 manual
          if ($scope.information.curTreeNodeIndex === 0) {
            $scope.information.treeNodeArrays[$scope.information.curScope][$scope.information.curTreeNodeIndex].click();
          }
        }, 0);
      }

      if (treeName === "autoTree") {
        switch (operateName) {
          case "new":
            item = requestData["new"][0];
            item.isLeaf = "true";
            $scope.autoMenu.data.autoTree.children.push(item);
            break;
          case "deleted":
            item = requestData["deleted"][0];
            deleteHandle("auto", item);
            break;
          case "modified":
            item = requestData["modified"][0];
            $scope.information.curFolder.name = item.name;
            $scope.information.curFolder.expression = item.expression;

            $timeout(function() {
              var treeNodeArr = $scope.information.treeNodeArrays[$scope.information.curScope];
              treeNodeArr[$scope.information.curTreeNodeIndex].click();
            }, 200);
            break;
        }
      } else if (treeName === "manualTree") {
        switch (operateName) {
          case "new":
            item = requestData["new"][0];
            item.isLeaf = "true";
            $scope.manualMenu.data.manualTree.children.push(item);
            break;
          case "deleted":
            item = requestData["deleted"][0];
            deleteHandle("manual", item);
            break;
          case "modified":
            item = requestData["modified"][0];
            $scope.information.curFolder.name = item.name;
            $scope.information.curFolder.deviceIDList = item.deviceIDList;
            break;
        }
      };
      $infoComm.updateSlideGroup($scope, "manual");
    }
    $scope.autoMenuConfig = {
      proxy: {
        url: deviceUrl
      },
      editable: true,
      group: "DEVICE.ALLDEVICE",
      editor: {
        fields: [{
          name: "name",
          allowBlank: false,
          maxLength: 50
        }, {
          name: "expression"
        }],
        request: "EDIT_DEVICE_TREE",
        success: successHandler
      }
    }
    $scope.manMenuConfig = {
      proxy: {
        url: deviceUrl
      },
      editable: true,
      editor: {
        fields: [{
          name: "name",
          mapping: "name",
          allowBlank: false,
          maxLength: 50
        }, {
          name: "deviceIDList"
        }],
        request: "EDIT_DEVICE_TREE",
        success: successHandler
      }
    };
    $scope.autoMenu = {};
    $scope.manualMenu = {};
    $scope.manualDeviceList = {
      fields: [{
        showName: "DEVICE.DEVICENAME",
        name: "deviceName"
      }, {
        showName: "DEVICE.IP_ADDRESS",
        name: "ipAddress"
      }],
      editable: true
    }
    $scope.readText = "DEVICE.ADD";
    $scope.deleteText = "DEVICE.DELETE";
    $scope.editText = "DEVICE.EDIT";

    // device 只有两级目录，给第二级目录数据添加 isLeaf 字段，以避免在第二级前显示文件夹图标
    function addIsLeafPara(treeData) {
      if (!treeData.children.length) return;
      var i = 0,
        len = treeData.children.length;
      for (; i < len; i++) {
        if (treeData.children[i].children)
          treeData.children[i].isLeaf = true;
      }
    }

    $proxy.request({
      url: deviceUrl
    }, {
      "REQUEST": "GET_DEVICE_TREE"
    }, function(data) {
      if (data.autoTree) {
        data.autoTree.name = $translate.instant("DEVICE.AUTO_GROUPING");
        data.autoTree.rde = "1-0-0";
        if(!data.autoTree.uuid){
          data.autoTree.uuid = $tool.createUuid();
        }

        $scope.autoMenu.data = {
          autoTree: data.autoTree
        };
        addIsLeafPara($scope.autoMenu.data.autoTree);

        var i, item,
          num = 0,
          childrenArr = $scope.autoMenu.data.autoTree.children,
          len = childrenArr.length;
        for (i = 0; i < len; i++) {
          item = childrenArr[i];
          if (item.name === "Managed" || item.name === "Unmanaged") {
            item.rde = "1-0-0";
            num++;
          };
          if (num == 2) break;
        }
      };
      if (data.manualTree) {
        data.manualTree.name = $translate.instant("DEVICE.MANUAL_GROUPING");
        data.manualTree.rde = "1-0-0";
        data.manualTree.deviceIDList = genDeviceIDListPro(data.manualTree);
        if(!data.manualTree.uuid){
          data.manualTree.uuid = $tool.createUuid();
        }
        $scope.manualMenu.data = {
          manualTree: data.manualTree
        };
        addIsLeafPara($scope.manualMenu.data.manualTree);
      };
      $infoComm.updateSlideGroup($scope, "manual");
    }, function() {}, function() {});

    function genDeviceIDListPro(manualTree) {
        var children = manualTree.children;
        var deviceIDList = [];
        if (children && children.length) {
            var i = 0;
            var len = children.length;
            for (; i < len; i++) {
                deviceIDList = deviceIDList.concat(children[i].deviceIDList);
            }
            $tool.uniqueArr(deviceIDList);
        }
        return deviceIDList;
    }

    // $scope.information = {}; ???
    $scope.deviceConditionAdd = {};
    $scope.deviceConditionEdit = {};
    $scope.deviceConditionAdd.options = $scope.deviceConditionEdit.options = {
      operators: [{
        name: "AND",
        value: "&&"
      }, {
        name: "OR",
        value: "||"
      }],
      comparators: [{
        name: "contains",
        value: "contains"
      }, {
        name: "startswith",
        value: "startswith"
      }, {
        name: "=",
        value: "="
      }, {
        name: "!=",
        value: "!="
      }, {
        name: ">",
        value: ">"
      }, {
        name: "<",
        value: "<"
      }],
      fields: [{
        name: "Device name",
        value: "deviceName"
      }, {
        name: "Status",
        value: "deviceState"
      }, {
        name: "Mode",
        value: "wirelessMode"
      }, {
        name: "SSID",
        value: "essid"
      }, {
        name: "Root AP SSID",
        value: "rootAPEssid"
      }, {
        name: "IP address",
        value: "ipAddress"
      }, {
        name: "MAC address",
        value: "macAddress"
      }, {
        name: "Product",
        value: "product"
      }, {
        name: "Version",
        value: "version"
      }, {
        name: "SNR",
        value: "signal"
      }, {
        name: "Tx rate",
        value: "txRate"
      }, {
        name: "Rx rate",
        value: "rxRate"
      }, {
        name: "Tx total",
        value: "txTotal"
      }, {
        name: "Rx total",
        value: "rxTotal"
      }, {
        name: "CPU load",
        value: "cpuCurrent"
      }, {
        name: "CPU frequency",
        value: "cpuMax"
      }, {
        name: "Memory usage",
        value: "memFree"
      }, {
        name: "Memory size",
        value: "memTotal"
      }, {
        name: "Client number",
        value: "clientNum"
      }, {
        name: "Transmit CCQ",
        value: "ccq"
      }, {
        name: "Description",
        value: "description"
      }]
    };

    function updateManualTree(manualTree, removeArr){
      $tool.orthogonalize(manualTree.deviceIDList, removeArr);
      var i, len = manualTree.children.length;
      for (i = 0; i < len; i++) {
          var item = manualTree.children[i].deviceIDList;
          $tool.orthogonalize(item, removeArr);
      }
    }

    $scope.$on("ev_device_removed", function(e, deviceIDList){
        updateManualTree($scope.manualMenu.data.manualTree, deviceIDList);
    })

    $scope.information.updateAdd = function() {
      var treename = $scope.information.treename;
      if (treename == "autoTree") {
        $scope.deviceConditionAdd.data = {
          "comparator": "contains",
          "field": "deviceName",
          "fieldDisplayName": "Device name",
          "type": "simple",
          "value": ""
        }
        return "Auto"
      } else {
        $scope.manualMenu.form.data.deviceIDList = {
          data: []
        };
        return "Manual"
      }
    };
    $scope.information.updateEdit = function() {
      var treename = $scope.information.treename;
      var curfolder, item, idList, i, j, ilen, jlen;
      var options = [],
        option, selectedData, gridData;
      if (treename == "manualTree") {
        curfolder = $scope.information.curFolder;
        idList = curfolder["deviceIDList"];
        if (idList.length) {
          for (i = 0, ilen = idList.length; i < ilen; i++) {
            gridData = $scope.$parent.grid.data;
            for (j = 0, jlen = gridData.length; j < jlen; j++) {
              if (idList[i] == gridData[j].key) {
                selectedData = gridData[j];
                break;
              }
            }
            option = {};
            option["deviceName"] = selectedData["deviceName"].data;
            option["ipAddress"] = selectedData["ipAddress"].data;
            option.key = selectedData.key;
            options.push(option);
            $scope.manualDeviceList.options = options;
          }
          $scope.manualDeviceList.data = idList;
        };
        $scope.manualMenu.form.data.name.data = $scope.information.curFolder.name;
        if($scope.manualMenu.form.data.deviceIDList.data === ""){
          $scope.manualMenu.form.data.deviceIDList.data = [];
        }
      } else if (treename == "autoTree") {
        $scope.deviceConditionEdit.data = angular.copy($scope.information.curFolder.expression);
        $scope.autoMenu.form.data.name.data = $scope.information.curFolder.name;
      }
    };
    // all device 目录没有 add 功能
    $scope.information.cantAdd = function() {
        var cur = $scope.information.curFolder;
        if (cur === "DEVICE.ALLDEVICE") return true;
        return false;
      }
      // 顶级目录没有 edit 或者 del 功能
    $scope.information.cant = function() {
      var cur = $scope.information.curFolder;
      if (cur === "DEVICE.ALLDEVICE" ||
        angular.uppercase(cur.name) === "AUTO GROUPING" ||
        angular.uppercase(cur.name) === "MANAGED" ||
        angular.uppercase(cur.name) === "UNMANAGED" ||
        angular.uppercase(cur.name) === "MANUAL GROUPING" ||
        angular.uppercase(cur.name) === "MANUAL GROUP") return true;
      return false;
    }
  }
]);

pharosModule.controllerProvider.register("deviceGrid", ["$scope", "$proxy", "$constant", "$url", "$translate", "$form", "$grid", "wirelessService",
  function($scope, $proxy, $constant, $url, $translate, $form, $grid, wirelessService) {

    $scope.grid = $scope.$parent.$parent.grid;
    $scope.$parent.$parent.childScope = $scope;

    $scope.$parent.$parent.editDeviceWireless = function() {
      $scope.wireless.form.data.deviceName.disabled = true;
      wirelessService.editWireless($scope, $scope.wireless, $scope.wirelessMsg);
    };

    $scope.wireless = {};
    $scope.wirelessMsg = {};
    wirelessService.configWirelessForm($scope.wireless);
    wirelessService.initWirelessMsg($scope, $scope.wirelessMsg, $scope.wireless);

    $scope.wirelessMsg.okBtn.handler = function() {
      $scope.wirelessMsg.disabled = true;
      var originDeviceName = wirelessService.getOriginDeviceName();

      if(!$form.validate($scope.wireless)){
        $scope.wirelessMsg.disabled = false;
        return;
      }
      $form.submit($scope.wireless, {
        "REQUEST": "EDIT_DEVICE_WIRELESS_CFG",
        "DATA": {
          "originDeviceName": originDeviceName,
          "deviceID": $scope.grid.data[$scope.grid.updateIndex].key
        }
      }, function() {
        // scope.grid.loadData( $scope.wireless.form, "update", true);
        $scope.wirelessMsg.disabled = false;
        var data = $scope.wireless.form;
        var updateIndex = $scope.grid.updateIndex;
        var serials = data.serials;
        var fields = data.fields;
        var selectedIndexs;
        for (var index = 0, len = fields.length; index < len; index++) {
          var name = fields[index].name;
          selectedIndexs = $scope.grid.selectedIndexs;
          if ($scope.grid.data[updateIndex][name] && angular.isDefined(data.data[name].data)) {
            if (!serials[name] && !data.data[name].disabled) {
              for (var sIndex = 0, selectedLen = selectedIndexs.length; sIndex < selectedLen; sIndex++) {
                var selectedIndex = selectedIndexs[sIndex];
                $scope.grid.data[selectedIndex][name].data = data.data[name].data;
              }
            }
          }
        }
        $form.clear($scope.wireless);
        $scope.wirelessMsg.show = false;
      }, function(err_msg) {
        $form.clear($scope.wireless);
        $scope.wirelessMsg.show = false;
        $scope.wirelessMsg.disabled = false;
      }, function() {}, true, false);
    }
    $scope.wirelessMsg.cancelBtn.handler = function() {
      $form.clear($scope.wireless);
      $scope.wirelessMsg.show = false;
      $scope.wirelessMsg.disabled = false;
    }

    // wirelessService.editWireless( $scope, $scope.wireless, $scope.wirelessMsg );
    wirelessService.initChangeHandler($scope.wireless);

  }
]);

if (window.googleMapApiInvalid !== true) {
  pharosModule.controllerProvider.register("deviceMap", ["$scope", "$rootScope", "$timeout", "$proxy", "$url", "$form", "$translate", "uiGmapGoogleMapApi", "wirelessService", "$infoComm", "$tool",
    function($scope, $rootScope, $timeout, $proxy, $url, $form, $translate, uiGmapGoogleMapApi, wirelessService, $infoComm, $tool) {
      $scope.googleMapShow = true;
      $scope.googlemapErr = false;
      if (!window.google) {
        $scope.googlemapErr = true;
        return;
      }
      $scope.loading = true;

      $timeout(function() {
        if ($scope.loading === true) {
          $scope.googlemapErr = true;
          $scope.loading = false;
        }
      }, 7000);

      // 默认深圳总部
      var DEFAULT_LOCATION = {
        latitude: 22.5446301,
        longitude: 113.9442036
      }

      var DEFAULT_ZOOM = 14;

      var ONLINE_MANAGED_GREEN = "#9CCF4C";
      var ONLINE_UNMANAGED_GREY = "#A0A0A0";
      var OFFLINE_RED = "#C11C66";

      var DEVICE_INFO_ITEMS = "deviceName|wirelessMode|ipAddress|signal|rxRate|txRate";

      var deviceData = $scope.grid.data;
      var deviceUrl = $url.format("/device/");
      var miscUrl = $url.format("/misc/");
      var editDeviceLocation = false;

      function getGridItemByKey(key) {
        var gridData = $scope.grid.data;
        var i = 0,
          len = gridData.length;
        for (; i < len; i++) {
          if (gridData[i].key === key) return gridData[i];
        }
        return false;
      }

      function getGridIndexByDeviceID(deviceID){
        var gridData = $scope.grid.data;
        var i = 0,
        len = gridData.length;
        for (; i < len; i++) {
          if (gridData[i].key === deviceID) return i;
        }
        return false;
      }

      function getGridItemByMac(mac){
        var gridData = $scope.grid.data;
        var i = 0,
          len = gridData.length;
        for (; i < len; i++) {
          if (gridData[i].macAddress.data === mac) return gridData[i];
        }
        return false;
      }

      function getUpstreamDeviceItem(deviceID){
        var item = getGridItemByKey(deviceID);
        var rootAPBssidCached = item.rootAPBssidCached.data;
        var rootAPBssid = item.rootAPBssid.data;
        if(rootAPBssid === "" && rootAPBssidCached === ""){
          return;
        }
        if(rootAPBssid !== ""){
          return getGridItemByMac(rootAPBssid);
        }
        return getGridItemByMac(rootAPBssidCached);
      }

      function getToLocationByTopo(topoRelation, deviceID) {
        var toLocation, toDeviceItem;
        var toMac = topoRelation.relation[topoRelation.keyToMac[deviceID]].toMac;
        if (toMac === "toServer") {
          // toLocation = $scope.serverMarker.coords;
        } else {
          toDeviceItem = getGridItemByKey(topoRelation.relation[toMac].key);
          if (!toDeviceItem) {
            topoRelation.relation[topoRelation.keyToMac[deviceID]].toMac = "toServer";
          } else {
            toLocation = {
              latitude: toDeviceItem.latitude.data,
              longitude: toDeviceItem.longitude.data
            };
          }
        }
        return toLocation;
      }

      function getTopologicalRelation() {
        var gridData = $scope.grid.data;
        var i = 0,
          len = gridData.length,
          mac, toMac, fromMac;

        var topoRelation = {
          keyToMac: {},
          relation: {}
        };
        for (; i < len; i++) {
          mac = gridData[i].macAddress.data;

          var rootAPBssid = gridData[i].rootAPBssid.data;
          var rootAPBssidCached = gridData[i].rootAPBssidCached.data;
          if (rootAPBssid !== '') {
            toMac = rootAPBssid;
          } else if (rootAPBssidCached !== '') {
            toMac = rootAPBssidCached;
          } else {
            toMac = "toServer";
          }
          // toMac = rootAPBssid === "" ? "toServer" : gridData[i].rootAPBssid.data;

          topoRelation.keyToMac[gridData[i].key] = mac;

          if (!topoRelation.relation[mac]) topoRelation.relation[mac] = {};
          topoRelation.relation[mac]["key"] = gridData[i].key;
          topoRelation.relation[mac]["toMac"] = toMac;

          if (toMac !== "toServer") {
            if (!topoRelation.relation[toMac]) topoRelation.relation[toMac] = {};
            if (!topoRelation.relation[toMac]["fromMac"]) topoRelation.relation[toMac]["fromMac"] = [];
            topoRelation.relation[toMac]["fromMac"].push(mac);
          }
        }
        return topoRelation;
      }

      function updateDeviceCoords(deviceID, coords){
        var gridItem = getGridItemByKey(deviceID);
        gridItem.latitude.data = coords.latitude;
        gridItem.longitude.data = coords.longitude;
      }

      function updateMarkerCoords(deviceID, coords){
          var marker = findMarkerItemByDeviceID(deviceID);
          marker.coords.latitude = coords.latitude;
          marker.coords.longitude = coords.longitude;
      }

      function updateLineToCoords(deviceID, coords){
        var curLine = findLineItemByDeviceID(deviceID);
        if(curLine){
          curLine.path[0] = coords;
        }

        var downstreamDevices = getRelatedDevices(deviceID).downstreamDevices;
        for (var i = 0, len = downstreamDevices.length; i < len; i++) {
          var downstreamDevice = downstreamDevices[i];
          findLineItemByDeviceID(downstreamDevice).path[1] = coords;
        }
      }

      function generateMarker(name, options) {
        var i, len, deviceIndex;
        var icon = "theme/default/img/cpe";
        if (name == "wbs") icon = "theme/default/img/wbs";
        if (!options.isManaged) icon += "_offline";
        icon += ".png";

        var deviceData = $scope.grid.data;
        for (i = 0, len = deviceData.length; i < len; i++) {
          if (deviceData[i].key == options.deviceID) {
            deviceIndex = i;
            break;
          }
        }

        return {
          id: options.id,
          coords: {
            latitude: options.latitude,
            longitude: options.longitude
          },
          show: true,
          icon: icon,
          options: {
            draggable: options.draggable
          },
          selected: false,
          ishover: false,
          deviceID: options.deviceID,
          deviceIndex: deviceIndex,
          windowOption: {
            disableAutoPan: true
          },
          deviceInfo: { /* name : { name: , value: } */ }
        }
      }

      function generateLine(name, options) {
        // 没有上游设备
        if (!options.toLocation) {
          return false;
        }

        var path0 = {
          latitude: options.location.latitude,
          longitude: options.location.longitude
        };

        var path1 = {
          latitude: options.toLocation.latitude,
          longitude: options.toLocation.longitude
        };

        if(options.toLocation.latitude == 255 && options.toLocation.longitude == 255){
          var upstream = getUpstreamDeviceItem(options.deviceID);
          var coords = $scope.deviceWithNoLocation[upstream.key];
          path1.latitude = coords.lat;
          path1.longitude = coords.lon;
        }

        return {
          id: options.id,
          path: [path0, path1],
          stroke: {
            color: options.color,
            weight: 2
          },
          deviceID: options.deviceID,
          editable: false,
          draggable: false,
          geodesic: true,
          visible: true
        }
      }

      function keepIconSlectedStatus() {
          var notSelected = [];
          var i, len = $scope.grid.data.length;
          for(i = 0; i < len; i++){
            notSelected.push(i);
          }
          var selected = $scope.grid.selectedIndexs;
          $tool.orthogonalize(notSelected, selected);
          // keep selected
          for (i = 0, len = selected.length; i < len; i++) {
              var selectedIndex = selected[i];
              var deviceID = $scope.grid.data[selectedIndex].key;
              var marker = findMarkerItemByDeviceID(deviceID);
              if (!marker) continue;
              marker.selected = true;
              var icon = marker.icon;
              if (icon.indexOf('selected') === -1) {
                  var _icon = icon.slice(0, icon.length - '.png'.length);
                  _icon += "_selected.png";
                  marker.icon = _icon;
              }
          }
          // keep unselected
          for (i = 0, len = notSelected.length; i < len; i++) {
              var notSelectedIndex = notSelected[i];
              var deviceID = $scope.grid.data[notSelectedIndex].key;
              var marker = findMarkerItemByDeviceID(deviceID);
              if (!marker) continue;
              marker.selected = false;
              var icon = marker.icon;
              if (icon.indexOf('selected') !== -1) {
                  var _icon = icon.slice(0, icon.length - '_selected.png'.length);
                  _icon += ".png";
                  marker.icon = _icon;
              }
          }
      }

      function findDeviceListChangeType(newList, oldList) {
          var oldDeviceIDArr = [];
          var newDeviceIDArr = [];

          var i,
              len;
          for (i = 0, len = oldList.length; i < len; i++) {
              oldDeviceIDArr.push(oldList[i].key);
          }
          for (i = 0, len = newList.length; i < len; i++) {
              newDeviceIDArr.push(newList[i].key);
          }

          var operation = oldDeviceIDArr.length < newDeviceIDArr.length
              ? "add"
              : "delete";
          if(oldDeviceIDArr.length === newDeviceIDArr.length){
              operation = "noNumChange";
          }

          var diffDeviceIDArr = [];
          switch (operation) {
              case "add":
                  diffDeviceIDArr = newDeviceIDArr;
                  $tool.orthogonalize(diffDeviceIDArr, oldDeviceIDArr);
                  break;
              case "delete":
                  diffDeviceIDArr = oldDeviceIDArr;
                  $tool.orthogonalize(diffDeviceIDArr, newDeviceIDArr);
                  break;
              case "noNumChange":
                  var iold = angular.copy(oldDeviceIDArr);
                  var inew = angular.copy(newDeviceIDArr);
                  $tool.orthogonalize(iold, inew);

                  var jold = angular.copy(oldDeviceIDArr);
                  var jnew = angular.copy(newDeviceIDArr);
                  $tool.orthogonalize(jnew, jold);

                  if( !(iold.length === jnew.length && iold.length === 0) ){
                      operation = "add&delete";
                      diffDeviceIDArr = [];
                      diffDeviceIDArr.push({
                        "operation": "add",
                        "diffDeviceIDArr": jnew
                      });
                      diffDeviceIDArr.push({
                        "operation": "delete",
                        "diffDeviceIDArr": iold
                      });
                  }
                  break;
          }

          // for(i = 0, len = diffDeviceIDArr.length; i < len; i++){
          //     var item = getGridItemByKey(diffDeviceIDArr[i]);
          // }

          return {
            "operation": operation,
            "diffDeviceIDArr": diffDeviceIDArr
          }
      }

      function updateIconStatus(deviceID, nV, oV) {
          var marker = findMarkerItemByDeviceID(deviceID);
          if (!marker || !oV) return;
          var isMarkerSelected = marker.selected;
          var product = nV.product.data.indexOf("WBS") !== -1 ? "wbs" : "cpe";
          var icon = product === "wbs" ? "theme/default/img/wbs" : "theme/default/img/cpe";
          var oldDeviceState = oV["deviceState"].data.toUpperCase();
          var newDeviceState = nV["deviceState"].data.toUpperCase();
          if ((oldDeviceState === "MANAGED" && newDeviceState !== "MANAGED") ||
              (oldDeviceState !== "MANAGED" && newDeviceState === "MANAGED")) {
                if(newDeviceState !== "MANAGED"){
                  icon += "_offline";
                }
          } else {
            return;
          }
          if(isMarkerSelected){
            icon += "_selected";
          }
          icon += ".png";
          marker.icon = icon;
      }

      function updateMarkerLocationAndLineColor(deviceID, nV, oV){
        if (!oV) return;
        var oldlatitude = oV["latitude"].data;
        var oldlongitude = oV["longitude"].data;
        var newlatitude = nV["latitude"].data;
        var newlongitude = nV["longitude"].data;
        var newLocation = {
          "latitude": newlatitude,
          "longitude": newlongitude
        };
        var curLine = findLineItemByDeviceID(deviceID);

        if(oldlatitude !== newlatitude || oldlongitude !== newlongitude){
          updateMarkerCoords(deviceID, newLocation)
          var relatedDevices = getRelatedDevices(deviceID);
          var upstreamDevice = relatedDevices.upstreamDevice;
          var downstreamDevices = relatedDevices.downstreamDevices;

          if(curLine){
            curLine.path[0] = newLocation;
          }

          for (var i = 0; i < downstreamDevices.length; i++) {
            var lineItem = findLineItemByDeviceID(downstreamDevices[i]);
            lineItem.path[1] = newLocation;
          }
        }

        var oldDeviceState = oV["deviceState"].data.toUpperCase();
        var newDeviceState = nV["deviceState"].data.toUpperCase();
        var lineColor = ONLINE_MANAGED_GREEN;
        if ((oldDeviceState === "MANAGED" && newDeviceState !== "MANAGED") || (oldDeviceState !== "MANAGED" && newDeviceState === "MANAGED")) {
          if(newDeviceState !== "MANAGED"){
            lineColor = ONLINE_UNMANAGED_GREY;
          }
          curLine.stroke.color = lineColor;
        }
      }

      function findMarkerItemByDeviceID(deviceID) {
        var marker,
          i = 0,
          len = $scope.wbsMarkers.markers.length;
        for (; i < len; i++) {
          marker = $scope.wbsMarkers.markers[i];
          if (marker.deviceID === deviceID) {
            return marker;
          }
        }

        i = 0;
        len = $scope.cpeMarkers.markers.length;
        for (; i < len; i++) {
          marker = $scope.cpeMarkers.markers[i];
          if (marker.deviceID === deviceID) {
            return marker;
          }
        }
      }

      function findLineItemByDeviceID(deviceID) {
        var line,
          i = 0,
          len = $scope.wbsLines.lines.length;
        for (; i < len; i++) {
          line = $scope.wbsLines.lines[i];
          if (line.deviceID === deviceID) {
            return line;
          }
        }

        i = 0;
        len = $scope.cpeLines.lines.length;
        for (; i < len; i++) {
          line = $scope.cpeLines.lines[i];
          if (line.deviceID === deviceID) {
            return line;
          }
        }
        return false;
      }

      function findLineItemByMarkerID(lines, markerId) {
        var i,
          len = lines.length,
          lineItem;
        if (!len) return;
        for (i = 0; i < len; i++) {
          lineItem = lines[i];
          if (lineItem.id == markerId) return lineItem;
        }
        return false;
      }

      function getRelatedDevices(deviceID){
        var upstreamDevice;
        var downstreamDevices = [];
        var curItem = getGridItemByKey(deviceID);
        var curMacAddress = curItem.macAddress.data;
        var upstreamDeviceMac = curItem.rootAPBssidCached.data;
        if(upstreamDeviceMac !== ""){
          upstreamDevice = getGridItemByMac(upstreamDeviceMac);
        } else {
          upstreamDevice = false;
        }

        var gridData = $scope.grid.data;
        var i = 0,
          len = gridData.length;
        for (; i < len; i++) {
          if (gridData[i].rootAPBssidCached.data === curMacAddress){
            downstreamDevices.push(gridData[i].key);
          }
        }
        return {
          "upstreamDevice": upstreamDevice,
          "downstreamDevices": downstreamDevices
        };
      }

      function markerDragHandler(name, marker, eventName, args) {
        var lines = $scope[name + "Lines"].lines;
        var toLineItem = findLineItemByMarkerID(lines, marker.key);
        if (toLineItem) toLineItem.visible = false;
        // -------------------
        $scope.fromLineItems = [];
        var topoRelation = getTopologicalRelation();
        var deviceIndex = marker.model.deviceIndex;
        var mac = $scope.grid.data[deviceIndex].macAddress.data;
        var fromMac = topoRelation.relation[mac].fromMac;

        if (!fromMac || fromMac.length === 0) return;

        var i = 0,
          len = fromMac.length,
          key, fromLineItem;
        for (; i < len; i++) {
          key = topoRelation.relation[fromMac[i]].key;
          fromLineItem = findLineItemByDeviceID(key);
          $scope.fromLineItems.push(fromLineItem);
          fromLineItem.visible = false;
        }
      }

      function markerDragendHandler(name, marker, eventName, args) {
        var lines = $scope[name + "Lines"].lines;
        var toLineItem = findLineItemByMarkerID(lines, marker.key);
        var location = {
          latitude: marker.getPosition().lat(),
          longitude: marker.getPosition().lng()
        }

        var data = {};
        data["deviceIDList"] = [marker.model.deviceID];
        data["longitude"] = location.longitude;
          data["latitude"] = location.latitude;

        editDeviceLocation = true;
        $proxy.request({
          url: deviceUrl
        }, {
          "REQUEST": "EDIT_DEVICE_LOCATION",
          "DATA": data
        });

        if (toLineItem) {
          toLineItem.path[0] = location;
          if (!toLineItem.visible) toLineItem.visible = true;
        }

        if ($scope.fromLineItems.length !== 0) {
          for (var i = 0, len = $scope.fromLineItems.length; i < len; i++) {
            var fromLineItem = $scope.fromLineItems[i];
            fromLineItem.path[1] = location;
            if (!fromLineItem.visible) fromLineItem.visible = true;
          }
        }
      }

      function markerClickHandler(name, marker, eventName, args) {
        var isSelected = marker.model["selected"] = !marker.model["selected"];
        var icon_selected = "theme/default/img/" + name + "_selected.png";
        var icon_normal = "theme/default/img/" + name + ".png";
        var i;
        var selectedIndexs = $scope.grid.selectedIndexs;
        var len = selectedIndexs.length;

        if (marker.model.icon.indexOf("offline") !== -1) {
          icon_selected = "theme/default/img/" + name + "_offline_selected.png";
          icon_normal = "theme/default/img/" + name + "_offline.png";
        }

        if (isSelected) {
          marker.setIcon(icon_selected);
          $scope.grid.selectedIndexs.push(marker.model.deviceIndex);
          _.uniq($scope.grid.selectedIndexs);
          $scope.grid.selectedIndexs.sort(function(a, b) {
            return a - b
          });
        } else {
          marker.setIcon(icon_normal);
          for (i = 0; i < len; i++) {
            if (selectedIndexs[i] == marker.model.deviceIndex) {
              selectedIndexs.splice(i, 1);
            }
          }
        }

        // ------------------
        var markersInstance = $scope[name + "Markers"].markersInstance;
        markersInstance[marker.model.id] = marker;
      }

      function markerDbClickHandler(name, marker, eventName, args){
          var deviceID = marker.model.deviceID;
          var index = getGridIndexByDeviceID(deviceID);
          if(index === false) return;
          $scope.$emit("showGridItemInfo", {index: index});
      }

      function modeFormat(data) {
        switch (data) {
          case 0:
          return $translate.instant("DEVICE.MODE_AP");
          case 1:
          return $translate.instant("DEVICE.MODE_CLIENT");
          case 2:
          return $translate.instant("DEVICE.MODE_REPEATER");
          case 3:
          return $translate.instant("DEVICE.MODE_BRIDGE");
          case 4:
          return $translate.instant("DEVICE.MODE_AP_ROUTER");
          case 5:
          return $translate.instant("DEVICE.MODE_AP_CLIENTROUTER");
          default:
          return $translate.instant("DEVICE.N_A");
        }
      }

      function updateDeviceInfo(deviceID, nV, oV){
          var marker = findMarkerItemByDeviceID(deviceID);
          if(!marker || !oV) return;
          // deviceName|wirelessMode|ipAddress|signal|rxRate|txRate
          var _nameArr = DEVICE_INFO_ITEMS.split("|");
          var i, len = _nameArr.length;
          for(i = 0; i < len; i++){
            var name = _nameArr[i];
            if(nV[name].data !== oV[name].data){
              var value = name === "wirelessMode" ? modeFormat(nV[name].data) : nV[name].data;
              marker.deviceInfo[name].value = value;
            }
          }
      }

      function isDeviceInfoItemsChanged(nVal, oVal){
        // deviceName|wirelessMode|ipAddress|signal|rxRate|txRate
        var _nameArr = DEVICE_INFO_ITEMS.split("|");
        var i, len = _nameArr.length;
        for(i = 0; i < len; i++){
           var name = nameArr[i];
        }

      }

      function generateDeviceInfoObj(deviceItem) {
        var _nameArr = DEVICE_INFO_ITEMS.split("|");
        var result = {};
        var i, len = _nameArr.length,
          _name, _data, translateName;
        for (i = 0; i < len; i++) {
          _name = _nameArr[i];
          _data = deviceItem[_name].data;
          translateName = "DEVICE.MAP_" + angular.uppercase(_name);

          if (_name === "wirelessMode") {
            _data = modeFormat(_data);
          }

          result[_name] = {
            name: $translate.instant(translateName),
            value: _data
          }
        }
        return result;
      }

      function getLineColor(deviceItem) {
        var isManaged = deviceItem.deviceState.data === "MANAGED" ? true : false;
        var _toMac = deviceItem.rootAPBssid.data;
        var _toMacCache = deviceItem.rootAPBssidCached.data;

        if (_toMac === '' && _toMacCache === '') return false;
        if (isManaged && _toMac !== '') return ONLINE_MANAGED_GREEN;
        return ONLINE_UNMANAGED_GREY
      }

      function getCenter(){
        // 默认深圳总部
        var center = DEFAULT_LOCATION;

        var i = 0,
          gridData = $scope.grid.data,
          len = gridData.length;

        if (len) {
          var latSum = 0,
            lonSum = 0,
            _len = len;

          for (; i < len; i++) {
            var item = gridData[i];
            if (item.latitude.data === 255 && item.longitude.data === 255) {
              _len--;
              continue;
            } else {
              latSum += item.latitude.data;
              lonSum += item.longitude.data;
            }
          }

          // 都没有经纬度
          if (_len === 0) return center;
          if (_len === 1) {
            center.latitude = latSum;
            center.longitude = lonSum + 0.003;
          } else {
            center.latitude = latSum / _len;
            center.longitude = lonSum / _len;
          }
        }
        return center;
      }

      function setZoom(){
        var i = 0,
          gridData = $scope.grid.data,
          len = gridData.length;

        if(len === 0) return;

        var _len = len;
        var maxLatitude, minLatitude;
        var maxLongitude, minLongitude;
        var center = getCenter();

        for (; i < len; i++) {
          var item = gridData[i];
          var ilatitude = item.latitude.data;
          var ilongitude = item.longitude.data;
          if (ilatitude === 255 && ilongitude === 255) {
            _len--;
            continue;
          } else {
            if(maxLatitude === undefined){
              maxLatitude = ilatitude;
              minLatitude = ilatitude;
              maxLongitude = ilongitude;
              minLongitude = ilongitude;
            } else {
              if(ilatitude > maxLatitude) maxLatitude = ilatitude;
              if(ilongitude > maxLongitude) maxLongitude = ilongitude;
              if(ilatitude < minLatitude) minLatitude = ilatitude;
              if(ilongitude < minLongitude) minLongitude = ilongitude;
            }
          }
        }
        if (_len === 0 || _len === 1){
          return;
        }

        var deltaLatitude = maxLatitude - minLatitude;
        var deltaLongitude = maxLongitude - minLongitude;
        var preferDelta = deltaLatitude > deltaLongitude ? deltaLatitude : deltaLongitude;

        var zoom = DEFAULT_ZOOM;
        if(preferDelta > 90){
          zoom = 1;
        } else if(preferDelta > 45){
          zoom = 2;
        } else if(preferDelta > 10){
          zoom = 4;
        } else if(preferDelta > 3){
          zoom = 6;
        } else if(preferDelta > 1){
          zoom = 8;
        } else if(preferDelta > 0.2){
          zoom = 10;
        } else if(preferDelta > 0.05){
          zoom = 12;
        }
        $scope.map.zoom = zoom;
      }
      // ---------------------------------------------------------------------------
      $scope.map = {
        center: DEFAULT_LOCATION,
        zoom: DEFAULT_ZOOM,
        bounds: {},
        markers: [],
        idkey: 'place_id',
        events: {
          tilesloaded: function(map) {
            $scope.$apply(function() {
              $scope.mapInstance = map;
              if (!$scope.searchBoxService) $scope.searchBoxService = new google.maps.places.PlacesService(map);
            });
            $scope.loading = false;
          }
        }
      };

      uiGmapGoogleMapApi.then(function(maps) {
        // console.log( "Google Maps SDK ready ！！！" )
        maps.visualRefresh = true;
        // $scope.defaultBounds = new google.maps.LatLngBounds(
        //   new google.maps.LatLng(22.6446301, 114.0442036),
        //   new google.maps.LatLng(22.4446301, 113.8442036)
        // );


        // $scope.map.bounds = {
        //   northeast: {
        //     latitude: $scope.defaultBounds.getNorthEast().lat(),
        //     longitude: $scope.defaultBounds.getNorthEast().lng()
        //   },
        //   southwest: {
        //     latitude: $scope.defaultBounds.getSouthWest().lat(),
        //     longitude: -$scope.defaultBounds.getSouthWest().lng()
        //   }
        // };

        // $scope.searchbox.options.bounds = new google.maps.LatLngBounds($scope.defaultBounds.getNorthEast(), $scope.defaultBounds.getSouthWest());
      })

      var setCenter = function() {
        // $scope.serverMarker.coords = getCenter();
        $scope.map.center = getCenter();
      }

      // server marker
      $scope.serverMarker = {
        id: 0,
        coords: DEFAULT_LOCATION,
        // coords: getCenter(),
        options: {
          draggable: true,
          icon: "theme/default/img/server_selected.png",
          title: "SERVER"
        },
        events: {
          dragend: function(marker, eventName, args) {
            var data = {};
            data["latitude"] = marker.getPosition().lat(),
              data["longitude"] = marker.getPosition().lng()

            $proxy.request({
              url: miscUrl
            }, {
              "REQUEST": "EDIT_SERVER_LOCATION",
              "DATA": data
            });
          }
        }
      };
      if ($scope.serverLocation &&
        $scope.serverLocation.latitude !== 255 &&
        $scope.serverLocation.latitude !== 255) {
        $scope.serverMarker.coords = $scope.serverLocation;

      }

      $scope.isMarkersLocked = {
        data: false
      };

      // var hasInited = false;
      function init(deviceData) {
        var i, len, deviceItem;
        var lat, lon, _marker, _line, product, deviceID, deviceState, lineColor, isManaged;

        // !hasInited && setCenter();
        // hasInited = true;

        setZoom();
        setCenter();

        // relation
        var topoRelation = getTopologicalRelation();
        // WBS
        $scope.wbsMarkers = {
          markers: [],
          options: {
            title: "WBS"
          },
          events: {
            drag: function(marker, eventName, args) {
              markerDragHandler("wbs", marker, eventName, args);
            },
            dragend: function(marker, eventName, args) {
              markerDragendHandler("wbs", marker, eventName, args);
            },
            click: function(marker, eventName, args) {
              markerClickHandler("wbs", marker, eventName, args);
            },
            dblclick: function(marker, eventName, args){
              markerDbClickHandler("wbs", marker, eventName, args);
            },
            mouseover: function(marker, eventName, args) {
              marker.model["ishover"] = true;
            },
            mouseout: function(marker, eventName, args) {
              marker.model["ishover"] = false;
            }
          },
          markersInstance: {}
        };
        $scope.wbsLines = {
          lines: []
        };
        // CPE
        $scope.cpeMarkers = {
          markers: [],
          options: {
            title: "CPE"
          },
          events: {
            drag: function(marker, eventName, args) {
              markerDragHandler("cpe", marker, eventName, args);
            },
            dragend: function(marker, eventName, args) {
              markerDragendHandler("cpe", marker, eventName, args);
            },
            click: function(marker, eventName, args) {
              markerClickHandler("cpe", marker, eventName, args);
            },
            dblclick: function(marker, eventName, args){
              markerDbClickHandler("cpe", marker, eventName, args);
            },
            mouseover: function(marker, eventName, args) {
              marker.model["ishover"] = true;
            },
            mouseout: function(marker, eventName, args) {
              marker.model["ishover"] = false;
            }
          },
          markersInstance: {}
        };
        $scope.cpeLines = {
          lines: []
        };

        $scope.deviceWithNoLocation = {};
        len = deviceData.length;
        if (len) {
          // ----------------------------
          var icount = 1;
          for (i = 0; i < len; i++) {
            deviceItem = deviceData[i];
            deviceID = deviceItem.key;

            lat = deviceItem.latitude.data;
            lon = deviceItem.longitude.data;

            product = deviceItem.product.data.indexOf("WBS") !== -1 ? "WBS" : "CPE";
            if (lat === undefined || lon === undefined || product === undefined) continue;

            if (lat == 255 && lon == 255){
              lat = $scope.serverMarker.coords.latitude;
              lon = $scope.serverMarker.coords.longitude + 0.003 * (icount++);
              $scope.deviceWithNoLocation[deviceID + ""] = {
                "lat": lat,
                "lon": lon
              }
            }
          }
          // ----------------------------

          var count = 1;
          for (i = 0; i < len; i++) {
            deviceItem = deviceData[i];
            deviceID = deviceItem.key;
            deviceState = deviceItem.deviceState.data;

            lat = deviceItem.latitude.data;
            lon = deviceItem.longitude.data;

            product = deviceItem.product.data.indexOf("WBS") !== -1 ? "WBS" : "CPE";

            if (lat === undefined || lon === undefined || product === undefined) continue;

            if (lat == 255 && lon == 255){
              lat = $scope.serverMarker.coords.latitude;
              lon = $scope.serverMarker.coords.longitude + 0.003 * (count++);
            }

            isManaged = false;
            if (deviceState === "MANAGED") {
              isManaged = true;
            }

            lineColor = getLineColor(deviceItem);
            if (!lineColor) lineColor = OFFLINE_RED;

            _marker = {};
            if (product === "WBS") {
              _marker = generateMarker("wbs", {
                id: deviceID,
                latitude: lat,
                longitude: lon,
                deviceID: deviceID,
                isManaged: isManaged,
                draggable: $scope.isMarkersLocked.data ? false : true
              });

              _line = generateLine("wbs", {
                id: deviceID,
                location: {
                  latitude: lat,
                  longitude: lon
                },
                toLocation: getToLocationByTopo(topoRelation, deviceID),
                color: lineColor,
                deviceID: deviceID
              });

              _marker.deviceInfo = generateDeviceInfoObj(deviceItem);
              $scope.wbsMarkers.markers.push(_marker);
              if (_line) $scope.wbsLines.lines.push(_line);
            } else if (product === "CPE") {
              _marker = generateMarker("cpe", {
                id: deviceID,
                latitude: lat,
                longitude: lon,
                deviceID: deviceID,
                isManaged: isManaged,
                draggable: $scope.isMarkersLocked.data ? false : true
              });

              _line = generateLine("cpe", {
                id: deviceID,
                location: {
                  latitude: lat,
                  longitude: lon
                },
                toLocation: getToLocationByTopo(topoRelation, deviceID),
                color: lineColor,
                deviceID: deviceID
              });

              _marker.deviceInfo = generateDeviceInfoObj(deviceItem);
              $scope.cpeMarkers.markers.push(_marker);
              if (_line) $scope.cpeLines.lines.push(_line);
            }
          }
        }
      }

      init($scope.grid.data);

      // ---------------------------------------------------------------------------
      // add/edit device messageBox
      var editDeviceConfig = {
        proxy: {
          url: deviceUrl
        },
        fields: [{
          name: "ipAddress",
          allowBlank: false,
          vtype: "ip"
        }, {
          name: "description"
        }, {
          name: "withSshInfo"
        }, {
          name: "sshUsername",
          allowBlank: false
        }, {
          name: "sshPassword",
          allowBlank: false,
          encryption: {
            name: "noop"
          }
        }, {
          name: "sshPort",
          allowBlank: false
        }],
        validator: function(scope) {
          var data = scope.form.data,
            withSshInfo = data.withSshInfo.data,
            sshUsername, sshPassword, sshPort;
          if (withSshInfo == 1) {
            sshUsername = data.sshUsername.data;
            sshPassword = data.sshPassword.inputData;
            sshPort = data.sshPort.data;
            if (sshUsername == '' ||
              sshPassword == '' ||
              sshPort == '') {
              return false;
            }
          }
          return true;
        },
        autoLoad: false
      };
      $scope.editDeviceForm = {};
      $form.config($scope.editDeviceForm, editDeviceConfig);
      $scope.editDeviceMsg = {
        title: "FORM.ADD",
        okBtn: {
          handler: function() {
            var optype = $scope.editDeviceForm.optype;
            var data;
            if (optype == "add") {
              data = {
                REQUEST: "ADD_DEVICE"
              }
            } else if (optype == "edit") {
              data = {
                REQUEST: "EDIT_DEVICE",
                DATA: {
                  "deviceID": $scope.editLoginKeys
                }
              }
            }
            $form.submit($scope.editDeviceForm, data,
              function(data) {
                $scope.editDeviceMsg.show = false;
              }
            );
          }
        },
        cancelBtn: {
          handler: function() {
            $form.clear($scope.editDeviceForm);
            $scope.editDeviceMsg.show = false;
          }
        },
        autoClose: false
      };

      $scope.editDeviceForm.form.data.withSshInfo.changeHandler = function(nVal) {
        var fields = ["sshUsername", "sshPassword", "sshPort"];
        if (nVal == 0) {
          for (var index = 0, len = fields.length; index < len; index++) {
            $scope.editDeviceForm.form.data[fields[index]].disabled = true;
          }
        } else if (nVal == 1) {
          for (var index = 0, len = fields.length; index < len; index++) {
            $scope.editDeviceForm.form.data[fields[index]].disabled = false;
          }
        }
      };

      $scope.multiEditDeviceMsg = {
        title: "DEVICE.EDIT_MANAGING",
        okBtn: {
          handler: function() {
            $form.serialize($scope.editDeviceForm, ["ipAddress", "description", "withSshInfo"]);
            $form.submit($scope.editDeviceForm, {
              "REQUEST": "EDIT_DEVICE_LOGIN_CREDENTIAL",
              "DATA": {
                "deviceIDList": $scope.editLoginKeys
              }
            }, function(data, other) {
              // update grid
              $scope.grid.loadData($scope.editDeviceForm.form, "update", true);
              $scope.multiEditDeviceMsg.show = false;
            }, function() {
              $scope.multiEditDeviceMsg.show = false;
            }, function() {
              $scope.multiEditDeviceMsg.show = false;
            });
          }
        },
        cancelBtn: {
          handler: function() {
            $form.clear($scope.editDeviceForm);
            $scope.multiEditDeviceMsg.show = false;
          }
        },
        autoClose: false
      };

      $scope.deleteDeviceMsg = {
        title: "FORM.CONFIRMATION",
        content: "FORM.DELGROUP",
        okBtn: {
          handler: function() {
            var deviceIDList = [],
              index;
            for (var i = 0, len = $scope.grid.selectedIndexs.length; i < len; i++) {
              index = $scope.grid.selectedIndexs[i];
              deviceIDList.push($scope.grid.data[index].key);
            }

            function initMenuHandle($scope) {
              // if (data.autoTree) {
              // 	data.autoTree.rde = "1-0-0";
              // 	$scope.autoMenu.data = {autoTree: data.autoTree};
              // };
              // if (data.manualTree) {
              // 	data.manualTree.rde = "1-0-0";
              // 	$scope.manualMenu.data = {manualTree: data.manualTree};
              // };
              $infoComm.updateSlideGroup($scope, "manual");
            }
            $infoComm.deleteIDList($scope.childMenu, "manual", deviceIDList, function() {
              initMenuHandle($scope.childMenu);
            });
            $scope.grid.selectedIndexs = [];
          }
        },
        cancelBtn: {
          handler: function() {}
        }
      };

      // edit: wireless messageBox
      $scope.mapWireless = {};
      $scope.mapWirelessMsg = {};
      wirelessService.configWirelessForm($scope.mapWireless);
      wirelessService.initWirelessMsg($scope, $scope.mapWirelessMsg, $scope.mapWireless);

      $scope.mapWirelessMsg.okBtn.handler = function() {
        $scope.mapWirelessMsg.disabled = true;
        var originDeviceName = wirelessService.getOriginDeviceName();
        var updateIndex = $scope.grid.updateIndex || $scope.grid.selectedIndexs[0];

        if(!$form.validate($scope.mapWireless)){
          $scope.mapWirelessMsg.disabled = false;
          return;
        }

        $form.submit($scope.mapWireless, {
          "REQUEST": "EDIT_DEVICE_WIRELESS_CFG",
          "DATA": {
            "originDeviceName": originDeviceName,
            "deviceID": $scope.grid.data[updateIndex].key
          }
        }, function() {
          $scope.mapWirelessMsg.disabled = false;
          var data = $scope.mapWireless.form;
          var updateIndex = $scope.grid.updateIndex || $scope.grid.selectedIndexs[0];
          var serials = data.serials;
          var fields = data.fields;
          var selectedIndexs;
          for (var index = 0, len = fields.length; index < len; index++) {
            var name = fields[index].name;
            selectedIndexs = $scope.grid.selectedIndexs;
            if ($scope.grid.data[updateIndex][name] && angular.isDefined(data.data[name].data)) {
              if (!serials[name] && !data.data[name].disabled) {
                for (var sIndex = 0, selectedLen = selectedIndexs.length; sIndex < selectedLen; sIndex++) {
                  var selectedIndex = selectedIndexs[sIndex];
                  $scope.grid.data[selectedIndex][name].data = data.data[name].data;
                }
              }
            }
          }
          $form.clear($scope.mapWireless);
          $scope.mapWirelessMsg.show = false;
        }, function() {
          $scope.mapWirelessMsg.show = false;
          $scope.mapWirelessMsg.disabled = false;
        }, function() {
          $scope.mapWirelessMsg.show = false;
          $scope.mapWirelessMsg.disabled = false;
        }, true, false);
      }
      $scope.mapWirelessMsg.cancelBtn.handler = function() {
        $form.clear($scope.mapWireless);
        $scope.mapWirelessMsg.show = false;
        $scope.mapWirelessMsg.disabled = false;
      }

      wirelessService.initChangeHandler($scope.mapWireless);

      // -----------------
      $scope.$on("gridEditing", function(ev, args) {
        if (args.type === "add") {
          $scope.editDeviceForm.optype = "add";
          $scope.editDeviceForm.form.data.sshPassword.inputData = '';
          $scope.editDeviceForm.form.data.withSshInfo.data = 0;
          $scope.editDeviceMsg.title = "FORM.ADD";
          $scope.editDeviceMsg.show = true;
        } else if (args.type === "remove") {
          $scope.deleteDeviceMsg.show = true;
        }
      })

      // edit device
      $scope.editDevicAddonBtn = {
        name: "DEVICE.START_MANAGE",
        handler: function(editMsg) {
          // 先 edit device 然后再对 unmanaged 设备进行 start managing 操作
          var i, len = $scope.grid.selectedIndexs.length;
          var data = [];
          for (i = 0; i < len; i++) {
            var item = $scope.grid.data[$scope.grid.selectedIndexs[i]];
            if (angular.uppercase(item.deviceState.data) === "UNMANAGED" ||
              item.deviceState.data === "INVALID_CREDENTIAL" ||
              item.deviceState.data === "ERROR") {
              data.push(item.key);
            }
          }

          function connectDevice() {
            $proxy.request({
              url: deviceUrl
            }, {
              "REQUEST": "CONNECT_DEVICE",
              "DATA": {
                "deviceIDList": data
              }
            });
            editMsg.show = false;
          }

          // len > 1 的话表明此时打开的是 multiEditDeviceMsg 这个弹窗
          if (len === 1) {
            $form.submit($scope.editDeviceForm, {
              "REQUEST": "EDIT_DEVICE",
              "DATA": {
                "deviceID": data[0]
              }
            }, function() {
              connectDevice();
            }, function() {}, function() {});
          } else if ($scope.multiEditDeviceMsg.show) {
            $form.serialize($scope.editDeviceForm, ["ipAddress", "description", "withSshInfo"]);
            $form.submit($scope.editDeviceForm, {
              "REQUEST": "EDIT_DEVICE_LOGIN_CREDENTIAL",
              "DATA": {
                "deviceIDList": data
              }
            }, function(data, other) {
              connectDevice();
            }, function() {}, function() {});
          }
        }
      }

      $scope.$on("liveEditing", function(e, args) {
        var len = args.len,
          selectedIndexs = args.selectedIndexs;
        $scope.editLoginKeys = [];
        var i, ilen, formData = {},
          item;

        // 编辑单个设备
        if (len === 1) {
          var singleData = $scope.grid.data[selectedIndexs[0]];
          // 单个 managed 设备
          if (singleData.deviceState.data == "MANAGED") {
            // tmpVersion >= 2 时设备支持编辑无线参数
            if ($scope.grid.data[selectedIndexs[0]].tmpVersion.data < 2) {
              $scope.notSupportEditMsg.content = "DEVICE.NOT_SUPPORT_EDIT_WIRELESS";
              $scope.notSupportEditMsg.show = true;
            } else {
              $scope.mapWireless.form.data.deviceName.disabled = true;
              wirelessService.editWireless($scope, $scope.mapWireless, $scope.mapWirelessMsg);
            }
            // 单个 unmanaged 设备
          } else if (singleData.deviceState.data === "UNMANAGED" ||
            singleData.deviceState.data === "INVALID_CREDENTIAL" ||
            singleData.deviceState.data === "ERROR") {
            $scope.editLoginKeys = $scope.grid.data[selectedIndexs[0]].key;
            $scope.editDeviceForm.optype = "edit";
            $scope.editDeviceMsg.title = "FORM.EDIT";

            angular.forEach(["ipAddress", "description", "sshUsername", "sshPassword", "sshPort"], function(value, key) {
              formData[value] = singleData[value].data;
            })

            $form.loadData($scope.editDeviceForm, formData);
            $scope.editDeviceForm.form.data.withSshInfo.data = 0;

            $scope.editDeviceMsg.addonBtn = $scope.editDevicAddonBtn;
            $scope.editDeviceMsg.show = true;
          }
          // 编辑多个设备
        } else {
          var managedArr = [];
          var unmanagedArr = [];
          for (var index = 0; index < len; index++) {
            var iData = $scope.grid.data[selectedIndexs[index]];
            if (iData.deviceState.data === "UNMANAGED" ||
              iData.deviceState.data === "INVALID_CREDENTIAL" ||
              iData.deviceState.data === "ERROR") {
              unmanagedArr.push($scope.grid.data[selectedIndexs[index]].key);
            } else if (iData.deviceState.data === "MANAGED") {
              managedArr.push($scope.grid.data[selectedIndexs[index]].key);
            }
          }
          // 多个设备中至少有一个 unmanaged 设备
          if (unmanagedArr.length) {
            $scope.editLoginKeys = unmanagedArr;
            for (i = 0, ilen = $scope.grid.data.length; i < ilen; i++) {
              item = $scope.grid.data[i];
              if (item.key === unmanagedArr[0]) {
                angular.forEach(["sshUsername", "sshPassword", "sshPort"], function(value, key) {
                  formData[value] = item[value].data;
                })
                break;
              }
            }
            $form.loadData($scope.editDeviceForm, formData);
            $scope.editDeviceForm.form.data.withSshInfo.data = 1;

            $scope.multiEditDeviceMsg.addonBtn = $scope.editDevicAddonBtn;
            $scope.multiEditDeviceMsg.show = true;
          } else {
            $scope.notSupportEditMsg.content = "DEVICE.EDIT_MANAGED_MULTIDEVICE_NOTE";
            $scope.notSupportEditMsg.show = true;
          }
        }
      })
      $scope.$watch("grid.data", function(nVal, oVal) {
        if (nVal !== oVal) {
          var changeResult = findDeviceListChangeType(nVal, oVal);
          // 设备还是那些设备，但是某些设备的某些数据变了
          if(changeResult.operation === "noNumChange"){
            if(editDeviceLocation){
              editDeviceLocation = false;
            } else {
              var i, len = nVal.length;
              for (i=0; i < len; i++){
                var nV = nVal[i];
                var oV = oVal[i];
                var deviceID = nV.key;
                updateDeviceInfo(deviceID, nV, oV);
                updateIconStatus(deviceID, nV, oV);
                updateMarkerLocationAndLineColor(deviceID, nV, oV);
                // setZoom();
              }
            }
          // 增加/删除了某些设备
          } else {
            // init($scope.grid.data);
            $rootScope.$broadcast("switchLive");
          }
        }
      }, true);

      // -------------------
      var infoWindowsOn = $translate.instant("DEVICE.ALL_INFO_WINDOWS_ON");
      var infoWindowsOff = $translate.instant("DEVICE.ALL_INFO_WINDOWS_OFF");
      var isInfoWindowsOn = true;
      $scope.infoWindowsState = infoWindowsOn;
      $scope.switchAllInfoWindows = function(){
        var marker,
          i = 0,
          len = $scope.wbsMarkers.markers.length;
        for (; i < len; i++) {
          marker = $scope.wbsMarkers.markers[i];
          if(isInfoWindowsOn){
            marker.show = false;
          }else{
            marker.show = true;
          }
        }

        i = 0;
        len = $scope.cpeMarkers.markers.length;
        for (; i < len; i++) {
          marker = $scope.cpeMarkers.markers[i];
          if(isInfoWindowsOn){
            marker.show = false;
          }else{
            marker.show = true;
          }
        }

        if(isInfoWindowsOn){
          $scope.infoWindowsState = infoWindowsOff;
        }else{
          $scope.infoWindowsState = infoWindowsOn;
        }

        isInfoWindowsOn = !isInfoWindowsOn;
      }

      $scope.isFullScreen = false;
      $scope.swicthFullScreen = function() {
          var gridContainer = angular.element(document.getElementById("grid-container"));
          var liveContainer = angular.element(document.getElementById("device-live-container"));
          if ($scope.isFullScreen) {
              gridContainer.removeClass("gmap-fullscreen");
              liveContainer.removeClass("gmap-fullscreen");
          } else {
              gridContainer.addClass("gmap-fullscreen");
              liveContainer.addClass("gmap-fullscreen");
              // 触发重绘
              google.maps.event.trigger($scope.mapInstance, 'resize')
          }
          $scope.isFullScreen = !$scope.isFullScreen;
      }

      $scope.$watch('isMarkersLocked.data', function(nV, oV) {
        if (nV !== oV) {
          if (nV) {
            angular.forEach($scope.wbsMarkers.markers, function(marker, index) {
              marker.options.draggable = false;
            });
            angular.forEach($scope.cpeMarkers.markers, function(marker, index) {
              marker.options.draggable = false;
            });
            $scope.serverMarker.options.draggable = false;
          } else {
            angular.forEach($scope.wbsMarkers.markers, function(marker, index) {
              marker.options.draggable = true;
            });
            angular.forEach($scope.cpeMarkers.markers, function(marker, index) {
              marker.options.draggable = true;
            });
            $scope.serverMarker.options.draggable = true;
          }
          // init($scope.grid.data);
          keepIconSlectedStatus();
        }
      })

      $scope.searchMsg = {
        title: "DEVICE.RELOCATE",
        okBtn: {
          text: "DEVICE.RELOCATE",
          handler: function() {
            if ($scope.locationOperate.mode.data === 'address') {
              var data = $scope.locationOperate.placesList.data;
              if (data.length === 0) {
                $scope.searchMsg.msg_errtip = "ERROR_TIPS.NO_SELECT";
                return;
              }
              if (data && data.length !== 1) {
                $scope.searchMsg.msg_errtip = "ERROR_TIPS.ONE_SELECT";
                return;
              }
              var location = $scope.locationOperate.placesList.options[data[0]];
              $scope.locationOperate.locationForm.form.data.latitude.data = location.latitude;
              $scope.locationOperate.locationForm.form.data.longitude.data = location.longitude;
            }

            var deviceIDList = [];
            editDeviceLocation = true;
            $form.submit($scope.locationOperate.locationForm, {
              "REQUEST": "EDIT_DEVICE_LOCATION",
              "DATA": {
                deviceIDList: $scope.locationOperate.deviceIDList
              }
            }, function(data) {
              $scope.searchMsg.show = false;
              var newLocation = {
                "latitude": $scope.locationOperate.locationForm.form.data.latitude.data,
                "longitude": $scope.locationOperate.locationForm.form.data.longitude.data
              };

              for (var i = 0, len = $scope.locationOperate.deviceIDList.length; i < len; i++) {
                updateMarkerCoords($scope.locationOperate.deviceIDList[i], newLocation);
                updateLineToCoords($scope.locationOperate.deviceIDList[i], newLocation);
                updateDeviceCoords($scope.locationOperate.deviceIDList[i], newLocation);
              }

              if($scope.grid.data.length === 1){
                $scope.map.center = newLocation;
              }

              setZoom();
            });
          }
        },
        cancelBtn: {
          handler: function() {
            $form.clear($scope.locationOperate.locationForm);
            $scope.searchMsg.show = false;
          }
        },
        autoClose: false
      }

      function organizPlacesList(sourcePlacesList, targetList) {
        var i = 0,
          len = sourcePlacesList.length,
          options = [];

        for (; i < len; i++) {
          options.push({
            "formatted_address": sourcePlacesList[i]["formatted_address"],
            "latitude": sourcePlacesList[i]["geometry"].location.lat(),
            "longitude": sourcePlacesList[i]["geometry"].location.lng(),
            "key": i,
          });
        }
        $timeout(function() {
          targetList.options = options;
        }, 0);
      };

      $scope.locationOperate = {
        deviceIDList: [],
        locationForm: {},
        placesList: {
          fields: [{
            showName: "DEVICE.LOCATION_FOUND",
            name: "formatted_address"
              // },
              // {
              // 	showName: "DEVICE.LATITUDE",
              // 	name: "latitude"
              // },
              // {
              // 	showName: "DEVICE.LONGITUDE",
              // 	name: "longitude"
          }],
          showIndex: true,
          editable: true
        },
        mode: {
          options: [{
            name: "DEVICE.ADDRESS",
            value: "address"
          }, {
            name: "DEVICE.GPS",
            value: "gps"
          }],
          data: "address"
        },
        getPlaces: function() {
          if ($scope.locationOperate.searchTerm === "") {
            $scope.locationOperate.placesList.options = {};
            return;
          }
          $scope.searchBoxService.textSearch({
            query: $scope.locationOperate.searchTerm
          }, function(results, status) {
            if (status == google.maps.places.PlacesServiceStatus.OK) {
              organizPlacesList(results, $scope.locationOperate.placesList);
            }
          });
        },
        keypress: function(e) {
          if (e.keyCode === 13) {
            $scope.locationOperate.getPlaces();
          }
        }
      }

      var locationFormOptions = {
        proxy: {
          url: deviceUrl
        },
        fields: [{
          name: "latitude",
          allowBlank: false,
          vtype: "float_number"
        }, {
          name: "longitude",
          allowBlank: false,
          vtype: "float_number"
        }],
        autoLoad: false,
        validator: function(scope) {
          var latitude = $scope.locationOperate.locationForm.form.data.latitude.data,
            longitude = $scope.locationOperate.locationForm.form.data.longitude.data;

          if (latitude > 180 || latitude < -180 || longitude > 180 || longitude < -180) {
            $scope.searchMsg.msg_errtip = "ERROR_TIPS.LOCATION_OVERFLOW";
            return false;
          }
          $scope.locationOperate.locationForm.form.data.latitude.data = +latitude;
          $scope.locationOperate.locationForm.form.data.longitude.data = +longitude;
          return true;
        }
      };
      $form.config($scope.locationOperate.locationForm, locationFormOptions);

      $scope.$on("location", function(e, option) {
        $scope.searchMsg.msg_errtip = "";
        $scope.locationOperate.searchTerm = "";
        $scope.locationOperate.placesList.options = {};
        $scope.locationOperate.deviceIDList = option.deviceIDList;

        $scope.searchMsg.show = true;
      });

      $scope.$watch("grid.selectedIndexs", function(nV, oV) {
        if (nV !== oV && nV.length === 0) {
          angular.forEach(["wbs", "cpe"], function(name) {
            var i, marker;
            for (i in $scope[name + "Markers"].markersInstance) {
              marker = $scope[name + "Markers"].markersInstance[i];
              if (marker.model.selected) {
                marker.model.selected = false;
                marker.setIcon("theme/default/img/" + name + ".png");
              }
            }
          })
        }
      }, true);

    }
  ]);
} else if (window.googleMapApiInvalid === true) {
  pharosModule.controllerProvider.register("deviceMap", ["$scope", function($scope) {
    $scope.googleMapShow = false;
  }]);
} // end of if
