pharosModule.controllerProvider.register("firmware", [
    "$scope",
    '$q',
    '$proxy',
    '$user',
    '$url',
    '$grid',
    '$form',
    '$infoComm',
    '$timeout',
    '$tree',
    '$msg',
    '$toolBarSrv',
    '$tool',
    function($scope, $q, $proxy, $user, $url, $grid, $form, $infoComm, $timeout, $tree, $msg, $toolBarSrv, $tool) {
        var firmwareUrl = $url.format("/firmware/");

        var successPrompt = $msg.create({type: "success", text: "FORM.SUCCESS"});
        var failurePrompt = $msg.create({type: "failure", text: "FORM.FAILED"});

        function successHandler(responseData, requestData, uuid) {
            var operateName = requestData["new"]
                ? "new"
                : requestData["deleted"]
                    ? "deleted"
                    : "modified";
            var item;

            function deleteHandle(tree, delItem) {
                var queue = [],
                    node,
                    children;
                queue.push(tree);
                while (queue.length) {
                    node = queue.shift();
                    children = node.children;
                    if (children && children.length) {
                        for (var i = 0, len = children.length; i < len; i++) {
                            if (children[i].uuid === delItem.uuid) {
                                children.splice(i, 1);
                                return $timeout(function() {
                                    var elementsArray = $scope.information.treeNodeArrays[$scope.information.curScope];
                                    var i,
                                        curlevel,
                                        level,
                                        len = $scope.information.curTreeNodeIndex,
                                        $element;
                                    // curlevel = JSON.parse($scope.information.curElement.attr("data-curfolder")).level;
                                    var curFolderItem = $scope.information.curElement;
                                    // var curFolderSpan = angular.element(curFolderItem[0].querySelector(".currentfolder"));
                                    var curFolderSpan = curFolderItem;
                                    curlevel = JSON.parse(curFolderSpan.attr("data-curfolder")).level;
                                    for (i = len - 1; i > -1; i--) {
                                        $element = angular.element(elementsArray[i]);
                                        level = JSON.parse($element.attr("data-curfolder")).level;
                                        if (level > curlevel) {
                                            continue;
                                        } else {
                                            elementsArray[i].click();
                                            break;
                                        }
                                    };
                                }, 0);
                            } else {
                                queue.push(children[i]);
                            }
                        }
                    }
                }
            }
            switch (operateName) {
                case "new":
                    item = requestData["new"][0];
                    item["level"] = $scope.information.curFolder.level + 1;
                    $scope.information.curFolder.children.push(item);
                    break;
                case "deleted":
                    item = requestData["deleted"][0];
                    deleteHandle($scope.firmwareMenu.data.firmwareTree, item);
                    break;
                case "modified":
                    item = requestData["modified"][0];
                    $scope.information.curFolder.name = item.name;
                    $scope.information.curFolder.firmwareIDList = item.firmwareIDList;
                    break;
            }
            $infoComm.updateSlideGroup($scope, "firmware");
        }
        $scope.menuConfig = {
            editable: true,
            editrecursion: true,
            proxy: {
                url: firmwareUrl
            },
            editor: {
                fields: [
                    {
                        name: "name",
                        mapping: "name"
                    }, {
                        name: "firmwareIDList"
                    }
                ],
                request: "EDIT_FIRMWARE_TREE",
                success: successHandler
            }
        };
        $scope.firmwareMenu = {};
        $scope.information = {};
        $scope.information.curFolder = {};

        $scope.readText = "FIRMWARE.ADD";
        $scope.deleteText = "FIRMWARE.DELETE";
        $scope.editText = "FIRMWARE.EDIT";

        function traverseTree(tree, limit) {
            var queue = [],
                item,
                children;
            tree.level = 0;
            // tree.parent = null;
            queue.push(tree);
            while (queue.length) {
                item = queue.shift();
                children = item.children;
                if (item.level >= limit) {
                    item.isClosed = true;
                };
                if (children && children.length) {
                    for (var i = 0, len = children.length; i < len; i++) {
                        // children[i].parent = item;
                        children[i].level = item.level + 1;
                        queue.push(children[i]);
                    }
                }
            }
        }

        $tree.getTree("firmware", function(data) {
            data.firmwareTree.rde = "1-0-0";
            traverseTree(data.firmwareTree, 1);
            $scope.firmwareMenu.data = data;
            $infoComm.updateSlideGroup($scope, "firmware");
        })

        var gridOptions = {
            proxy: {
                url: firmwareUrl
            },
            key: "firmware",
            fields: [
                {
                    name: "filename",
                    mapping: "firmwareFileName"
                }, {
                    name: "software",
                    mapping: "version"
                }, {
                    name: "hardware",
                    mapping: "hardware"
                }, {
                    name: "date",
                    mapping: "uploadDate"
                }, {
                    name: "uploader",
                    mapping: "uploader"
                }, {
                    name: "firmwareID",
                    mapping: "firmwareID"
                }, {
                    name: "md5",
                    mapping: "MD5"
                }, {
                    name: "buildDate",
                    mapping: "buildDate"
                }, {
                    name: "description",
                    mapping: "description"
                }, {
                    name: "firmwareFilePath",
                    mapping: "firmwareFilePath"
                }, {
                    name: "firmwareFileUUID",
                    mapping: "firmwareFileUUID"
                }, {
                    name: "isActive",
                    mapping: "isActive"
                }, {
                    name: "machineType",
                    mapping: "machineType"
                }
            ]
        };
        $grid.config($scope, gridOptions);

        $scope.timeFormat2 = function(data) {
            return $tool.timeFormat2(data);
        };

        $scope.gridConfig = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "FIRMWARE.FILENAME",
                    name: "filename"
                }, {
                    show: "FIRMWARE.SOFTVERSION",
                    name: "software"
                }, {
                    show: "FIRMWARE.HARDVERSION",
                    name: "hardware"
                }, {
                    show: "FIRMWARE.UPLOADDATE",
                    name: "date",
                    format: $scope.timeFormat2
                }, {
                    show: "FIRMWARE.ACTIVE",
                    name: "isActive"
                }, {
                    show: "FIRMWARE.UPLOADER",
                    name: "uploader"
                }
            ],
            grouping: function(item) {
                return true;
            },
            showMoreList: false
        }

        $scope.dataGrouping = function(condition) {
            $scope.gridConfig.grouping = function(item) {
                var isArray = angular.isArray(condition);
                if (!isArray) {
                    return true;
                } else {
                    for (var i = 0, len = condition.length; i < len; i++) {
                        if (item.firmwareID.data == condition[i]) {
                            return true;
                        };
                    };
                }
            }
        }

        var operates = {};
        $scope.fileTipMsg = {
            title: "FIRMWARE.WARNING",
            content: "FIRMWARE.ERRORFILE",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                show: false
            }
        }

        $scope.fileSelect = {
            labeltext: "FIRMWARE.FILE_PATH",
            btntext: "FIRMWARE.BROWSE",
            errorFile: "FIRMWARE.ERRORFILE",
            showErrMsg: function(err_msg) {
                $timeout(function() {
                    $scope.fileTipMsg.content = "FIRMWARE.ERRORFILE";
                    if (err_msg) {
                        $scope.fileTipMsg.content = err_msg;
                    }
                    $scope.fileTipMsg.show = true;
                }, 0);
            },
            getCredentialId: function() {
                var credentialId = $user.getCookie("NAME")
                    ? $user.getCookie("NAME").split("&amp")[2]
                    : "";
                return credentialId;
            },
            validate: function(v) {
                if (!v) {
                    $scope.$broadcast("errShow");
                    return
                }
                var validArr = v.split(".");
                if (validArr[validArr.length - 1] !== "bin") {
                    $scope.$broadcast("errShow");
                } else {
                    $scope.$broadcast("errHide");
                }
            },
            closeMsg: function() {
                $scope.addFirmwareMsg.show = false;
            }
        }

        $scope.addFirmwareMsg = {
            title: "FIRMWARE.ADDFIRMWARE",
            okBtn: {
                handler: function() {
                    $scope.$broadcast("fileSubmit");
                }
            },
            cancelBtn: {
                handler: function() {
                    $scope.$broadcast("fileCancel");
                }
            },
            autoClose: false
        };
        operates.addFirmwareMsg = function() {
            $scope.addFirmwareMsg.show = true;
        }

        angular.forEach([/*"add",*/
            "delete",
            "activate",
            "deactivate"
        ], function(value, key) {
            $scope[value + "FirmwareMsg"] = {
                title: "FIRMWARE.CONFIRMATION",
                content: "FIRMWARE." + angular.uppercase(value) + "_CONTENT",
                okBtn: {
                    handler: function() {
                        var firmwareIDList = [],
                            activedIDList = [],
                            disActivedIDList = [];
                        for (var i = 0, len = $scope.grid.selectedIndexs.length; i < len; i++) {
                            var index = $scope.grid.selectedIndexs[i];
                            var item = $scope.grid.data[index];
                            firmwareIDList.push(item.key);
                            // if (item.isActive.data) {
                            //   activedIDList.push(item.key)
                            // } else {
                            //   disActivedIDList.push(item.key)
                            // }
                        }

                        switch (value) {
                            case "delete":
                                $infoComm.deleteIDList($scope, "firmware", firmwareIDList, function() {
                                    successPrompt.show();
                                }, function() {
                                    failurePrompt.show();
                                });
                                $scope.grid.selectedIndexs = [];
                                break;
                            case "activate":
                                // if (disActivedIDList.length !== 0) {
                                $infoComm.activateIDList($scope, "firmware", firmwareIDList, function(data) {
                                    $grid.loadData($scope, data, "load");
                                    successPrompt.show();
                                }, function() {
                                    failurePrompt.show();
                                });
                                $scope.grid.selectedIndexs = [];
                                // }
                                break;
                            case "deactivate":
                                // if (activedIDList.length !== 0) {
                                $infoComm.deactivateIDList($scope, "firmware", firmwareIDList, function(data) {
                                    $grid.loadData($scope, data, "load");
                                    successPrompt.show();
                                }, function() {
                                    failurePrompt.show();
                                });
                                $scope.grid.selectedIndexs = [];
                                // }
                                break;
                        }
                    }
                },
                cancelBtn: {
                    handler: function() {}
                }
            };
            operates[value + "FirmwareMsg"] = function() {
                if ($scope.grid.selectedIndexs && $scope.grid.selectedIndexs.length) {

                    var activedIDList = [],
                        disActivedIDList = [];
                    for (var i = 0, len = $scope.grid.selectedIndexs.length; i < len; i++) {
                        var index = $scope.grid.selectedIndexs[i];
                        var item = $scope.grid.data[index];
                        if (item.isActive.data) {
                            activedIDList.push(item.key)
                        } else {
                            disActivedIDList.push(item.key)
                        }
                    }

                    if (value === 'activate' && disActivedIDList.length === 0)
                        return;
                    if (value === 'deactivate' && activedIDList.length === 0)
                        return;

                    $scope[value + "FirmwareMsg"].show = true;
                } else {
                    // $scope.warningMsg.show = true;
                    return;
                }
            }
        });

        $scope.warningMsg = {
            title: "FIRMWARE.WARNING",
            content: "FIRMWARE.REMOVE_FROM_GROUP_NOTE",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                show: false
            }
        };

        operates.addToGroup = function(groupObj) {
            if ($scope.grid.selectedIndexs && $scope.grid.selectedIndexs.length) {
                $infoComm.addToGroup($scope, "firmware", groupObj, function(data) {
                    initMenuHandle(data);
                    successPrompt.show();
                }, function() {
                    failurePrompt.show();
                });
                $scope.grid.selectedIndexs = [];
            }
        }
        operates.removeFromGroup = function() {
            if ($scope.information.curFolder.name === "Firmwares") {
                $scope.warningMsg.show = true;
            } else {
                if ($scope.grid.selectedIndexs && $scope.grid.selectedIndexs.length) {
                    $infoComm.removeFromGroup($scope, "firmware", function(data) {
                        initMenuHandle(data);
                        successPrompt.show();
                    }, function() {
                        failurePrompt.show();
                    });
                    $scope.grid.selectedIndexs = [];
                }
            }
        }

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "FIRMWARE.DELETE",
                        className: "delete",
                        isDisabled: "disable",
                        operate: operates.deleteFirmwareMsg
                    }, {
                        name: "FIRMWARE.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: operates.activateFirmwareMsg
                    }, {
                        name: "FIRMWARE.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: operates.deactivateFirmwareMsg
                    }
                ],
                more: [
                    {
                        moreText: "FIRMWARE.MORE",
                        name: "FIRMWARE.ADD_TO_GROUP",
                        className: "add-to-group",
                        type: "expander",
                        operate: function() {},
                        slidehandle: operates.addToGroup,
                        slide: [],
                        slider_holder: "grouping"
                    }, {
                        name: "FIRMWARE.REMOVE_FROM_GROUP",
                        className: "remove",
                        operate: operates.removeFromGroup
                    }
                ]
            },
            // showIcon: false,
            others: [
                {
                    name: "FIRMWARE.ADD",
                    className: "add",
                    operate: operates.addFirmwareMsg
                }
            ]
        };

        $scope.toolbarConfig.operator.more.isDisabled = "disable";

        $scope.$watch("grid.data", function(newval, oldval) {
            if (newval != oldval) {
                $infoComm.updateRootIDList($scope, "firmware", newval);
                $timeout(function() {
                    $scope.firmwareMenu.data.firmwareTree.firmwareNumber = newval.length;
                    $scope.information.curElement && $scope.information.curElement[0].click();
                    if ($scope.information.curFolder && $scope.information.curFolder.children && $scope.information.curFolder.children.length) {
                        $scope.information.curElement && $scope.information.curElement[0].click();
                    }
                }, 0);
            }
        })

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                })
                if (nVal.length) {
                    $toolBarSrv.setEnable($scope.toolbarConfig);
                }

                var hasActived = false;
                var hasDisActived = false;
                for (var i = 0, len = nVal.length; i < len; i++) {
                    var item = $scope.grid.data[nVal[i]];
                    if (item.isActive.data) {
                        hasActived = true;
                    } else {
                        hasDisActived = true;
                    }
                }

                if (hasActived && !hasDisActived) {
                    // actived only
                    $scope.toolbarConfig.operator.show[1].isDisabled = "disable";
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                } else if (!hasActived && hasDisActived) {
                    // disactived only
                    $scope.toolbarConfig.operator.show[1].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[2].isDisabled = "disable";
                } else {
                    $scope.toolbarConfig.operator.show[1].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                }

                // 没有选择任何项的情形应置于末尾
                if (nVal.length === 0) {
                    $toolBarSrv.setDisable($scope.toolbarConfig);
                }
            }
        }, true);

        function initMenuHandle(data) {
            data.firmwareTree.rde = "1-0-0";
            traverseTree(data.firmwareTree, 1);
            $scope.firmwareMenu.data = data;
            $infoComm.updateSlideGroup($scope, "firmware");
            $infoComm.updateRootIDList($scope, "firmware", $scope.grid.data); // 手动update
        }

        $scope.firmwareList = {
            fields: [
                {
                    showName: "FIRMWARE.FILENAME",
                    name: "filename"
                }, {
                    showName: "FIRMWARE.MACHINE_TYPE",
                    name: "machineType"
                }, {
                    showName: "FIRMWARE.VERSION",
                    name: "software"
                }
            ],
            editable: true
        }
        $scope.information.updateAdd = function() {
            var treename = $scope.information.treename;
            if (treename == "firmwareTree") {
                $scope.firmwareMenu.form.data.firmwareIDList = {
                    data: []
                };
                return "firmwareInfoTree"
            }
        };
        $scope.information.updateEdit = function() {
            var treename = $scope.information.treename;
            var curfolder,
                item,
                idList,
                i,
                j,
                ilen,
                jlen;
            var options = [],
                option,
                selectedData,
                gridData;
            if (treename == "firmwareTree") {
                curfolder = $scope.information.curFolder;
                idList = curfolder["firmwareIDList"];
                if (idList.length) {
                    for (i = 0, ilen = idList.length; i < ilen; i++) {
                        gridData = $scope.grid.data;
                        for (j = 0, jlen = gridData.length; j < jlen; j++) {
                            if (idList[i] == gridData[j].key) {
                                selectedData = gridData[j];
                                break;
                            }
                        }
                        option = {};
                        option["filename"] = selectedData["filename"].data;
                        option["machineType"] = selectedData["machineType"].data;
                        option["software"] = selectedData["software"].data;
                        option.key = selectedData.key;
                        options.push(option);
                        $scope.firmwareList.options = options;
                    }
                    $scope.firmwareList.data = idList;
                };
                $scope.firmwareMenu.form.data.name.data = $scope.information.curFolder.name;
                if ($scope.firmwareMenu.form.data.firmwareIDList.data === "") {
                    $scope.firmwareMenu.form.data.firmwareIDList.data = [];
                }
            };
        };

        // 顶级目录没有 edit 或者 del 功能
        $scope.information.cant = function() {
            if ($scope.information.curFolder.level === 0)
                return true;
            return false;
        }

    }
]);
