pharosModule.controllerProvider.register("log", [
    "$scope",
    "$proxy",
    "$url",
    "$grid",
    "$tool",
    "$form",
    "$http",
    "$user",
    "$timeout",
    "$interval",
    "$toolBarSrv",
    function($scope, $proxy, $url, $grid, $tool, $form, $http, $user, $timeout, $interval, $toolBarSrv) {
        var logUrl = $url.format("/log/");

        // 清空遗留的 toptool
        angular.element(document.getElementById("menubar-container")).empty();
        $scope.logMenu = {};
        $scope.information = {};
        $scope.information.curFolder = {};
        $scope.logMenu.data = {
            logTree: {
                "children": [
                    {
                        "name": "LOG.LOG",
                        "type": "log",
                        "isLeaf": true,
                        "uuid": "LOG"
                    }, {
                        "name": "LOG.EVENT",
                        "type": "event",
                        "isLeaf": true,
                        "uuid": "EVENT"
                    }, {
                        "name": "LOG.ERROR",
                        "type": "error",
                        "isLeaf": true,
                        "uuid": "ERROR"
                    }, {
                        "name": "LOG.DEBUG",
                        "type": "debug",
                        "isLeaf": true,
                        "uuid": "DEBUG"
                    }
                ],
                "name": "LOG.ALLLOGS",
                "type": "all",
                "uuid": "ALLLOGS"
            }
        };
        $scope.menuConfig = {
            editable: false
        };

        var timeFormat = function(data) {
            if (data && data.time) {
                return $tool.timeFormat(data.time);
            }
        };

        function timeformat2(date) {
            var time = new Date(date.time);
            var hour = time.getHours();
            var minutes = time.getMinutes();
            minutes = minutes < 10
                ? "0" + minutes
                : minutes;
            hour = hour < 10
                ? "0" + hour
                : hour;
            return time.toLocaleDateString() + " " + hour + ":" + minutes;
        }

        $scope.timeFormat2 = function(data) {
            return $tool.timeFormat2(data);
        };

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "LOG.TIME",
                    name: "createDate",
                    format: $scope.timeFormat2
                }, {
                    show: "LOG.MESSAGE",
                    name: "logString"
                }, {
                    show: "LOG.TYPE",
                    name: "eventType"
                }, {
                    show: "LOG.DEVICENAME",
                    name: "deviceName"
                }, {
                    show: "LOG.MAC_ADDRESS",
                    name: "macAddress"
                }, {
                    show: "LOG.IP_ADDRESS",
                    name: "ipAddress"
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        $scope.dataGroup = function(type) {
            $scope.gridConfig.grouping = function(item) {
                if (type == "all" || type == angular.lowercase(item.eventType.data)) {
                    return true;
                }
            }
        };

        var options = {
            proxy: {
                url: logUrl
            },
            key: "log",
            fields: [
                {
                    name: "createDate"
                }, {
                    name: "deviceName"
                }, {
                    name: "macAddress"
                }, {
                    name: "ipAddress"
                }, {
                    name: "eventType"
                }, {
                    name: "logString"
                }
            ],
            autoLoad: false
        };
        $grid.config($scope, options);

        $scope.grid.load({
            // "timezoneOffset": (new Date()).getTimezoneOffset()
        }, function(data) {
            initGridData(data);
        }, function() {}, function() {});

        function initGridData(res) {
            var data = res["data"] || [];
            initSearchItems(data);
            if (data && data.length) {
                for (var index = 0, len = data.length; index < len; index++) {
                    $scope.grid.data[index].deviceName.data = "";
                    $scope.grid.data[index].macAddress.data = "";
                    $scope.grid.data[index].ipAddress.data = "";

                    if (angular.isDefined(data[index].deviceString)) {
                        var device = data[index].deviceString.device;
                        if (device) {
                            $scope.grid.data[index].deviceName.data = angular.isDefined(device.deviceName)
                                ? device.deviceName
                                : "";
                            $scope.grid.data[index].macAddress.data = angular.isDefined(device.macAddress)
                                ? device.macAddress
                                : "";
                            $scope.grid.data[index].ipAddress.data = angular.isDefined(device.ipAddress)
                                ? device.ipAddress
                                : "";
                        }
                    }
                }
                initDeleteFormStartTime(res["firstLog"].createDate);
                updateFirstlog(res["firstLog"]);

                $scope.exportForm.form.data.startTime.data = {};
                $scope.exportForm.form.data.startTime.data.time = res["firstLog"].createDate.time;
                $scope.exportForm.form.data.startTime.data.timezoneOffset = res["firstLog"].createDate.timezoneOffset;
            }
        }

        function initDeleteFormStartTime(createDate) {
            $scope.deleteForm.form.data.startTime.data = {};
            $scope.deleteForm.form.data.startTime.data.time = createDate.time;
            $scope.deleteForm.form.data.startTime.data.timezoneOffset = createDate.timezoneOffset;
        }

        function updateFirstlog(firstlog) {
            $scope.firstLog = firstlog;
        }

        // delete log
        $scope.showDeleteType = true;
        var delLog = function() {
            // var selectedIndexs = $scope.grid.selectedIndexs;
            // if (selectedIndexs.length) {
            //     $scope.grid.startRemove(selectedIndexs);
            // }
            $scope.deleteMsg.msg_errtip = "";
            initDeleteFormStartTime($scope.firstLog.createDate);
            $scope.deleteMsg.show = true;
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.showDeleteType = true;
                $scope.deleteForm.deleteType = "selected";
            } else {
                $scope.showDeleteType = false;
                $scope.deleteForm.deleteType = "interval";
            }
        };
        $scope.deleteForm = {};
        $scope.deleteForm.deleteType = "selected";
        $form.config($scope.deleteForm, {
            proxy: {
                url: logUrl
            },
            fields: [
                {
                    name: "startTime"
                }, {
                    name: "endTime"
                }
            ],
            autoLoad: false
        })

        $scope.deleteMsg = {
            title: "LOG.DELETE",
            okBtn: {
                handler: function() {
                    var selectedIndexs = $scope.grid.selectedIndexs;
                    var data = {
                        "deleteType": $scope.deleteForm.deleteType
                    }
                    switch ($scope.deleteForm.deleteType) {
                        case "selected":
                            if (selectedIndexs.length) {
                                var _data = [];
                                for (var i = 0; i < selectedIndexs.length; i++) {
                                    _data.push($scope.grid.data[selectedIndexs[i]].key)
                                }
                                data["logIDList"] = _data;
                            }
                            break;
                        case "interval":
                            var startTime = $scope.deleteForm.form.data.startTime.data;
                            var endTime = $scope.deleteForm.form.data.endTime.data;
                            if (startTime.time >= endTime.time) {
                                $scope.deleteMsg.msg_errtip = "LOG.TIME_INVALID";
                                return;
                            }

                            data["startTime"] = startTime;
                            data["endTime"] = endTime;
                            break;
                        case "all":
                            break;
                    }

                    $proxy.request({
                        url: logUrl
                    }, {
                        "REQUEST": "DELETE_LOG",
                        "DATA": data
                    }, function(data, other) {
                        $scope.grid.loadData(data, "load");
                        $form.clear($scope.deleteForm);
                        $scope.deleteMsg.show = false;
                        $timeout(function() {
                            initGridData(data);
                        }, 100);
                    }, function(errMsg, data) {
                        $form.clear($scope.deleteForm);
                        $scope.deleteMsg.show = false;
                    });
                }
            },
            cancelBtn: {
                handler: function() {
                    $form.clear($scope.deleteForm);
                    $scope.deleteMsg.show = false;
                }
            },
            autoClose: false
        }

        // export log
        $scope.exportForm = {};
        var exportOptions = {
            proxy: {
                url: logUrl
            },
            fields: [
                {
                    name: "startTime",
                    allowBlank: false,
                    allowEmptyObject: false
                }, {
                    name: "endTime",
                    allowBlank: false,
                    allowEmptyObject: false
                }
            ],
            autoLoad: false
        };
        $form.config($scope.exportForm, exportOptions);

        $scope.exportLogMsg = {
            title: "LOG.EXPORT",
            okBtn: {
                handler: function() {
                    if (!$form.validate($scope.exportForm)) {
                        return;
                    }
                    var startData = $scope.exportForm.form.data.startTime.data.time;
                    var endData = $scope.exportForm.form.data.endTime.data.time;

                    var _startDate = new Date(startData);
                    _startDate.setSeconds(0);
                    _startDate.setMilliseconds(0);

                    var _endDate = new Date(endData);
                    _endDate.setSeconds(59);
                    _endDate.setMilliseconds(999);

                    $scope.exportForm.form.data.startTime.data.time = _startDate.getTime();
                    $scope.exportForm.form.data.endTime.data.time = _endDate.getTime();
                    startData = _startDate.getTime();
                    endData = _endDate.getTime();

                    if (startData > endData) {
                        $scope.exportLogMsg.msg_errtip = "LOG.TIME_INVALID";
                        return;
                    }
                    var credentialId = $user.getCookie("NAME")
                        ? $user.getCookie("NAME").split("&amp")[2]
                        : "";
                    var inputArr = $scope.logForm.find("input");
                    angular.element(inputArr[0]).val(credentialId);
                    angular.element(inputArr[1]).val(startData);
                    angular.element(inputArr[2]).val(endData);
                    angular.element(inputArr[3]).val((new Date()).getTimezoneOffset());

                    var logType = $scope.information.curFolder.type;
                    angular.element(inputArr[4]).val(logType);
                    angular.element(inputArr[5]).val(getIDListOfSearching());

                    $scope.logForm.find("button")[0].click();
                    $scope.exportLogMsg.show = false;
                }
            },
            cancelBtn: {
                handler: function() {
                    $scope.exportLogMsg.show = false;
                    $form.setNormal($scope.exportForm);
                    $scope.exportLogMsg.msg_errtip = "";
                }
            },
            autoClose: false
        };

        var exportLog = function() {
            if (!$scope.logForm) {
                $scope.logForm = angular.element(document.getElementById('logForm'));
                $scope.logForm.attr("action", "/download/");
            }
            $scope.exportLogMsg.show = true;
        };

        $scope.$watch("exportLogMsg.show", function(nV, oV) {
            if (nV !== oV) {
                if (!nV) {
                    // $scope.exportForm.form.data.startTime.data = "";
                    // $scope.exportForm.form.data.endTime.data = "";
                }
            }
        })

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "LOG.DEL",
                        className: "delete",
                        isDisabled: "enable",
                        operate: delLog
                    }
                ]
            },
            others: [
                {
                    name: "LOG.EXPORT",
                    className: "export",
                    operate: exportLog
                }
            ]
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                })
                if (nVal.length) {
                    // $toolBarSrv.setEnable($scope.toolbarConfig);
                } else {
                    // $toolBarSrv.setDisable($scope.toolbarConfig);
                }
            }
        }, true);

        function getListInfo(scope, data) {
            var i,
                len,
                item;
            len = data.length;
            scope.information.listInfo = {
                allNum: len,
                logNum: 0,
                eventNum: 0,
                errorNum: 0,
                debugNum: 0
            };
            for (i = 0; i < len; i++) {
                item = data[i];
                switch (item.eventType.data) {
                    case "LOG":
                        scope.information.listInfo.logNum++;
                        break;
                    case "EVENT":
                        scope.information.listInfo.eventNum++;
                        break;
                    case "ERROR":
                        scope.information.listInfo.errorNum++;
                        break;
                    case "DEBUG":
                        scope.information.listInfo.debugNum++;
                        break;
                }
            }
        }

        function formatNum(str, num) {
            if (!str)
                return;
            var index = str.indexOf("\("),
                string;
            if (index === -1) {
                string = str + "(" + num + ")";
            } else {
                string = str.slice(0, index) + "(" + num + ")";
            }
            return string;
        }

        function updateLogNum(scope, data) {
            var arr,
                all,
                log,
                events,
                error,
                debug,
                listInfo;
            getListInfo(scope, data);
            if (!scope.information.logmenu_arr || scope.information.logmenu_arr.length === 0) {
                scope.information.logmenu_arr = [];
                angular.forEach(angular.element(document.getElementById("log-menu")).find("span"), function(value) {
                    var $value = angular.element(value);
                    if ($value.hasClass("currentfolder")) {
                        scope.information.logmenu_arr.push(value);
                    }
                })
            }
            arr = scope.information.logmenu_arr;
            all = angular.element(arr[0]);
            log = angular.element(arr[1]);
            events = angular.element(arr[2]);
            error = angular.element(arr[3]);
            debug = angular.element(arr[4]);

            listInfo = scope.information.listInfo;
            all.html(formatNum(all.html(), listInfo.allNum));
            log.html(formatNum(log.html(), listInfo.logNum));
            events.html(formatNum(events.html(), listInfo.eventNum));
            error.html(formatNum(error.html(), listInfo.errorNum));
            debug.html(formatNum(debug.html(), listInfo.debugNum));
        }

        var updateLogNumId = $interval(function() {
            updateLogNum($scope, $scope.grid.data);
        }, 1000);

        $scope.$on("$destroy", function() {
            $interval.cancel(updateLogNumId);
        });

        $scope.$watch("grid.data", function(nV, oV) {
            if (nV !== oV) {
                // $timeout(function() {
                updateLogNum($scope, nV);
                // }, 200);
            }
        });

        $scope.searchStr = "";
        $scope.$on("onSearching", function(e, data) {
            $scope.searchStr = data[0];
        })
        $scope.$on("stopSearching", function() {
            $scope.searchStr = "";
        })

        function initSearchItems(data) {
            $scope.searchObj = [];
            var i = 0,
                len = data.length;
            for (; i < len; i++) {
                var item = data[i];
                var timeStr = $scope.timeFormat2(item.createDate);
                var messageStr = item.logString;
                var typeStr = item.eventType;

                var deviceNameStr = "";
                var macAddressStr = "";
                var ipAddressStr = "";
                if (angular.isDefined(item.deviceString)) {
                    var device = item.deviceString.device;
                    if (device) {
                        deviceNameStr = angular.isDefined(device.deviceName)
                            ? device.deviceName
                            : "";
                        macAddressStr = angular.isDefined(device.macAddress)
                            ? device.macAddress
                            : "";
                        ipAddressStr = angular.isDefined(device.ipAddress)
                            ? device.ipAddress
                            : "";
                    }
                }

                $scope.searchObj.push({
                    "logID": item.logID,
                    "logStr": [
                        timeStr,
                        messageStr,
                        typeStr,
                        deviceNameStr,
                        macAddressStr,
                        ipAddressStr
                    ]
                });
            }
        }

        function getIDListOfSearching() {
            if ($scope.searchStr === "") {
                return "nosearch";
            }
            var logIDList = [];
            var searchText = $scope.searchStr;
            var pattern = new RegExp(searchText, "i");
            var curlogType = $scope.information.curFolder.type;

            var i = 0,
                len = $scope.searchObj.length;
            for (; i < len; i++) {
                var item = $scope.searchObj[i];
                var j,
                    jlen = item.logStr.length;

                if (curlogType !== "all" && angular.lowercase(item.logStr[2]) !== curlogType) {
                    continue;
                }

                for (j = 0; j < jlen; j++) {
                    if (pattern.test(item.logStr[j])) {
                        logIDList.push(item.logID);
                        break;
                    }
                }
            }
            return logIDList.toString();
        }
    }
]);
