var pharosModule = angular.module('pharoscontrol', ['pascalprecht.translate', 'pharosComm']);

pharosModule.run(["$translate", function($translate) {

}]);

pharosModule.controller("login", ["$rootScope", "$scope", "$form", "$proxy", "$url", "$user","$translate", "$timeout",
  function($rootScope, $scope, $form, $proxy, $url, $user, $translate, $timeout) {
    var loginUrl = $url.format("/login/");

    var options = {
      proxy: {
        url: loginUrl
      },
      fields: [{
        name: "username",
        allowBlank: false
      }, {
        name: "password",
        allowBlank: false,
        encryption: {
          name: "hex_sha1"
        }
      }],
      autoLoad: false
    };
    $form.config($scope, options);

    // $scope.form.data.password.encryption = {
    //
    // };

    $scope.errMsg = "";
    $scope.loginErr = false;

    $scope.login = function() {
      if ($user.checkCookie()) {
        $form.submit($scope, {
          "REQUEST": "LOGIN"
        }, function(data) {
          $user.setCookie(angular.extend(data, {
            "name": $scope.form.data.username.data
          }));
          location.href = "./";
        }, function(errMsg) {
          $scope.loginErr = false;
          $timeout(function(){
            $scope.errMsg = $translate.instant(errMsg);
            $scope.loginErr = true;
          }, 10);
        }, function(status) {});
      }
    };

    $scope.cookieMsg = {
      content: "LOGIN.COOKIE_ALERT",
      cancelBtn: {
        show: false
      },
      size: "sm"
    };
    // check cookie
    if (!$user.checkCookie()) {
      $scope.cookieMsg.show = true;
    }

  }
]);
