pharosModule.controllerProvider.register("task", [
    "$scope",
    "$proxy",
    "$translate",
    "$tool",
    "$url",
    "$interval",
    function($scope, $proxy, $translate, $tool, $url, $interval) {
        // $scope.type = "completed";
        var taskUrl = $url.format("/task/");
        // toptool
        angular.element(document.getElementById("menubar-container")).empty();

        $scope.taskMenu = {};
        $scope.information = {};
        $scope.information.curFolder = {};
        $scope.taskMenu.data = {
            taskTree: {
                "children": [
                    {
                        "name": "TASK.SCHEDULED",
                        "type": "scheduled",
                        "isLeaf": true,
                        "uuid": "SCHEDULED"
                    }, {
                        "name": "TASK.RUNNING",
                        "type": "running",
                        "isLeaf": true,
                        "uuid": "RUNNING"
                    }, {
                        "name": "TASK.COMPLETED",
                        "type": "completed",
                        "isLeaf": true,
                        "uuid": "COMPLETED"
                    }, {
                        "name": "TASK.FAILED",
                        "type": "failed",
                        "isLeaf": true,
                        "uuid": "FAILED"
                    }
                ],
                "name": "TASK.TASKS",
                "type": "scheduled",
                "uuid": "TASKS"
            }
        };
        $scope.menuConfig = {
            editable: false
        };
        $scope.changeType = function(type) {
            $scope.type = type;
        };

        $scope.timeFormat = function(data) {
            if (data && data.time) {
                return $tool.timeFormat(data.time);
            }
        };

        $scope.timeFormat2 = function(data) {
            return $tool.timeFormat2(data);
        };

        $scope.information.listInfo = {
            all: 0,
            scheduled: 0,
            running: 0,
            completed: 0,
            failed: 0
        }

        function formatNum(str, num) {
            if (!str)
                return;
            var index = str.indexOf("\("),
                string;
            if (index === -1) {
                string = str + "(" + num + ")";
            } else {
                string = str.slice(0, index) + "(" + num + ")";
            }
            return string;
        }

        function updateTaskNum() {
            var arr,
                task;
            var scheduled = $scope.information.listInfo.scheduled,
                running = $scope.information.listInfo.running,
                completed = $scope.information.listInfo.completed,
                failed = $scope.information.listInfo.failed;
            $scope.information.listInfo.all = scheduled + running + completed + failed;

            if (!$scope.information.taskmenu_arr || $scope.information.taskmenu_arr.length !== 5) {
                $scope.information.taskmenu_arr = [];
                angular.forEach(angular.element(document.getElementById("task-menu")).find("span"), function(value) {
                    var $value = angular.element(value);
                    if ($value.hasClass("currentfolder")) {
                        $scope.information.taskmenu_arr.push(value);
                    }
                })
            }
            if ($scope.information.taskmenu_arr.length !== 5) {
                return;
            }
            arr = $scope.information.taskmenu_arr;
            task = angular.element(arr[0]);
            scheduled = angular.element(arr[1]);
            running = angular.element(arr[2]);
            completed = angular.element(arr[3]);
            failed = angular.element(arr[4]);

            listInfo = $scope.information.listInfo;
            task.html(formatNum(task.html(), listInfo.all));
            scheduled.html(formatNum(scheduled.html(), listInfo.scheduled));
            running.html(formatNum(running.html(), listInfo.running));
            completed.html(formatNum(completed.html(), listInfo.completed));
            failed.html(formatNum(failed.html(), listInfo.failed));
        }

        var taskInterval = $interval(function() {
            angular.forEach({
                scheduled: "GET_SCHEDULE_LIST",
                running: "GET_RUNNING_TASK",
                completed: "GET_COMPLETED_TASK",
                failed: "GET_FAILED_TASK"
            }, function(value, key) {
                $proxy.request({
                    url: taskUrl
                }, {
                    "REQUEST": value
                }, function(data) {
                    $scope.information.listInfo[key] = data.length;
                    updateTaskNum();
                })
            });
        }, 3000);

        $scope.$watch("child.grid.data", function(nV, oV) {
            if (nV !== oV) {
                $scope.information.listInfo[$scope.type] = nV.length;
                updateTaskNum();
            }
        });

        $scope.$watch("type", function(nV, oV) {
            if (nV !== oV && $scope.child != undefined) {
                if (nV !== "scheduled") {
                    $scope.$broadcast("cancel_scheduledInterval");
                }

                if (nV !== "running") {
                    $scope.child.runningInterval && $interval.cancel($scope.child.runningInterval);
                }

                if (nV !== "completed") {
                    $scope.child.completedInterval && $interval.cancel($scope.child.completedInterval);
                }

                if (nV !== "failed") {
                    $scope.child.failedInterval && $interval.cancel($scope.child.failedInterval);
                }
            }
        });

        $scope.$on("$destroy", function() {
            $interval.cancel(taskInterval);
            if ($scope.type) {
                var intervalName = $scope.type + "Interval";
                $interval.cancel($scope.child[intervalName]);
            }
        })

    }
]);

pharosModule.controllerProvider.register("scheduledTask", [
    "$scope",
    "$translate",
    "$proxy",
    "$interval",
    "$url",
    "$grid",
    "$form",
    "$filter",
    "$tool",
    "$q",
    "$timeout",
    '$msg',
    '$toolBarSrv',
    function($scope, $translate, $proxy, $interval, $url, $grid, $form, $filter, $tool, $q, $timeout, $msg, $toolBarSrv) {
        var taskUrl = $url.format("/task/");
        var devcieUrl = $url.format("/device/");
        var firmwareUrl = $url.format("/firmware/");

        $scope.$parent.$parent.child = $scope;

        var successPrompt = $msg.create({type: "success", text: "FORM.SUCCESS"});

        var failurePrompt = $msg.create({type: "failure", text: "FORM.FAILED"});

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "TASK.NAME",
                    name: "scheduleName"
                }, {
                    show: "TASK.ACTION",
                    name: "taskType"
                }, {
                    show: "TASK.CREATE_TIME",
                    name: "createDate",
                    format: $scope.timeFormat2
                }, {
                    show: "TASK.START_TIME",
                    name: "startDate",
                    format: $scope.timeFormat2
                }, {
                    show: "TASK.FINISH_TIME",
                    name: "endDate",
                    format: $scope.timeFormat2
                }, {
                    show: "TASK.SCHEDULER",
                    name: "creator"
                }, {
                    show: "TASK.STATUS",
                    name: "isActive",
                    format: function(data) {
                        if (data === true) {
                            return $translate.instant("TASK.ACTIVE");
                        } else {
                            return $translate.instant("TASK.INACTIVE");
                        }
                    }
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: taskUrl
            },
            key: "schedule",
            fields: [
                {
                    name: "createDate"
                }, {
                    name: "creator"
                }, {
                    name: "endDate"
                }, {
                    name: "isActive"
                }, {
                    name: "period"
                }, {
                    name: "scheduleName"
                }, {
                    name: "startDate"
                }, {
                    name: "taskJsonString"
                }, {
                    name: "taskType"
                }
            ],
            editor: {
                fields: [
                    {
                        name: "scheduleName",
                        allowBlank: false
                    }, {
                        name: "startDate",
                        allowBlank: false,
                        allowEmptyObject: false
                    }, {
                        name: "endDate",
                        allowEmptyObject: false
                    }, {
                        name: "periodType"
                    }, {
                        name: "periodDate"
                    }, {
                        name: "periodTimeH",
                        allowBlank: false,
                        vtype: {
                            vtype: "number",
                            config: {
                                max: 23,
                                min: 0
                            }
                        }
                    }, {
                        name: "periodTimeM",
                        allowBlank: false,
                        vtype: {
                            vtype: "number",
                            config: {
                                max: 59,
                                min: 0
                            }
                        }
                    }, {
                        name: "taskType"
                    }
                ],
                validator: function() {
                    if ($scope.form.data.taskType.data !== "DISCOVERY") {
                        if ($scope.form.data.taskType.data == "UPGRADE") {
                            if (!$scope.form.data.pairList.data || !$scope.form.data.pairList.data.length) {
                                return false;
                            }
                        } else {
                            if (!$scope.form.data.deviceIDList.data || !$scope.form.data.deviceIDList.data.length) {
                                return false;
                            }
                        }
                    }
                    return true;
                }
            }
        };
        $grid.config($scope, options);

        $scope.comfirmMsg = {
            title: "FORM.CONFIRMATION",
            content: "",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                handler: function() {}
            }
        };

        var activateTask = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                var schedules = [];
                // need filter schedules ?
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    if ($scope.grid.data[selectedIndexs[index]].isActive.data == false) {
                        var currentTime = new Date();
                        currentTime = Date.parse(currentTime);
                        // if ($scope.grid.data[selectedIndexs[index]].startDate.data.time > currentTime) {
                        schedules.push($scope.grid.data[selectedIndexs[index]].key);
                        // }
                    }
                }
                if (schedules.length) {
                    $scope.comfirmMsg.content = "TASK.ACTIVATE_CONFIRM";
                    $scope.comfirmMsg.show = true;
                    $scope.comfirmMsg.okBtn.handler = function() {
                        $proxy.request({
                            url: taskUrl
                        }, {
                            "REQUEST": "ACTIVATE_SCHEDULE",
                            "DATA": {
                                "scheduleIDList": schedules
                            }
                        }, function(data) {
                            $scope.grid.loadData(data, "load");
                            successPrompt.show();
                        }, function() {
                            failurePrompt.show();
                        }, function() {
                            failurePrompt.show();
                        });
                    }
                }
            }
        };

        var deactivateTask = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            var schedules = [];

            if (selectedIndexs.length) {
                // need filter schedules ?
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    if ($scope.grid.data[selectedIndexs[index]].isActive.data) {
                        schedules.push($scope.grid.data[selectedIndexs[index]].key);
                    }
                }
                if (schedules.length) {
                    $scope.comfirmMsg.content = "TASK.DEACTIVATE_CONFIRM";
                    $scope.comfirmMsg.show = true;
                    $scope.comfirmMsg.okBtn.handler = function() {
                        $proxy.request({
                            url: taskUrl
                        }, {
                            "REQUEST": "DEACTIVATE_SCHEDULE",
                            "DATA": {
                                "scheduleIDList": schedules
                            }
                        }, function(data) {
                            $scope.grid.loadData(data, "load");
                            successPrompt.show();
                        }, function() {
                            failurePrompt.show();
                        }, function() {
                            failurePrompt.show();
                        });
                    }
                }
            }
        };

        var runTask = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            var schedules = [];
            if (selectedIndexs.length) {
                // need filter schedules ?
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    if ($scope.grid.data[selectedIndexs[index]].isActive.data) {
                        var currentTime = new Date();
                        if ($scope.grid.data[selectedIndexs[index]].startDate.data.time > Date.parse(currentTime)) {
                            schedules.push($scope.grid.data[selectedIndexs[index]].key);
                        }
                    }
                }
                if (schedules.length) {
                    $scope.comfirmMsg.content = "TASK.RUN_CONFIRM";
                    $scope.comfirmMsg.show = true;
                    $scope.comfirmMsg.okBtn.handler = function() {
                        $proxy.request({
                            url: taskUrl
                        }, {
                            "REQUEST": "RUN_SCHEDULE_NOW",
                            "DATA": {
                                "scheduleID": schedules[0]
                            }
                        }, function() {}, function() {}, function() {});
                    }
                }
            }
        };

        var delSchedule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startRemove(selectedIndexs);
            }
        };

        var allDevices = [];
        $proxy.request({
            url: devcieUrl
        }, {
            "REQUEST": "GET_DEVICE_TREE"
        }, function(data) {
            // get device group
            var options = [];
            options.push({name: "TASK.ALLDEVICES", value: "all"});
            for (var tree in data) {
                for (var index = 0, len = data[tree].children.length; index < len; index++) {
                    var option = {};
                    var name = data[tree].children[index].name;
                    if (angular.uppercase(name) === "MANAGED" || angular.uppercase(name) === "UNMANAGED") {
                        continue;
                    }
                    option.name = name;
                    if (angular.isDefined(data[tree].children[index].deviceIDList)) {
                        option.value = data[tree].children[index].deviceIDList;
                    } else {
                        option.value = data[tree].children[index].expression;
                    }
                    options.push(option);
                }
            }
            $scope.form.deviceGroup.options = options;
        }, function() {}, function() {});
        var deviceDef = $q.defer();
        var firmwareDef = $q.defer();
        var promises = [];
        promises.push(deviceDef.promise, firmwareDef.promise);
        $proxy.request({
            url: devcieUrl
        }, {
            "REQUEST": "GET_DEVICE_LIST"
        }, function(data) {
            allDevices = data;
            deviceDef.resolve(data);
        }, function() {}, function() {});

        var allFirmware = [];
        $proxy.request({
            url: firmwareUrl
        }, {
            "REQUEST": "GET_FIRMWARE_LIST"
        }, function(data) {
            allFirmware = data;
            firmwareDef.resolve(data);
        }, function() {}, function() {});

        $q.all(promises).then(function(data) {
            var devices = data[0];
            var firmwares = data[1];

            if (devices.length && firmwares.length) {
                for (var index = 0, len = devices.length; index < len; index++) {
                    var defaultData = "";
                    var product = devices[index].product;
                    var version = devices[index].version;
                    var firmwareOptions = [];
                    var firmwareID = {};

                    for (var findex = 0, flen = firmwares.length; findex < flen; findex++) {
                        var firmwareDevices = firmwares[findex].description.split(";");
                        firmwareDevices.pop();

                        if (firmwareDevices.indexOf(product) !== -1) {
                            if(false === firmwares[findex].isActive){
                              continue;
                            }

                            var firmwareOption = {};
                            firmwareOption.name = firmwares[findex].firmwareFileName;
                            firmwareOption.value = firmwares[findex].firmwareID;

                            if (firmwares[findex].version + " Build " + firmwares[findex].buildDate === version) {
                                // firmwareOption.name += $translate.instant("DEVICE.INUSE");
                                defaultData = firmwareOption.value;
                            }
                            firmwareOptions.push(firmwareOption);
                        }
                    }
                    firmwareID.options = firmwareOptions;
                    firmwareID.data = defaultData
                        ? defaultData
                        : firmwareOptions.length !== 0
                            ? firmwareOptions[0].value
                            : "";

                    allDevices[index].firmwares = firmwareID;
                }
            }
        });

        $scope.scheduleMsg = {
            title: "TASK.ADDSCHEDULE",
            okBtn: {
                handler: function() {
                    var periodParts = ["periodType", "periodDate", "periodTimeH", "periodTimeM"];
                    var expanderData = {};
                    var serials = [];
                    if ($scope.form.data.taskType.data === "UPGRADE") {
                        // need filter
                        expanderData["pairList"] = $scope.form.data.pairList.data;
                    } else if ($scope.form.data.taskType.data == "REBOOT") {
                        // need filter
                        expanderData["deviceIDList"] = $scope.form.data.deviceIDList.data;
                    } else if ($scope.form.data.taskType.data == "MANAGE") {
                        expanderData["deviceIDList"] = $scope.form.data.deviceIDList.data;
                    }

                    if ($scope.form.timeType !== "once") {
                        var periodObj = {};
                        for (var index = 0, len = periodParts.length; index < len; index++) {
                            // serials.push(periodParts[index]);
                            if (!$scope.form.data[periodParts[index]].disabled) {
                                periodObj[periodParts[index]] = $scope.form.data[periodParts[index]].data;
                            }
                        }
                        expanderData["period"] = periodObj;
                    } else {
                        expanderData["period"] = null;
                    }
                    serials = periodParts;

                    $form.serialize($scope, serials);

                    for (var iname = 0, namelen = $scope.grid.data.length; iname < namelen; iname++) {
                        var curName = $scope.form.data.scheduleName.data;
                        if ($scope.grid.data[iname]["scheduleName"].data === curName) {
                            if ($scope.grid.updateIndex === iname) {
                                continue;
                            }
                            $scope.scheduleMsg.msg_errtip = $translate.instant("TASK.DUPLICATED_SCHEDULE");
                            return;
                        }
                    }

                    if ($scope.form.timeType === "once") {
                        $scope.form.data.endDate.data = $scope.form.data.startDate.data;
                        if ($scope.form.data.startDate.data.time < (new Date()).getTime()) {
                            $scope.scheduleMsg.msg_errtip = $translate.instant("TASK.ONCETIME_INVALID");
                            return;
                        }
                    }

                    // if ($scope.form.timeType === "cycle") {
                    //   var cycleStartDate = $scope.form.data.startDate.data;
                    //   var cycleEndDate = $scope.form.data.endDate.data;
                    //
                    //
                    //
                    //   return;
                    // }

                    var _temp = angular.copy($scope.form);
                    if ($scope.grid.updateIndex === "") {
                        $scope.grid.insert({
                            "DATA": expanderData
                        }, function(data) {
                            $scope.grid.loadData(data.scheduleList, "load");
                            $scope.scheduleMsg.show = false;
                            // setWarnOption(data);
                            $timeout(function() {
                                setWarnOption(data);
                            }, 1000);
                        }, function(err_msg) {
                            // $scope.scheduleMsg.show = false;
                            $scope.scheduleMsg.msg_errtip = err_msg;
                            $timeout(function() {
                                // $scope.form.timeType = "once";
                                // $scope.form.deviceGroup.data = "all";
                                // $scope.form.data.taskType.data = "DISCOVERY";
                                $scope.form = _temp;
                            }, 0);
                        }, function() {
                            $scope.scheduleMsg.show = false;
                        }, {"showPrompt": false});
                    } else {
                        $scope.grid.update({
                            "DATA": expanderData
                        }, function(data, other) {
                            $scope.grid.loadData(data.scheduleList, "load");
                            $scope.scheduleMsg.show = false;
                            // setWarnOption(data);
                            $timeout(function() {
                                setWarnOption(data);
                            }, 1000);
                        }, function(err_msg) {
                            // $scope.scheduleMsg.show = false;
                            $scope.scheduleMsg.msg_errtip = err_msg;
                            $timeout(function() {
                                // $scope.form.timeType = "once";
                                // $scope.form.deviceGroup.data = "all";
                                // $scope.form.data.taskType.data = "DISCOVERY";
                                $scope.form = _temp;
                            }, 0);
                        }, function() {
                            $scope.scheduleMsg.show = false;
                        }, null, {"showPrompt": false});
                    }

                    var setWarnOption = function(data) {
                        if (data.emptyCredentialDeviceList && data.emptyCredentialDeviceList.length) {
                            var deviceList = $scope.form.data.deviceIDList.options;
                            var warnOptions = [];
                            for (var index = 0, len = data.emptyCredentialDeviceList.length; index < len; index++) {
                                for (var dIndex = 0, dLen = deviceList.length; dIndex < dLen; dIndex++) {
                                    if (data.emptyCredentialDeviceList[index] === deviceList[dIndex]["deviceID"]) {
                                        var warnOption = {};
                                        warnOption["deviceName"] = deviceList[dIndex]["deviceName"];
                                        warnOption["ipAddress"] = deviceList[dIndex]["ipAddress"];
                                        warnOption.key = deviceList[dIndex]["deviceID"];

                                        warnOptions.push(warnOption);
                                        break;
                                    }
                                }
                            }
                            $scope.warningList.options = warnOptions;
                            $scope.taskWarningMsg.show = true;
                        }
                    }
                }
            },
            cancelBtn: {
                handler: function() {
                    $form.clear($scope);
                    $scope.scheduleMsg.show = false;
                }
            },
            autoClose: false
        };
        $scope.taskWarningMsg = {
            title: "FORM.WARNING",
            cancelBtn: {
                show: false
            }
        };

        $scope.form.data.taskType.options = [
            {
                name: "TASK.DISCOVERY",
                value: "DISCOVERY"
            }, {
                name: "TASK.REBOOT",
                value: "REBOOT"
            }, {
                name: "TASK.FIRM_UPGRADE",
                value: "UPGRADE"
            }, {
                name: "TASK.MANAGE",
                value: "MANAGE"
            }
        ];

        $scope.form.data.periodType.options = [
            {
                name: "TASK.MONTH",
                value: "month"
            }, {
                name: "TASK.WEEK",
                value: "week"
            }, {
                name: "TASK.DAY",
                value: "day"
            }
        ];

        function generateTimeOptions(timeType) {
            var i,
                len = timeType === "hour"
                    ? 24
                    : 60;
            var options = [];
            for (i = 0; i < len; i++) {
                var option = {};
                option.name = i < 10
                    ? '0' + i
                    : '' + i;
                option.value = i + '';
                options.push(option);
            }
            return options;
        }

        $scope.form.data.periodTimeH.options = generateTimeOptions("hour");
        $scope.form.data.periodTimeM.options = generateTimeOptions("minute");

        function resetPeriodDate() {
            $scope.form.data.periodDate.options = [];
            $scope.form.data.periodDate.data = '';
        }

        $scope.form.data.periodType.changeHandler = function(nVal) {
            switch (nVal) {
                case "month":
                    $scope.form.data.periodDate.disabled = true;
                    var dateOptions = [];
                    for (var index = 0, len = 31; index < len; index++) {
                        var dateOption = {};
                        dateOption.name = (index + 1).toString();
                        dateOption.value = (index + 1).toString();
                        dateOptions.push(dateOption);
                    }
                    resetPeriodDate();
                    $timeout(function() {
                        $scope.form.data.periodDate.options = dateOptions;
                        $scope.form.data.periodDate.data = "1";

                        if ($scope.grid.updateIndex !== "" && $scope.grid.updateIndex !== undefined) {
                            var gridData = $scope.grid.data[$scope.grid.updateIndex];
                            $scope.form.data["periodDate"].data = gridData["period"].data["periodDate"];
                        }

                        $scope.form.data.periodDate.disabled = false;
                    }, 200);
                    break;
                case "week":
                    $scope.form.data.periodDate.disabled = true;
                    var weekOptions = [
                        {
                            name: "CALENDER.SUN",
                            value: "SUN"
                        }, {
                            name: "CALENDER.MON",
                            value: "MON"
                        }, {
                            name: "CALENDER.TUE",
                            value: "TUE"
                        }, {
                            name: "CALENDER.WED",
                            value: "WED"
                        }, {
                            name: "CALENDER.THU",
                            value: "THU"
                        }, {
                            name: "CALENDER.FRI",
                            value: "FRI"
                        }, {
                            name: "CALENDER.SAT",
                            value: "SAT"
                        }
                    ];
                    resetPeriodDate();
                    $timeout(function() {
                        $scope.form.data.periodDate.options = weekOptions;
                        $scope.form.data.periodDate.data = weekOptions[0].value;

                        if ($scope.grid.updateIndex !== "" && $scope.grid.updateIndex !== undefined) {
                            var gridData = $scope.grid.data[$scope.grid.updateIndex];
                            $scope.form.data["periodDate"].data = gridData["period"].data["periodDate"];
                        }

                        $scope.form.data.periodDate.disabled = false;
                    }, 200);
                    break;
                case "day":
                    resetPeriodDate();
                    $scope.form.data.periodDate.disabled = true;
                    break;
            }
        };

        $scope.form.data.periodDate.changeHandler = function(nVal) {
            if ($scope.form.data.periodTimeH.data === '') {
                $scope.form.data.periodTimeH.data = '0';
            }
            if ($scope.form.data.periodTimeM.data === '') {
                $scope.form.data.periodTimeM.data = '0';
            }
        }

        $scope.form.data.taskType.changeHandler = function(nVal) {
            if (nVal) {
                if (nVal === "DISCOVERY") {
                    $scope.form.deviceGroup.disabled = true;
                    $scope.form.data.deviceIDList.disabled = true;
                } else {
                    $scope.form.deviceGroup.disabled = false;
                    $scope.form.data.deviceIDList.disabled = false;
                }
            }
        };

        $scope.form.deviceGroup = {};
        $scope.form.deviceGroup.changeHandler = function(condition) {
            if (condition) {
                var filterFunc = $tool.expressFilter(condition, false);
                var showDevices = $filter("filter")(allDevices, filterFunc);
                var listOptions = [];
                var pairListOptions = [];
                for (var index = 0, len = showDevices.length; index < len; index++) {
                    var listOption = {};
                    listOption["deviceName"] = showDevices[index]["deviceName"];
                    listOption["ipAddress"] = showDevices[index]["ipAddress"];
                    listOption["deviceID"] = showDevices[index].deviceID;
                    listOption["deviceState"] = showDevices[index].deviceState;

                    listOptions.push(listOption);

                    pairListOptions.push(angular.extend({}, listOption, {"firmwareID": showDevices[index].firmwares}));

                    (function(index) {
                        if (pairListOptions[index]["firmwareID"]) {
                            pairListOptions[index]["firmwareID"].changeHandler = function(nVal) {
                                for (var dindex = 0, len = $scope.form.data.pairList.data.length; dindex < len; dindex++) {
                                    if ($scope.form.data.pairList.options[index].deviceID === $scope.form.data.pairList.data[dindex].deviceID) {
                                        break;
                                    }
                                }
                                if (dindex < len) {
                                    $scope.form.data.pairList.data[dindex]["firmwareID"] = nVal;
                                }
                            };
                        }
                    })(index);
                }
                $scope.form.data.deviceIDList.options = listOptions;
                $scope.form.data.pairList.options = pairListOptions;
            }
        };

        $scope.form.data.deviceIDList = {
            fields: [
                {
                    showName: "DEVICE.DEVICENAME",
                    name: "deviceName"
                }, {
                    showName: "DEVICE.IP_ADDRESS",
                    name: "ipAddress"
                }
            ],
            dataFields: {
                fields: ["deviceID"],
                key: "deviceID"
            },
            editable: true
        };

        $scope.form.data.pairList = {
            fields: [
                {
                    showName: "DEVICE.DEVICENAME",
                    name: "deviceName"
                }, {
                    showName: "DEVICE.IP_ADDRESS",
                    name: "ipAddress"
                }, {
                    showName: "DEVICE.FIRMWARE",
                    name: "firmwareID",
                    type: "comboField"
                }
            ],
            dataFields: {
                fields: [
                    "deviceID", "firmwareID"
                ],
                key: "deviceID",
                initBlank: false,
                allowBlank: false
            },
            editable: true
        };

        $scope.warningList = {
            fields: [
                {
                    showName: "DEVICE.DEVICENAME",
                    name: "deviceName"
                }, {
                    showName: "DEVICE.IP_ADDRESS",
                    name: "ipAddress"
                }
            ],
            editable: false
        };
        var editSchedule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startEdit(selectedIndexs[0], false);
                // init form
                var periodParts = ["periodType", "periodDate", "periodTimeH", "periodTimeM"];
                var fields = $scope.form.fields;
                var gridData = $scope.grid.data[$scope.grid.updateIndex];
                for (var index = 0, len = fields.length; index < len; index++) {
                    var name = fields[index].name;
                    if (periodParts.indexOf(name) == -1) {
                        $scope.form.data[name].data = angular.isDefined(gridData[name].data)
                            ? gridData[name].data
                            : "";
                    } else {
                        if (gridData["period"] && gridData["period"].data && angular.isDefined(gridData["period"].data[name])) {
                            $scope.form.data[name].data = gridData["period"].data[name];
                        } else {
                            $scope.form.data[name].data = "";
                        }
                    }
                }
                if (gridData["period"] && angular.isObject(gridData["period"].data)) {
                    $scope.form.timeType = "cycle";

                } else if (gridData["period"] && (gridData["period"].data == null || gridData["period"].data == -1)) {
                    $scope.form.timeType = "once";
                }
                $scope.form.deviceGroup.data = "all";
                $scope.scheduleMsg.title = "TASK.EDITSCHEDULE";
                $scope.scheduleMsg.msg_errtip = "";
                $scope.scheduleMsg.show = true;
            }
        };

        var addSchedule = function() {
            $scope.grid.startAdd(false);
            $scope.form.timeType = "once";
            $scope.form.deviceGroup.data = "all";
            $scope.form.data.taskType.data = "DISCOVERY";
            $scope.scheduleMsg.title = "TASK.ADDSCHEDULE";

            $scope.scheduleMsg.msg_errtip = "";
            $scope.scheduleMsg.show = true;
        };

        $scope.form.data.periodType.data = "month";
        $scope.$watch("form.timeType", function(nV, oV) {
            if (nV !== oV && nV === "cycle") {
                if (!$scope.form.data.periodType.data) {
                    $scope.form.data.periodType.data = "month";
                }
            }
        })

        // toolbar setting
        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "TASK.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: editSchedule
                    }, {
                        name: "TASK.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delSchedule
                    }, {
                        name: "TASK.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: activateTask
                    }, {
                        name: "TASK.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: deactivateTask
                    }, {
                        name: "TASK.RUN",
                        className: "run",
                        isDisabled: "disable",
                        operate: runTask
                    }
                ]
            },
            search: true,
            others: [
                {
                    name: "DEVICE.ADD",
                    className: "add",
                    operate: addSchedule
                }
            ]
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                })

                if (nVal.length) {
                    $toolBarSrv.setEnable($scope.toolbarConfig);
                }

                var hasActived = false;
                var hasDisActived = false;
                var enableRun = false;
                for (var i = 0, len = nVal.length; i < len; i++) {
                    var item = $scope.grid.data[nVal[i]];
                    if (item.isActive.data) {
                        hasActived = true;

                        var currentTime = new Date();
                        if (item.startDate.data.time > Date.parse(currentTime)) {
                            enableRun = true;
                        }
                    } else {
                        hasDisActived = true;
                    }
                }

                if (hasActived && !hasDisActived) {
                    // actived task only
                    $scope.toolbarConfig.operator.show[2].isDisabled = "disable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "enable";
                } else if (!hasActived && hasDisActived) {
                    // disactived task only
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "disable";
                } else {
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "enable";
                }

                if (enableRun && nVal.length === 1) {
                    $scope.toolbarConfig.operator.show[4].isDisabled = "enable";
                } else {
                    $scope.toolbarConfig.operator.show[4].isDisabled = "disable";
                }

                // 没有选择任何项的情形应置于末尾
                if (nVal.length === 0) {
                    $toolBarSrv.setDisable($scope.toolbarConfig);
                }

            }
        }, true);

        $scope.getListIntervalFlag = true;
        $scope.getListInterval = function() {
            return $interval(function() {
                $scope.getListIntervalFlag && $proxy.request({
                    url: taskUrl
                }, {
                    "REQUEST": "GET_SCHEDULE_LIST"
                }, function(data) {
                    $scope.grid.loadData(data, "load", false, false);
                }, function() {});
            }, 2000);
        }
        $scope.scheduledInterval = $scope.getListInterval();

        $scope.$on("onSearching", function() {
            $scope.scheduledInterval && $interval.cancel($scope.scheduledInterval);
            $scope.getListIntervalFlag = false;
        });

        $scope.$on("stopSearching", function() {
            $scope.scheduledInterval = $scope.getListInterval();
            $scope.getListIntervalFlag = true;
        });
        $scope.$on("cancel_scheduledInterval", function() {
            $scope.scheduledInterval && $interval.cancel($scope.scheduledInterval);
            $scope.getListIntervalFlag = false;
        })
    }
]);

pharosModule.controllerProvider.register("runningTask", [
    "$scope",
    "$proxy",
    "$url",
    "$grid",
    "$interval",
    function($scope, $proxy, $url, $grid, $interval) {
        var taskUrl = $url.format("/task/");

        $scope.$parent.$parent.child = $scope;

        var config = {
            columns: [
                {
                    show: "TASK.TASKNAME",
                    name: "taskName"
                }, {
                    show: "TASK.ACTION",
                    name: "taskType"
                }, {
                    show: "TASK.STATUS",
                    name: "taskState"
                }, {
                    show: "TASK.START_TIME",
                    name: "createDate",
                    format: $scope.timeFormat2
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: taskUrl
            },
            fields: [
                {
                    name: "createDate"
                }, {
                    name: "creator"
                }, {
                    name: "deviceList"
                }, {
                    name: "finishDate"
                }, {
                    name: "processing"
                }, {
                    name: "processingPair"
                }, {
                    name: "taskJsonString"
                }, {
                    name: "taskName"
                }, {
                    name: "taskState"
                }, {
                    name: "taskType"
                }
            ],
            key: "task",
            autoLoad: false
        };
        $grid.config($scope, options);
        $scope.grid.load({"REQUEST": "GET_RUNNING_TASK"});

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "TASK.ADD",
                        className: "add",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.RUN",
                        className: "run",
                        isDisabled: "disable",
                        operate: function() {}
                    }
                ]
            },
            search: true
        };

        $scope.getListIntervalFlag = true;
        $scope.getListInterval = function() {
            return $interval(function() {
                $scope.getListIntervalFlag && $proxy.request({
                    url: taskUrl
                }, {
                    "REQUEST": "GET_RUNNING_TASK"
                }, function(data) {
                    $scope.grid.loadData(data, "load", false, false);
                }, function() {});
            }, 2000);
        }
        $scope.runningInterval = $scope.getListInterval();

        $scope.$on("onSearching", function() {
            $scope.child.runningInterval && $interval.cancel($scope.child.runningInterval);
            $scope.child.getListIntervalFlag = false;
        });

        $scope.$on("stopSearching", function() {
            $scope.child.runningInterval = $scope.child.getListInterval();
            $scope.child.getListIntervalFlag = true;
        });
    }
]);

pharosModule.controllerProvider.register("completedTask", [
    "$scope",
    "$proxy",
    "$url",
    "$grid",
    '$toolBarSrv',
    "$translate",
    "$interval",
    function($scope, $proxy, $url, $grid, $toolBarSrv, $translate, $interval) {
        var taskUrl = $url.format("/task/");

        $scope.$parent.$parent.child = $scope;

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "TASK.TASKNAME",
                    name: "taskName"
                }, {
                    show: "TASK.ACTION",
                    name: "taskType"
                }, {
                    show: "TASK.STATUS",
                    name: "taskState",
                    format: function(data) {
                        var _data = angular.uppercase(data);

                        switch (_data) {
                            case "RUNNING":
                                return $translate.instant("TASK.STATUS_RUNNING");
                            case "COMPLETED":
                                return $translate.instant("TASK.STATUS_COMPLETED");
                            case "PENDING":
                                return $translate.instant("TASK.STATUS_PENDING");
                            case "FAILED":
                                return $translate.instant("TASK.STATUS_FAILED");
                            case "CANCELLED":
                                return $translate.instant("TASK.STATUS_CANCELLED");
                        }
                    }
                }, {
                    show: "TASK.START_TIME",
                    name: "createDate",
                    format: $scope.timeFormat2
                }, {
                    show: "TASK.FINISH_TIME",
                    name: "finishDate",
                    format: $scope.timeFormat2
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: taskUrl
            },
            key: "task",
            fields: [
                {
                    name: "createDate"
                }, {
                    name: "creator"
                }, {
                    name: "deviceList"
                }, {
                    name: "finishDate"
                }, {
                    name: "processing"
                }, {
                    name: "processingPair"
                }, {
                    name: "taskJsonString"
                }, {
                    name: "taskName"
                }, {
                    name: "taskState"
                }, {
                    name: "taskType"
                }
            ],
            autoLoad: false
        };
        $grid.config($scope, options);
        $scope.grid.load({"REQUEST": "GET_COMPLETED_TASK"});

        var delEndedTask = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startRemove(selectedIndexs);
            }
        };

        // $scope.toolbarConfig = {
        // 	operator:{
        // 		show: [{
        // 			name: "TASK.DEL",
        // 			className: "delete",
        // 			isDisabled: "disable",
        // 			operate: delEndedTask
        // 		}]
        // 	}
        // };

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "TASK.ADD",
                        className: "add",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delEndedTask
                    }, {
                        name: "TASK.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.RUN",
                        className: "run",
                        isDisabled: "disable",
                        operate: function() {}
                    }
                ]
            },
            search: true
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                var i,
                    len = $scope.toolbarConfig.operator.show.length;
                if (nVal.length) {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete') {
                            ishow.isDisabled = "enable";
                        }
                    }
                } else {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete') {
                            ishow.isDisabled = "disable";
                        }
                    }
                }
            }
        }, true);

        $scope.getListIntervalFlag = true;
        $scope.getListInterval = function() {
            return $interval(function() {
                $scope.getListIntervalFlag && $proxy.request({
                    url: taskUrl
                }, {
                    "REQUEST": "GET_COMPLETED_TASK"
                }, function(data) {
                    $scope.grid.loadData(data, "load", false, false);
                }, function() {});
            }, 2000);
        }
        $scope.completedInterval = $scope.getListInterval();

        $scope.$on("onSearching", function() {
            $scope.child.completedInterval && $interval.cancel($scope.child.runningInterval);
            $scope.child.getListIntervalFlag = false;
        });

        $scope.$on("stopSearching", function() {
            $scope.child.completedInterval = $scope.child.getListInterval();
            $scope.child.getListIntervalFlag = true;
        });
    }
]);

pharosModule.controllerProvider.register("failedTask", [
    "$scope",
    "$proxy",
    "$url",
    "$grid",
    '$toolBarSrv',
    "$translate",
    "$interval",
    function($scope, $proxy, $url, $grid, $toolBarSrv, $translate, $interval) {
        var taskUrl = $url.format("/task/");

        $scope.$parent.$parent.child = $scope;

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "TASK.TASKNAME",
                    name: "taskName"
                }, {
                    show: "TASK.ACTION",
                    name: "taskType"
                }, {
                    show: "TASK.STATUS",
                    name: "taskState",
                    format: function(data) {
                        var _data = angular.uppercase(data);

                        switch (_data) {
                            case "RUNNING":
                                return $translate.instant("TASK.STATUS_RUNNING");
                            case "COMPLETED":
                                return $translate.instant("TASK.STATUS_COMPLETED");
                            case "PENDING":
                                return $translate.instant("TASK.STATUS_PENDING");
                            case "FAILED":
                                return $translate.instant("TASK.STATUS_FAILED");
                            case "CANCELLED":
                                return $translate.instant("TASK.STATUS_CANCELLED");
                        }
                    }
                }, {
                    show: "TASK.START_TIME",
                    name: "createDate",
                    format: $scope.timeFormat2
                }, {
                    show: "TASK.FINISH_TIME",
                    name: "finishDate",
                    format: $scope.timeFormat2
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: taskUrl
            },
            key: "task",
            fields: [
                {
                    name: "createDate"
                }, {
                    name: "creator"
                }, {
                    name: "deviceList"
                }, {
                    name: "finishDate"
                }, {
                    name: "processing"
                }, {
                    name: "processingPair"
                }, {
                    name: "taskJsonString"
                }, {
                    name: "taskName"
                }, {
                    name: "taskState"
                }, {
                    name: "taskType"
                }
            ],
            autoLoad: false
        };
        $grid.config($scope, options);
        $scope.grid.load({"REQUEST": "GET_FAILED_TASK"});

        var delFailedTask = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startRemove(selectedIndexs);
            }
        };

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "TASK.ADD",
                        className: "add",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delFailedTask
                    }, {
                        name: "TASK.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TASK.RUN",
                        className: "run",
                        isDisabled: "disable",
                        operate: function() {}
                    }
                ]
            },
            search: true
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                var i,
                    len = $scope.toolbarConfig.operator.show.length;
                if (nVal.length) {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete') {
                            ishow.isDisabled = "enable";
                        }
                    }
                } else {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete') {
                            ishow.isDisabled = "disable";
                        }
                    }
                }
            }
        }, true);

        $scope.getListIntervalFlag = true;
        $scope.getListInterval = function() {
            return $interval(function() {
                $scope.getListIntervalFlag && $proxy.request({
                    url: taskUrl
                }, {
                    "REQUEST": "GET_FAILED_TASK"
                }, function(data) {
                    $scope.grid.loadData(data, "load", false, false);
                }, function() {});
            }, 2000);
        }
        $scope.failedInterval = $scope.getListInterval();

        $scope.$on("onSearching", function() {
            $scope.child.failedInterval && $interval.cancel($scope.child.runningInterval);
            $scope.child.getListIntervalFlag = false;
        });

        $scope.$on("stopSearching", function() {
            $scope.child.failedInterval = $scope.child.getListInterval();
            $scope.child.getListIntervalFlag = true;
        });
    }
]);
