pharosModule.controllerProvider.register("trigger", [
    "$scope",
    '$proxy',
    '$url',
    "$translate",
    function($scope, $proxy, $url, $translate) {
        var triggerUrl = $url.format("/trigger/");

        // 清空遗留的 toptool
        angular.element(document.getElementById("menubar-container")).empty();

        $scope.type = "rule";

        $scope.menuConfig = {
            editable: false
        };

        $scope.triggerMenu = {};
        $scope.information = {};
        $scope.information.curFolder = {};
        $scope.triggerMenu.data = {
            ruleTree: {
                "children": [],
                "name": "TRIGGER.TRIGGERRULES",
                "type": "RULE",
                // "isLeaf": true,
                "uuid": "TRIGGERRULES"
            },
            zeventTree: {
                "children": [
                    {
                        "children": [],
                        "name": "TRIGGER.CHECKED",
                        "type": "CHECKED",
                        "isLeaf": true,
                        "uuid": "CHECKED"
                    }, {
                        "children": [],
                        "name": "TRIGGER.UNCHECKED",
                        "type": "UNCHECKED",
                        "isLeaf": true,
                        "uuid": "UNCHECKED"
                    }
                ],
                "name": "TRIGGER.TRIGGEREVENTS",
                "type": "EVENT",
                // "isLeaf": true,
                "uuid": "TRIGGEREVENTS"
            }
        };

        $scope.dataGrouping = function(type) {
            $scope.type = type;
        };

        $scope.information.listInfo = {
            rules: 0,
            events: 0,
            checked: 0,
            unchecked: 0
        }

        function formatNum(str, num) {
            if (!str) {
                return;
            }
            var index = str.indexOf("\("),
                string;
            if (index === -1) {
                string = str + "(" + num + ")";
            } else {
                string = str.slice(0, index) + "(" + num + ")";
            }
            return string;
        }

        var checkedFolderName = $translate.instant("TRIGGER.CHECKED");
        var uncheckedFolderName = $translate.instant("TRIGGER.UNCHECKED");
        function updateTaskNum() {
            var arr;
            var rules = $scope.information.listInfo.rules;
            var events = $scope.information.listInfo.events;
            var checked = $scope.information.listInfo.checked;
            var unchecked = $scope.information.listInfo.unchecked;

            if (!$scope.information.triggermenu_arr || $scope.information.triggermenu_arr.length !== 4) {
                $scope.information.triggermenu_arr = [];
                angular.forEach(angular.element(document.getElementById("trigger-menu")).find("span"), function(value) {
                    var $value = angular.element(value);
                    if ($value.hasClass("currentfolder")) {
                        $scope.information.triggermenu_arr.push(value);
                    }
                })
            }
            if ($scope.information.triggermenu_arr.length !== 4) {
                return;
            }
            arr = $scope.information.triggermenu_arr;
            rules = angular.element(arr[0]);
            events = angular.element(arr[1]);
            checked = angular.element(arr[2]);
            unchecked = angular.element(arr[3]);

            checked.html(checkedFolderName);
            unchecked.html(uncheckedFolderName);

            listInfo = $scope.information.listInfo;
            rules.html(formatNum(rules.html(), listInfo.rules));
            events.html(formatNum(events.html(), listInfo.events));
            checked.html(formatNum(checked.html(), listInfo.checked));
            unchecked.html(formatNum(unchecked.html(), listInfo.unchecked));
        }

        angular.forEach({
            rules: "GET_RULE_LIST",
            events: "GET_EVENT_LIST"
        }, function(value, key) {
            $proxy.request({
                url: triggerUrl
            }, {
                "REQUEST": value
            }, function(data) {
                $scope.information.listInfo[key] = data.length;

                if (key === "events") {
                    eventsCheckedHandler(data);
                }
            })
        });

        function eventsCheckedHandler(data, flag) {
            var checkedNum = 0;
            var uncheckedNum = 0;
            for (var i = 0, len = data.length; i < len; i++) {
                var item = data[i];
                var checkStr = flag
                    ? item.eventState.data
                    : item.eventState;
                if (angular.uppercase(checkStr) === "CHECKED") {
                    checkedNum++;
                } else {
                    uncheckedNum++;
                }
            }
            $scope.information.listInfo["checked"] = checkedNum;
            $scope.information.listInfo["unchecked"] = uncheckedNum;
        }

        $scope.$watch("child.grid.data", function(nV, oV) {
            if (nV !== oV) {
                var type = "rules";
                if ($scope.type !== 'RULE') {
                    type = "events";
                }
                $scope.information.listInfo[type] = nV.length;

                if (type === "events") {
                    eventsCheckedHandler(nV, true);
                }
                updateTaskNum();
            }
        }, true);

    }
]);

pharosModule.controllerProvider.register("triggerRule", [
    "$scope",
    "$grid",
    "$url",
    "$proxy",
    "$translate",
    "$form",
    "$vtype",
    "$timeout",
    '$toolBarSrv',
    '$msg',
    function($scope, $grid, $url, $proxy, $translate, $form, $vtype, $timeout, $toolBarSrv, $msg) {

        $scope.$parent.$parent.child = $scope;

        var triggerUrl = $url.format("/trigger/");
        var deviceUrl = $url.format("/device/");
        var mailUrl = $url.format("/misc/");

        var successPrompt = $msg.create({type: "success", text: "FORM.SUCCESS"});

        var failurePrompt = $msg.create({type: "failure", text: "FORM.FAILED"});

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "TRIGGER.NAME",
                    name: "ruleName"
                }, {
                    show: "TRIGGER.FROM_STATE",
                    name: "fromState"
                }, {
                    show: "TRIGGER.TO_STATE",
                    name: "toState"
                }, {
                    show: "TRIGGER.ACTION",
                    name: "action",
                    format: function(data) {
                        if (data.taskType == "MAIL") {
                            return $translate.instant("TRIGGER.MAIL_ACTION");
                        } else {
                            return $translate.instant("TRIGGER.MANAGE_ACTION");
                        }
                    }
                }, {
                    show: "TRIGGER.STATUS",
                    name: "isActive",
                    format: function(data) {
                        if (data === true) {
                            return $translate.instant("TRIGGER.ACTIVE");
                        } else {
                            return $translate.instant("TRIGGER.INACTIVE");
                        }
                    }
                }
            ],
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: triggerUrl
            },
            key: "rule",
            fields: [
                {
                    name: "action"
                }, {
                    name: "creator"
                }, {
                    name: "deviceList"
                }, {
                    name: "fromState"
                }, {
                    name: "group"
                }, {
                    name: "isActive"
                }, {
                    name: "ruleName"
                }, {
                    name: "toState"
                }
            ],
            editor: {
                fields: [
                    {
                        name: "ruleName",
                        allowBlank: false
                    }, {
                        name: "group"
                    }, {
                        name: "fromState"
                    }, {
                        name: "toState"
                    }, {
                        name: "taskType"
                    }, {
                        name: "mailTo",
                        allowBlank: false,
                        vtype: "email"
                    }, {
                        name: "subject",
                        allowBlank: false
                    }, {
                        name: "authType"
                    }, {
                        name: "mailServerAddr",
                        allowBlank: false,
                        vtype: {
                            vtype: "ip",
                            config: {
                                "allowLoopFlag": true
                            }
                        }
                    }, {
                        name: "mailServerPort",
                        allowBlank: false,
                        vtype: "number"
                    }, {
                        name: "mailSSLEnable"
                    }, {
                        name: "mailServerUsername",
                        allowBlank: false,
                        vtype: "email"
                    }, {
                        name: "mailServerPassword",
                        allowBlank: false,
                        encryption: {
                            name: "hex_sha1"
                        }
                    }
                ],
                validator: function(scope) {
                    var data = scope.form.data;
                    var taskType = data.taskType.data,
                        mailTo = data.mailTo.data,
                        subject = data.subject.data,
                        authType = data.authType.data;

                    if (taskType === "MAIL") {
                        if ($vtype["email"](mailTo) !== true) {
                            return false
                        }
                    }
                    if (authType === "gmail" && !$scope.gmailSetting.gmailIsValid) {
                        $scope.gmailSetting.manageGmailTip = true;
                        return false;
                    }
                    return true;
                }
            }
        };
        $grid.config($scope, options);

        // active start
        // -------------------------------------------------------------------------
        $scope.activateMsg = {
            title: "FORM.CONFIRMATION",
            content: "TRIGGER.ACTIVATE_RULE",
            size: "sm",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                handler: function() {
                    $scope.activateMsg.show = false;
                }
            },
            autoClose: false
        };
        var activateRule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                var ruleIDList = [];
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    var item = $scope.grid.data[selectedIndexs[index]];
                    if (!item.isActive.data) {
                        ruleIDList.push(item.key);
                    }
                }

                if (!ruleIDList.length) {
                    return;
                }

                $scope.activateMsg.show = true;
                $scope.activateMsg.okBtn.handler = function() {
                    $proxy.request({
                        url: triggerUrl
                    }, {
                        "REQUEST": "ACTIVATE_RULE",
                        "DATA": {
                            "ruleIDList": ruleIDList
                        }
                    }, function(data) {
                        $scope.grid.loadData(data, "load");
                        $scope.activateMsg.show = false;
                        successPrompt.show();
                    }, function() {
                        $scope.activateMsg.show = false;
                        failurePrompt.show();
                    }, function() {});
                };
            }
        };
        // -------------------------------------------------------------------------
        // active end

        // deactive start
        // -------------------------------------------------------------------------
        $scope.deactivateMsg = {
            title: "FORM.CONFIRMATION",
            content: "TRIGGER.DEACTIVATE_RULE",
            size: "sm",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                handler: function() {
                    $scope.deactivateMsg.show = false;
                }
            },
            autoClose: false
        };
        var deactivateRule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {

                var ruleIDList = [];
                for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                    var item = $scope.grid.data[selectedIndexs[index]];
                    if (item.isActive.data) {
                        ruleIDList.push(item.key);
                    }
                }

                if (!ruleIDList.length) {
                    return;
                }

                $scope.deactivateMsg.show = true;
                $scope.deactivateMsg.okBtn.handler = function() {
                    $proxy.request({
                        url: triggerUrl
                    }, {
                        "REQUEST": "DEACTIVATE_RULE",
                        "DATA": {
                            "ruleIDList": ruleIDList
                        }
                    }, function(data) {
                        $scope.grid.loadData(data, "load");
                        $scope.deactivateMsg.show = false;
                        successPrompt.show();
                    }, function() {
                        $scope.deactivateMsg.show = false;
                        failurePrompt.show();
                    }, function() {});
                };
            }
        };
        // -------------------------------------------------------------------------
        // active end

        function errMsgAll(string) {
            if (angular.isString(string))
                $scope.errMsgAll.content = string;
            $scope.errMsgAll.show = true;
        }
        $scope.errMsgAll = {
            title: "FORM.WARNING",
            content: "TRIGGER.RUN_ERROR",
            size: "sm"
        }

        // run start
        // -------------------------------------------------------------------------
        $scope.runMsg = {
            title: "FORM.CONFIRMATION",
            content: "TRIGGER.RUN_CONFIRM",
            size: "sm",
            okBtn: {
                handler: function() {}
            },
            cancelBtn: {
                handler: function() {
                    $scope.runMsg.show = false;
                }
            },
            autoClose: false
        };

        var runRule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.runMsg.okBtn.handler = function() {
                    var ruleIDList = [];
                    for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                        ruleIDList.push($scope.grid.data[selectedIndexs[index]].key);
                    }
                    $proxy.request({
                        url: triggerUrl
                    }, {
                        "REQUEST": "GO_RULE",
                        "DATA": {
                            "ruleIDList": ruleIDList
                        }
                    }, function(data) {
                        $scope.runMsg.show = false;
                    }, function(errMsg) {
                        $scope.runMsg.show = false;
                        errMsgAll("TRIGGER.RUN_ERROR");
                    }, function() {
                        $scope.runMsg.show = false;
                        errMsgAll("TRIGGER.RUN_ERROR");
                    });
                };
                $scope.runMsg.show = true;
            }
        };
        // -------------------------------------------------------------------------
        // run end

        var delRule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startRemove(selectedIndexs);
            }
        };

        $proxy.request({
            url: deviceUrl
        }, {
            "REQUEST": "GET_DEVICE_TREE"
        }, function(data) {
            // get device group
            var options = [];
            options.push({name: "TASK.ALLDEVICES", value: "all"});
            for (var tree in data) {
                for (var index = 0, len = data[tree].children.length; index < len; index++) {
                    var option = {};
                    option.name = data[tree].children[index].name;
                    option.value = data[tree].children[index].uuid;
                    options.push(option);
                }
            }
            $scope.form.data.group.options = options;
        }, function() {}, function() {});

        var typeOptions = [
            {
                name: "TRIGGER.MAIL_ACTION",
                value: "MAIL"
            }, {
                name: "TRIGGER.MANAGE_ACTION",
                value: "MANAGE"
            }
        ];

        var stateOptions = [
            {
                name: "TRIGGER.UNMANAGED",
                value: "UNMANAGED"
            }, {
                name: "TRIGGER.MANAGED",
                value: "MANAGED"
            }, {
                name: "TRIGGER.ERROR",
                value: "ERROR"
            }
        ];

        $scope.form.data.fromState.options = stateOptions;
        $scope.form.data.toState.options = stateOptions;

        $scope.$watch("form.data.fromState.data", function(nV, oV) {
            if (nV !== oV) {
                switch (nV) {
                    case "UNMANAGED":
                        $scope.form.data.toState.options = stateOptions.slice(1);
                        if ($scope.form.data.toState.data === "UNMANAGED") {
                            $scope.form.data.toState.data = "MANAGED";
                        }
                        $scope.form.data.taskType.options = typeOptions.slice(0, 1);
                        break;
                    case "MANAGED":
                        $scope.form.data.toState.options = [
                            {
                                name: "TRIGGER.UNMANAGED",
                                value: "UNMANAGED"
                            }, {
                                name: "TRIGGER.ERROR",
                                value: "ERROR"
                            }
                        ];
                        if ($scope.form.data.toState.data === "MANAGED") {
                            $scope.form.data.toState.data = "UNMANAGED";
                        }
                        $scope.form.data.taskType.options = typeOptions;
                        break;
                    case "ERROR":
                        $scope.form.data.toState.options = stateOptions.slice(0, 2);
                        if ($scope.form.data.toState.data === "ERROR") {
                            $scope.form.data.toState.data = "UNMANAGED";
                        }
                        $scope.form.data.taskType.options = typeOptions.slice(0, 1);
                        break;
                }
            }
        })

        // $scope.form.data.taskType.options = typeOptions.slice(0, 1);

        $scope.$watch("form.data.taskType.data", function(nV, oV) {
            if (nV !== oV) {
                switch (nV) {
                    case "MAIL":
                        $scope.form.data.mailTo.disabled = false;
                        $scope.form.data.subject.disabled = false;
                        break;
                    case "MANAGE":
                        $scope.form.data.mailTo.disabled = true;
                        $scope.form.data.mailTo.valid = true;
                        $scope.form.data.subject.disabled = true;
                        $scope.form.data.subject.valid = true;
                        break;
                }
            }
        });

        var actionFields = ["taskType", "mailTo", "subject"];
        // edit
        $scope.updateRuleMsg = {
            title: "",
            okBtn: {
                handler: function() {
                    var expanderData = {};
                    var actionObj = {};
                    // for (var index = 0, len = actionFields.length; index < len; index++) {
                    //   if (!$scope.form.data[actionFields[index]].disabled) {
                    //     actionObj[actionFields[index]] = $scope.form.data[actionFields[index]].data;
                    //   }
                    // }
                    // expanderData["action"] = actionObj;
                    // $form.serialize($scope, actionFields);

                    var triggerConfig = {},
                        mailConfig = {},
                        _data = {};

                    for (var iname = 0, namelen = $scope.grid.data.length; iname < namelen; iname++) {
                        if ($scope.form.data.ruleName.data === $scope.grid.data[iname]["ruleName"].data) {
                            if ($scope.grid.updateIndex === iname) {
                                continue;
                            }
                            $scope.updateRuleMsg.msg_errtip = $translate.instant("TRIGGER.DUPLICATED_RULENAME");
                            return;
                        }
                    }

                    function generateData() {
                        var trigegrDataArr = [
                                "ruleName", "group", "fromState", "toState"/*, "action"*/
                            ],
                            mailDataArr = [
                                "authType",
                                "mailServerAddr",
                                "mailServerPassword",
                                "mailServerPort",
                                "mailServerUsername",
                                "mailSSLEnable"
                            ];

                        var i,
                            len;
                        for (i = 0, len = trigegrDataArr.length; i < len; i++) {
                            triggerConfig[trigegrDataArr[i]] = $scope.form.data[trigegrDataArr[i]].data;
                        }
                        triggerConfig["action"] = actionObj;

                        if ($scope.form.data.authType.data === "default") {
                            for (i = 0, len = mailDataArr.length; i < len; i++) {
                                mailConfig[mailDataArr[i]] = $scope.form.data[mailDataArr[i]].data;
                                if (mailDataArr[i] === "mailServerPassword") {
                                    mailConfig[mailDataArr[i]] = $scope.form.data[mailDataArr[i]].inputData;
                                }
                            }
                        } else {
                            mailConfig["authType"] = "gmail";
                        }
                        _data["triggerConfig"] = triggerConfig;
                        _data["mailConfig"] = mailConfig;
                    }
                    generateData();
                    if ($scope.grid.updateIndex === "") {
                        // hack 初始未设定 mail 的情况
                        if ($scope.form.data.mailServerAddr.data === '') {
                            $scope.updateRuleMsg.msg_errtip = "TRIGGER.CFG_MAIL_SETTING";
                        }

                        $scope.grid.insert({
                            // "DATA": expanderData
                            "DATA": _data
                        }, function(data) {
                            $scope.grid.loadData(data, "load");
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        }, function() {
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        }, function() {
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        });
                    } else {
                        var selectedIndexs = $scope.grid.selectedIndexs;
                        if (selectedIndexs.length) {
                            _data.triggerConfig["ruleID"] = $scope.grid.data[selectedIndexs[0]].key
                        }

                        $scope.grid.update({
                            // "DATA": expanderData
                            "DATA": _data
                        }, function(data) {
                            $scope.grid.loadData(data, "load");
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        }, function() {
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        }, function() {
                            $scope.updateRuleMsg.show = false;
                            $scope.updateRuleMsg.msg_errtip = '';
                        });
                    }
                }
            },
            cancelBtn: {
                handler: function() {
                    $form.clear($scope);
                    $scope.updateRuleMsg.show = false;
                    $scope.updateRuleMsg.msg_errtip = '';
                }
            },
            autoClose: false
        };

        var editRule = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startEdit(selectedIndexs[0], false, $scope.form);

                $proxy.request({
                    url: mailUrl
                }, {
                    "REQUEST": "GET_MAIL_CFG"
                }, function(data) {
                    // if(selectedIndexs.length == 1){
                    // init form
                    var gridData,
                        index,
                        len;
                    $form.loadData($scope, data);
                    gridData = $scope.grid.data[$scope.grid.updateIndex];
                    for (index = 0, len = actionFields.length; index < len; index++) {
                        $scope.form.data[actionFields[index]].data = gridData["action"].data[actionFields[index]];
                    }

                    var initArr = ["ruleName", "group", "fromState", "toState"];
                    for (index = 0, len = initArr.length; index < len; index++) {
                        $scope.form.data[initArr[index]].data = gridData[initArr[index]].data;
                    }

                    if ($scope.form.data.mailServerPassword.data) {
                        $timeout(function() {
                            $scope.form.data.mailServerPassword.inputData = $scope.form.data.mailServerPassword.data;
                        }, 0);
                    }

                    $scope.gmailSetting.gmailIsValid = data.gmailIsValid;

                    if ($scope.gmailSetting.gmailIsValid === 1) {
                        $scope.gmailSetting.gmailAccount = data.gmailAccount + " " + $translate.instant("ACCOUNT.IN_USE");
                    } else {
                        $scope.gmailSetting.gmailAccount = "";
                    }

                    $scope.gmailSetting.gmailCode.data = "";
                    $scope.gmailSetting.validateBtnSuccess = false;
                    $scope.updateRuleMsg.title = "TRIGGER.EDIT_TRIGGER";
                    $scope.updateRuleMsg.msg_errtip = "";
                    $scope.gmailSetting.manageGmailTip = false;
                    $scope.updateRuleMsg.show = true;
                    // }else{
                    // errMsgAll("TRIGGER.EDIT_ONEITEM");
                    // }
                }, function(err_msg) {}, function(err_status) {});
            }
        };

        var addRule = function() {
            $scope.grid.startAdd(false);
            $proxy.request({
                url: mailUrl
            }, {
                "REQUEST": "GET_MAIL_CFG"
            }, function(data) {
                $form.loadData($scope, data);
                // init form
                $scope.form.data.group.data = "all";
                $scope.form.data.fromState.data = "UNMANAGED";
                $scope.form.data.toState.data = "MANAGED";
                $scope.form.data.taskType.data = "MAIL";
                if ($scope.form.data.mailServerPassword.data) {
                    $timeout(function() {
                        $scope.form.data.mailServerPassword.inputData = $scope.form.data.mailServerPassword.data;
                    }, 0);
                }

                $scope.gmailSetting.gmailIsValid = data.gmailIsValid;
                if ($scope.gmailSetting.gmailIsValid === 1) {
                    $scope.gmailSetting.gmailAccount = data.gmailAccount + " " + $translate.instant("ACCOUNT.IN_USE");
                } else {
                    $scope.gmailSetting.gmailAccount = "";
                }

                $scope.gmailSetting.gmailCode.data = "";

                $scope.gmailSetting.validateBtnSuccess = false;
                $scope.updateRuleMsg.title = "TRIGGER.ADD_TRIGGER";
                $scope.updateRuleMsg.msg_errtip = "";
                $scope.gmailSetting.manageGmailTip = false;
                $scope.updateRuleMsg.show = true;
            }, function(err_msg) {}, function(err_status) {});
        };

        $scope.toggleFieldset = function(e) {
            var legend = angular.element(e.target);
            var icon = legend[0].nodeName == "SPAN"
                ? legend
                : legend.next();
            var body = icon.next();
            icon.hasClass("down")
                ? icon.removeClass("down")
                : icon.addClass("down");
            body.hasClass("hidden")
                ? body.removeClass("hidden")
                : body.addClass("hidden");
        };

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "TRIGGER.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: function() {
                            $scope.updateRuleMsgTitle = $translate.instant("TRIGGER.EDIT_TRIGGER");
                            editRule();
                        }
                    }, {
                        name: "TRIGGER.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delRule
                    }, {
                        name: "TRIGGER.ACTIVATE",
                        className: "activate",
                        isDisabled: "disable",
                        operate: activateRule
                    }, {
                        name: "TRIGGER.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: deactivateRule
                    }, {
                        name: "TRIGGER.TEST",
                        className: "run",
                        isDisabled: "disable",
                        operate: runRule
                    }
                ]
            },
            search: true,
            others: [
                {
                    name: "DEVICE.ADD",
                    className: "add",
                    operate: function() {
                        $scope.updateRuleMsgTitle = $translate.instant("TRIGGER.ADD_TRIGGER");
                        addRule();
                    }
                }
            ]
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                });
                if (nVal.length) {
                    $toolBarSrv.setEnable($scope.toolbarConfig);
                }

                var hasActived = false;
                var hasDisActived = false;
                // var enableRun = false;
                for (var i = 0, len = nVal.length; i < len; i++) {
                    var item = $scope.grid.data[nVal[i]];
                    if (item.isActive.data) {
                        hasActived = true;

                        // var currentTime = new Date();
                        // if (item.startDate.data.time > Date.parse(currentTime)) {
                        // 	enableRun = true;
                        // }
                    } else {
                        hasDisActived = true;
                    }
                }

                if (hasActived && !hasDisActived) {
                    // actived task only
                    $scope.toolbarConfig.operator.show[2].isDisabled = "disable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "enable";
                } else if (!hasActived && hasDisActived) {
                    // disactived task only
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "disable";
                } else {
                    $scope.toolbarConfig.operator.show[2].isDisabled = "enable";
                    $scope.toolbarConfig.operator.show[3].isDisabled = "enable";
                }

                // if (enableRun) {
                // 	$scope.toolbarConfig.operator.show[4].isDisabled = "enable";
                // } else {
                // 	$scope.toolbarConfig.operator.show[4].isDisabled = "disable";
                // }

                if (nVal.length === 0) {
                    $toolBarSrv.setDisable($scope.toolbarConfig);
                }
            }
        }, true);

        $scope.gmailSetting = {
            validateBtnDisable: true,
            validateBtnWaiting: false,
            validateBtnSuccess: false,
            gmailCode: {
                data: "",
                valid: true
            },
            gmailIsValid: 0,
            gmailAccount: ""
        };

        $scope.$watch("gmailSetting.gmailCode.data", function(nVal, oVal) {
            if (nVal !== oVal) {
                if (nVal !== '') {
                    $scope.gmailSetting.validateBtnDisable = false;
                }
                if (nVal === '') {
                    $scope.gmailSetting.validateBtnDisable = true;
                }
            }
        })

        $scope.mailSetting = {
            getCode: function() {

                var getCodeUrl = "https://accounts.google.com/o/oauth2/v2/auth?" +
                "scope=https://www.googleapis.com/auth/userinfo.email https://mail.google.com/&" +
                "redirect_uri=urn:ietf:wg:oauth:2.0:oob&response_type=code&" +
                "client_id=211462762800-h9oo1k95m495j82fo9lib4b914c8a6bf.apps.googleusercontent.com";

                window.open(getCodeUrl);
            },
            mailValidate: function() {
                var gmailCode = $scope.gmailSetting.gmailCode.data;
                $proxy.request({
                    url: mailUrl,
                    timeout: 60 * 1000
                }, {
                    "REQUEST": "VALIDATE_AUTH_CODE",
                    "DATA": {
                        "authCode": gmailCode
                    }
                }, function() {
                    $scope.gmailSetting.codeErr = false;
                    $scope.gmailSetting.gmailIsValid = 1;
                    $scope.gmailSetting.manageGmailTip = false;
                    $scope.gmailSetting.validateBtnDisable = false;
                    $scope.gmailSetting.validateBtnWaiting = false;
                    $scope.gmailSetting.validateBtnSuccess = true;
                }, function() {
                    $scope.gmailSetting.codeErr = true;
                    $scope.gmailSetting.gmailIsValid = 0;
                    $scope.gmailSetting.manageGmailTip = false;
                    $scope.gmailSetting.validateBtnDisable = false;
                    $scope.gmailSetting.validateBtnWaiting = false;
                    $scope.gmailSetting.validateBtnSuccess = false;
                });
                $scope.gmailSetting.validateBtnDisable = true;
                $scope.gmailSetting.validateBtnWaiting = true;
            }
        }

        var $fieldsetBefore;
        var $fieldsetAfter;
        function getFieldset() {
            if ($fieldsetBefore && $fieldsetAfter) {
                return;
            }

            var arr = document.querySelectorAll(".toggle-fieldset");
            $fieldsetBefore = arr[0]
                ? angular.element(arr[0])
                : null;
            $fieldsetAfter = arr[1]
                ? angular.element(arr[1])
                : null;
        }

        $scope.$watch("updateRuleMsg.show", function(nV, oV) {
            if (nV !== oV) {
                getFieldset();
                if (nV === false && oV === true) {
                    var beforeChildren = $fieldsetBefore.children();
                    var beforeIcon = angular.element(beforeChildren[1]);
                    var beforeBody = angular.element(beforeChildren[2]);
                    if (!beforeIcon.hasClass("down")) {
                        beforeIcon.addClass("down");
                    }
                    if (beforeBody.hasClass("hidden")) {
                        beforeBody.removeClass("hidden");
                    }

                    var afterChildren = $fieldsetAfter.children();
                    var afterIcon = angular.element(afterChildren[1]);
                    var afterBody = angular.element(afterChildren[2]);
                    if (afterIcon.hasClass("down")) {
                        afterIcon.removeClass("down");
                    }
                    if (!afterBody.hasClass("hidden")) {
                        afterBody.addClass("hidden");
                    }
                }
            }
        })

        $scope.$watch("form.data.authType.data", function(nVal, oVal) {
            if (nVal !== oVal) {
                if (nVal === "default") {
                    $scope.form.serials = {};
                } else if (nVal === "gmail") {
                    $scope.form.serials = {};
                    var serializeArr = ["mailServerAddr", "mailServerPassword", "mailServerPort", "mailServerUsername", "mailSSLEnable"];
                    $form.serialize($scope, serializeArr);
                }
            }
        });

    }
]);

pharosModule.controllerProvider.register("triggerEvent", [
    "$scope",
    "$grid",
    "$url",
    "$proxy",
    "$tool",
    "$translate",
    "$msg",
    function($scope, $grid, $url, $proxy, $tool, $translate, $msg) {

        $scope.$parent.$parent.child = $scope;

        var successPrompt = $msg.create({type: "success", text: "FORM.SUCCESS"});
        var failurePrompt = $msg.create({type: "failure", text: "FORM.FAILED"});

        var triggerUrl = $url.format("/trigger/");
        var timeFormat = function(data) {
            if (data && data.time) {
                return $tool.timeFormat(data.time);
            }
        };

        var config = {
            columns: [
                {
                    type: "check"
                }, {
                    show: "TRIGGER.NAME",
                    name: "eventName"
                }, {
                    show: "TRIGGER.DEVICENAME",
                    name: "deviceName"
                }, {
                    show: "TRIGGER.TIME",
                    name: "createDate",
                    format: $tool.timeFormat2
                }, {
                    show: "TRIGGER.TYPE",
                    name: "eventType"
                }, {
                    show: "TRIGGER.ACTION",
                    name: "taskType"
                }, {
                    show: "TRIGGER.IS_CHECKED",
                    name: "eventState",
                    format: function(data) {
                        if (data === "CHECKED") {
                            return $translate.instant('TRIGGER.CHECKED');
                        }
                        return $translate.instant('TRIGGER.UNCHECKED');
                    }
                }
            ],
            grouping: function(item) {
                var type = $scope.$parent.$parent.type;
                if (type == "CHECKED") {
                    if (item.eventState.data == "CHECKED") {
                        return true;
                    }
                } else if (type == "UNCHECKED") {
                    if (item.eventState.data == "UNCHECKED") {
                        return true;
                    }
                } else if (type == "EVENT") {
                    return true;
                }
            },
            showMoreList: false
        };
        $scope.gridConfig = config;

        var options = {
            proxy: {
                url: triggerUrl
            },
            key: "event",
            fields: [
                {
                    name: "eventName"
                }, {
                    name: "eventState"
                }, {
                    name: "eventType"
                }, {
                    name: "createDate"
                }, {
                    name: "deviceName"
                }, {
                    name: "rule"
                }, {
                    name: "taskType"
                }
            ]
        };
        $grid.config($scope, options);

        $scope.checkMsg = {
            title: "FORM.CONFIRMATION",
            content: "TRIGGER.CHECK_CONFIRM",
            okBtn: {
                handler: function() {
                    var checkList = [];
                    var selectedIndexs = $scope.grid.selectedIndexs;
                    for (var index = 0, len = selectedIndexs.length; index < len; index++) {
                        if ($scope.grid.data[selectedIndexs[index]].eventState.data == "UNCHECKED") {
                            checkList.push($scope.grid.data[selectedIndexs[index]].key);
                        }
                    }
                    $proxy.request({
                        url: triggerUrl
                    }, {
                        "REQUEST": "CHECK_EVENT",
                        "DATA": {
                            "eventIDList": checkList
                        }
                    }, function(data) {
                        $scope.grid.loadData(data, "load");
                        successPrompt.show();
                    }, function() {
                        failurePrompt.show();
                    }, function() {});
                }
            },
            cancelBtn: {
                handler: function() {}
            },
            size: "sm"
        };
        var checkEvent = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            var hasUnchecked = false;
            for (var i = 0, len = selectedIndexs.length; i < len; i++) {
                var item = $scope.grid.data[selectedIndexs[i]];
                if (item.eventState.data === "UNCHECKED") {
                    hasUnchecked = true;
                }
            }

            if (selectedIndexs.length && hasUnchecked) {
                $scope.checkMsg.show = true;
            }
        };

        var delEvent = function() {
            var selectedIndexs = $scope.grid.selectedIndexs;
            if (selectedIndexs.length) {
                $scope.grid.startRemove(selectedIndexs);
            }
        };

        // $scope.toolbarConfig = {
        // 	operator:{
        // 		show: [{
        // 			name: "TRIGGER.CHECK",
        // 			className: "check",
        // 			operate: checkEvent
        // 		},{
        // 			name: "TRIGGER.DEL",
        // 			className: "delete",
        // 			operate: delEvent
        // 		}]
        // 	}
        // };

        $scope.toolbarConfig = {
            operator: {
                show: [
                    {
                        name: "DEVICE.ADD",
                        className: "add",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TRIGGER.EDIT",
                        className: "edit",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TRIGGER.DEL",
                        className: "delete",
                        isDisabled: "disable",
                        operate: delEvent
                    }, {
                        name: "TRIGGER.CHECK",
                        className: "activate",
                        isDisabled: "disable",
                        operate: checkEvent
                    }, {
                        name: "TRIGGER.DEACTIVATE",
                        className: "deactivate",
                        isDisabled: "disable",
                        operate: function() {}
                    }, {
                        name: "TRIGGER.TEST",
                        className: "run",
                        isDisabled: "disable",
                        operate: function() {}
                    }
                ]
            },
            search: true
        };

        $scope.$watch("grid.selectedIndexs", function(nVal, oVal) {
            if (nVal !== oVal) {
                nVal.sort(function(a, b) {
                    return a - b
                });

                var hasUnchecked = false;
                var i = 0;
                var len = $scope.grid.selectedIndexs.length;
                for (var i = 0; i < len; i++) {
                    var item = $scope.grid.data[$scope.grid.selectedIndexs[i]];
                    if (item.eventState.data === "UNCHECKED") {
                        hasUnchecked = true;
                    }
                }

                i = 0;
                len = $scope.toolbarConfig.operator.show.length;
                if (nVal.length) {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete' || (ishow.className === 'activate' && hasUnchecked)) {
                            ishow.isDisabled = "enable";
                        }
                    }
                } else {
                    for (i = 0; i < len; i++) {
                        var ishow = $scope.toolbarConfig.operator.show[i];
                        if (ishow.className === 'delete' || ishow.className === 'activate') {
                            ishow.isDisabled = "disable";
                        }
                    }
                }

            }
        }, true);

    }
]);
