// directive
/*nav*/
pharosModule.directive("navigator", ["$location", "$translate", "$proxy", "$url", "$user", "$module", "$route",
	function($location, $translate, $proxy, $url, $user, $module, $route){
	return {
		restrict: "EA",
		replace: true,
		scope: {},
		templateUrl: 'components/common/navTop.html',
		link: function( $scope, $ele, $attr){
			/*$scope.pages = [
				{name:'NAV.DEVICE', state:'app.device'},
				{name:'NAV.FIRMWARE', state:'app.firmware'},
				{name:'NAV.TASK', state:'app.task'},
				{name:'NAV.TRIGGER', state:'app.trigger'},
				{name:'NAV.ACCOUNT', state:'app.user'},
				{name:'NAV.LOG', state:'app.log'},
			];*/

			$scope.account = $module.username;
			$scope.pages = $module.navigators;

			$scope.href = function(path){
				$location.path(path);
				$route.reload();
			};

			$scope.changeLanguage = function(langKey){
				$translate.use(langKey);
			}

			// $scope.logout = function(){
			// 	var logoutUrl = $url.format("/misc/");
			// 	$proxy.request({
			// 		url: logoutUrl
			// 	},{
			// 		"REQUEST": "LOGOUT"
			// 	}, function(){
			// 		$user.delCookie("NAME");
			// 		location.href = "./login.html";
			// 	}, function(){}, function(){});
			// };

			$scope.$watch(function(){
				return $module.current
			}, function(nVal, oVal){
				if(nVal !== oVal){
					$scope.current = nVal;
				}
			});
		}
	}
}]);

/*message*/
pharosModule.directive("message", ["$timeout", "$window", function($timeout, $window){
	return{
		restrict: "AE",
		templateUrl: "components/common/message.html",
		replace: true,
		transclude: true,
		scope: {
			msg: "=ngModel",
			cls: "@"
		},
		link: function($scope, $element, $attrs){
			var defaults = {
				show: false,
				title: "",
				content: "",
				iconCls: "",
				okBtn: {
					show: true,
					text: "FORM.OK",
					handler: null
				},
				cancelBtn: {
					show: true,
					text: "FORM.CANCEL",
					handler: null
				},
				autoClose: true,
				disabled: false,
				timeout: 0,
				size: "",
				flag: true,
				backdropClose: false
			};

			$scope.backdropClick = function(e){
				if ( !$scope.msg.backdropClose ) return;
				var content = $element[0].querySelector(".widget-message-content");
				if ( !content ) return;
				if ( e.target === content ) {
					$scope.msg.show = false;
				}
			};

			$scope.ok = function(){
				if($scope.msg.okBtn.handler !== null){
					$scope.msg.okBtn.handler();
				}
				$scope.msg.autoClose ? $scope.msg.show = false : null;
			};
			$scope.cancel = function(){
				if($scope.msg.cancelBtn.handler !== null){
					$scope.msg.cancelBtn.handler();
				}
				$scope.msg.autoClose ? $scope.msg.show = false : null;
			};
			$scope.close = function(){
				var closeResult = $scope.msg.close();
				if(closeResult === false){
					return;
				}
				$scope.msg.show = false;
			}

			$scope.$watch("msg", function(nVal, oVal){
				if($scope.msg && $scope.msg.flag !== true){
					$scope.msg = angular.extend({}, defaults, $scope.msg);
					$scope.msg.okBtn = angular.extend(defaults.okBtn, $scope.msg.okBtn);
					$scope.msg.cancelBtn = angular.extend(defaults.cancelBtn, $scope.msg.cancelBtn);
					$scope.msg.close = $scope.msg.close ? $scope.msg.close : function(){};
					if($scope.msg.timeout > 0){
						$scope.$watch("msg.show", function(nVal){
							if(nVal == true){
								$timeout(function(){
									$scope.msg.show = false;
								},$scope.msg.timeout);
							}
						});
					}
				}
				if(nVal !== oVal){
				}
			});

			$scope.resetModalTop = function(){
				var getCss = function(obj, key){
					if(key == "height" && obj.currentStyle){
						return obj.offsetHeight;
					}
				    return obj.currentStyle ?  obj.currentStyle[key] : window.getComputedStyle(obj, null)[key];
				};
				var windowH = parseInt(getCss(document.body, "height"));
				var modalH = parseInt(getCss($element[0].querySelector(".modal-content"), "height"));
				var marginTop = (windowH - modalH) / 2;
				marginTop = marginTop > 0 ? marginTop : 0;
				angular.element($element[0].querySelector(".modal-dialog")).css("margin", marginTop + 'px auto');
				return true;
			}
		}
	}
}]);

// status
pharosModule.directive("status", ["$timeout", "$msg", function($timeout, $msg){
	return {
		restrict: "AE",
		replace: true,
		templateUrl: 'components/common/status.html',
		link: function(scope, ele, attrs){
			scope.statusMessages = $msg.statusMessages;
		}
	}
}]);

// foldertree
pharosModule.directive("folderTree", ['$recurseTree', function($recurseTree) {
    return {
        restrict: "EA",
        replace:true,
        scope: {
            currentFolder: '=',
            currentConfig: '=',
            setCurFolder: '&',
            grouping: "&",
            subIndex: "@"
        },
        templateUrl: "components/common/foldertree.html",
        compile: function(element) {
            return $recurseTree.compile(element, function(scope, iElement, iAttrs, controller, transcludeFn){
            	scope.folderOpenClose = function(){
            		scope.isClosed = !scope.isClosed
            	}
            	scope.parseInt = parseInt;
            	scope.isClosed = scope.currentFolder.isClosed ? scope.currentFolder.isClosed : false;
            });
        }
    };
}]);

// toptools
pharosModule.directive("topTools", ["$user", function($user){
	return {
		restrict: "EA",
		replace: true,
        templateUrl: "components/common/topTools.html",
		link: function($scope, $element, $attrs){
			$scope.$watch("information.curFolder", function(newVal, oldVal, scope){
				if (angular.isString(newVal)) {
					$scope.add = $scope.del = $scope.edit = false;
				}

				var role = $user.getCookie("NAME").split("&amp")[1];
				$scope.isGuest = false;
				if(role === "GUEST") {
					$scope.isGuest = true;
				}

				if ( newVal === "DEVICE.ALLDEVICE" ) {
					$scope.all = true;
				}

				if ( newVal && newVal.uuid ){
					var temp = (newVal.rde ? newVal.rde : "1-1-1").split("-");
					$scope.add = temp[0] == '1' ? true : false;
					$scope.del 	= temp[1] == '1' ? true : false;
					$scope.edit = temp[2] == '1' ? true : false;
				}
			});
			var menuCtn = angular.element(document.getElementById("menubar-container"));
			menuCtn.empty();
			menuCtn.append($element);
    }
	}
}])

// role-auth
pharosModule.directive("roleAuth", ["$rootScope", function($rootScope){
	return {
		restrict: "EA",
		link: function($scope, $element, $attrs){
				if($rootScope.rootRole === "GUEST"){
					$element.addClass("hide");
				}
    }
	}
}])

// fileselect
pharosModule.directive("fileSelect", [ "$timeout", "$route", function($timeout, $route){
	return {
		restrict: "EA",
		replace: true,
    templateUrl: "components/common/fileselect.html",
    scope:{
    	fileSelect: "=",
    	cls: "@",
    	labelCls: "@",
    	inputCls: "@"
    },
		link: function($scope, $element, $attrs){
			$scope.iframe = $element.find("iframe");

			function inputClear(){
				var inputArr = $element.find("input");
				inputArr.val("");
				$element.removeClass("fileSelectTip");
			}

			function iframeLoadHandler(){
				inputClear();
				var iframeDoc = $element.find("iframe")[0].contentDocument || $element.find("iframe").contentWindow.document;
				var response = iframeDoc.getElementsByTagName("body")[0].innerText.match( /\{[^\}]+\}/ );
				if ( response[0] ){
					response = angular.fromJson( response[0] );
					if ( response["RESPONSE"] === "ERROR" ){
						var errMsg = response["ERR_MSG"];
						if(!(errMsg.indexOf("FIRMWARE") !== -1 && errMsg.indexOf(".") !== -1)){
							errMsg = undefined;
						}
						$scope.fileSelect.showErrMsg(errMsg);
					} else if ( response["RESPONSE"] === "OK" ){
						$route.reload();
					}
				}
			}

			$element.on( "change", function(event){
				var value = event.target.value;
				var v = value.toString().match(/.+(?=\\)/g);
				if ( v && v[0] && v[0].length ){
					v = value.substring(v[0].length+1);
				}else{
					v = value;
				};

				$scope.fileSelect.validate( v );
				angular.element($element.find("input")[0]).val(v);
				return false
			} );

			$scope.fileSubmit = function(){
				var form = $element.find("form")[0],
						credInput = $element.find("input")[2],
					span = $element.find("span");
				if ( $element.find("input").val() === "" || $element.hasClass("fileSelectTip") ){
					$element.addClass("fileSelectTip");
					return
				}
				$scope.iframe.one( "load", iframeLoadHandler );
				angular.element(credInput).val( $scope.fileSelect.getCredentialId() );
				form.submit();
				$scope.fileSelect.closeMsg();
			}
			$scope.$on("fileSubmit", function(e){
				$scope.fileSubmit();
			})
			$scope.$on("fileCancel", function(e){
				inputClear();
				$scope.fileSelect.closeMsg();
			})
			$scope.$on("errShow", function(e){
				$element.addClass("fileSelectTip");
			})
			$scope.$on("errHide", function(e){
				$element.removeClass("fileSelectTip");
			})
        }
	}
}])

/*menu*/
pharosModule.directive("menu", ["$proxy", "$form", "$tool", "$timeout", '$interval', "$rootScope",
function($proxy, $form, $tool, $timeout, $interval, $rootScope){
	return {
		restrict: "A",
		replace: true,
        templateUrl: "components/common/menu.html",
		transclude: true,
		scope: {
			menu: "=",
			config: "=",
			// editor: "=",
			grouping: "&",
			info: "=",
			addCls: "@",
			editCls: "@",
			deleteCls: "@"
		},
		link: function($scope, $element, $attrs, ctrls, $transclude){
			var defaults = {
				proxy: null,
				editable: false,
				editor: null,
				group: ""
			};
			var isEditing = -1;

			$scope.config = angular.extend({}, defaults, $scope.config);

			if($scope.config.editable){
				if(angular.isObject($scope.config.editor)){
					var options = {};
					options.autoLoad = false;
					options.fields = $scope.config.editor.fields ? angular.extend([],$scope.config.editor.fields) : null;
					options.validator = $scope.config.editor.validator || null;
					$form.config($scope.menu, options);
				}

				$scope.addMsg = {
					title: "MENU.ADDFOLDER",
					okBtn: {
						handler: function(){}
					},
					cancelBtn: {
						handler: function(){
							$form.clear($scope.menu);
							$scope.addMsg.show = false;
						}
					},
					autoClose: false
				};
				$scope.editMsg = {
					title: "MENU.EDITFOLDER",
					okBtn: {
						handler: function(){}
					},
					cancelBtn: {
						handler: function(){
							$form.clear($scope.menu);
							$scope.editMsg.show = false;
						}
					},
					autoClose: false
				};
				$scope.delMsg = {
					title: "MENU.CONFIRMATION",
					content: "MENU.DELGROUP",
					okBtn: {
						handler: function(){}
					},
					cancelBtn: {
						handler: function(){
							$scope.delMsg.show = false;
						}
					},
					autoClose: false
				};

				$scope.errorMsg = {
					title: "FORM.ERROR",
					content: "ERROR.UNKNOWN_ERROR",
					okBtn: {
						handler: function(){
							$scope.errorMsg.show = false;
						}
					},
					cancelBtn: {
						show: false
					},
					autoClose: false
				};

				function showErrMsg(errMsg){
					$scope.errorMsg.content = errMsg;
					$scope.errorMsg.show = true;
				}

				var editGroupTree = function(uuid, typeName){
					if(isEditing === 0 || $form.validate($scope.menu)){
						var node = {};
						if(isEditing !== 0){
							for(var index = 0, len = $scope.menu.form.fields.length; index < len; index++){
								var name = $scope.menu.form.fields[index].name;
								var mapping = $scope.menu.form.fields[index].mapping || name;
								node[name] = $scope.menu.form.data[name].data;
							}
						}
						// deal with tree
						var editMenu = angular.copy($scope.menu.data);
						if(typeName === "Auto" || typeName === "Manual"){
							var treeName = typeName === "Auto" ? "autoTree" : "manualTree";
							if(isEditing === -1){
								node.children = [];
								node["description"] = "";
								node["type"] = typeName;
								node["isLeaf"] = true;
								if(typeName === "manualTree"){
									node["deviceIDList"] = [];
								}
								node.uuid = $tool.createUuid();
								editMenu[treeName].children.push(node);
							}
						} else {
							for(var tree in editMenu){
								traverseTree(editMenu[tree], uuid, typeName);
							}
						}

						var success = $scope.config.editor.success || function(){};
						var failure = $scope.config.editor.failure || function(){};
						var error = $scope.config.editor.error || function(){};

						if(isEditing === 0){
							editMenu.deleted = [];
							editMenu.deleted.push(node);
						}else if(isEditing === -1){
							editMenu["new"] = [];
							editMenu["new"].push(node);
						}else{
							editMenu.modified = [];
							editMenu.modified.push(node);
						}

						var data = {"REQUEST": $scope.config.editor.request, "DATA":editMenu};
						var closeMsg = function(){
							if(isEditing === 0){
								$scope.delMsg.show = false;
								$scope.delMsg.disabled = false;
							}else if(isEditing === -1){
								$form.clear($scope.menu);
								$scope.addMsg.show = false;
								$scope.addMsg.disabled = false;
							}else{
								$form.clear($scope.menu);
								$scope.editMsg.show = false;
								$scope.editMsg.disabled = false;
							}
						}
						$proxy.request($scope.config.proxy, data, function(data){
							// init menu
							success(data, editMenu, uuid);
							// $scope.information.curFolder = node
							closeMsg();
						}, function(errMsg){
							// failed tip
							failure(errMsg);
							$form.clear($scope.menu);
							closeMsg();

							showErrMsg(errMsg);
						}, function(){
							// error tip
							error(data);
							closeMsg();
						});

					}else{
						// error tips
						isEditing === -1 ? $scope.addMsg.disabled = false : $scope.editMsg.disabled = false;
					}

					var delFlag = false;
					function traverseTree(root, uuid, typeName){
						if(root){
							if(root.uuid == uuid){
								if(isEditing === -1){
									node.children = [];
									node["description"] = "";
									node["type"] = typeName;
									node["isClosed"] = true;
									node.uuid = $tool.createUuid();
									// uuid can't be same,could use a global variable to save used uuid
									node ? root.children.push(node): null;
								}else if(isEditing === 0){
									delFlag = true;
									node.uuid = uuid;
								}else{
									// root = angular.extend({}, node, {children: root.children})
									for(var name in node){
										root[name] = node[name];
									}
									node = root;
								}
							}else if(root.children && root.children.length !== 0){
								for(var index = 0; index < root.children.length; index++){
									traverseTree(root.children[index], uuid, typeName);
									if(delFlag){
										root.children.splice(index ,1);
										index--;
										delFlag = false;
									}
								}
							}
						}
					}
				};

				/* ---------- */
				var id = $scope.$id;
				if ( !$scope.info.addFolder  ) $scope.info.addFolder  = {};
				if ( !$scope.info.delFolder  ) $scope.info.delFolder  = {};
				if ( !$scope.info.editFolder ) $scope.info.editFolder = {};
				$scope.info.addFolder[id] = function(uuid, initAddfn, cantAdd){
					var typeName;
					if ( cantAdd && cantAdd() ) return;

					if ( angular.isFunction( initAddfn ) ){
						typeName = initAddfn();
					}

					$scope.addMsg.show = true;
					$scope.addMsg.okBtn.handler = function(){
						isEditing = -1;
						$scope.addMsg.disabled = true;
						editGroupTree(uuid, typeName);
					};
				};
				$scope.info.delFolder[id] = function(uuid, cantDel){
					if ( cantDel && cantDel() ) return;

					$scope.delMsg.show = true;
					$scope.delMsg.okBtn.handler = function(){
						isEditing = 0;
						$scope.delMsg.disabled = true;
						editGroupTree(uuid);
					}
				}
				$scope.info.editFolder[id] = function(uuid, initEditfn, canEdit){
					initEditfn && initEditfn();
					if ( canEdit && canEdit() ) return;

					$scope.editMsg.show = true;
					$scope.editMsg.okBtn.handler = function(){
						isEditing = uuid;
						$scope.editMsg.disabled = true;
						editGroupTree(uuid);
					}
				};
			}
			/* ----------------------------------------------------------------------------- */
			if ( !$scope.info.scopes ) $scope.info.scopes = {};
			$scope.info.scopes[id] = $scope;
			if ( !$scope.info.elements ) $scope.info.elements = {};
			$scope.info.elements[id] = $element;
			if ( !$scope.info.treeNodeArrays ) $scope.info.treeNodeArrays = {};

			function updateTreeNodeArrays(){
				var i, len, treenode, treeNodeArr = [];
				angular.forEach( $element.find("span"), function(value, key){
					var $value = angular.element(value);
					if ( $value.hasClass("currentfolder") ){
						treeNodeArr.push( value );
					}
				});
				$scope.info.treeNodeArrays[ $scope.info.curScope ] = treeNodeArr;
				for ( i = 0, len = treeNodeArr.length; i < len; i++) {
					treenode = treeNodeArr[i];
					// var _curSpan = $scope.info.curElement[0].querySelector(".currentfolder");
					var _curSpan = $scope.info.curElement[0];
					if ( angular.equals( treenode, _curSpan ) ){
						$scope.info.curTreeNodeIndex = i;
						break;
					}
				};
			}
			$scope.setCurFolder = function(obj){
				if ( $scope.info.curElement && $scope.info.curElement.hasClass("selected") ){
					$scope.info.curElement.removeClass("selected");
				}
				$scope.info.curFolder  = obj.folder;
				var _curElement = obj.target.target ? obj.target.target : obj.target.srcElement;
				$scope.info.curElement = angular.element(_curElement);
				$scope.info.curElement.addClass("selected");

				$scope.info.curScope = $scope.$id;
				$scope.info.scopes[$scope.$id] = $scope;
				for ( var treename in $scope.info.scopes[$scope.info.curScope].menu.data ){
					$scope.info.treename = treename;
				}
				updateTreeNodeArrays();
				$rootScope.$broadcast("ev_setCurFolder");
			}
			$timeout(function(){
				$scope.info._arr = $scope.info._arr ? $scope.info._arr : [];
				angular.forEach( $element.find("span"), function(value, key){
					var $value = angular.element(value);
					if ( $value.hasClass("currentfolder") ){
						$scope.info._arr.push( value );
					}
				});
				$scope.info._arr[0].click();
				$scope.info._arr[0].click();
			}, 800);
		}
	}
}]);

/*timeDisplay*/
pharosModule.directive('timeDisplay', ['$interval', 'dateFilter', function($interval,dateFilter){
	return {
		restrict: "A",
		templateUrl: "components/common/timedisplay.html",
		replace: true,
		scope:{
			timeDisplay: "="
		},
		link: function(scope, element, attrs){
			var format, timeoutId;

			function updateTime(){
				angular.element(element.find("span")[1]).text(dateFilter(new Date(), format)).addClass("white");
			}

			scope.$watch(function(){ return scope.timeDisplay}, function(value){
				format = value || "M/d/yy h:mm:ss a";
				updateTime();
			});

			timeoutId = $interval(function(){
				updateTime();
			}, 1000);

			element.on('$destroy', function(){
				$interval.cancel(timeoutId);
			});
		}
	}
}]);

/*search*/
pharosModule.directive("search", [ "$rootScope", "$timeout", function($rootScope, $timeout){
	return{
		restrict: "A",
		templateUrl: "components/common/search.html",
		replace: true,
		scope: {
			inputCls: "@"
		},
		link: function( $scope, $element, attr ){
			$scope.search = "OPERATE.SEARCH";
			var hideRowNumber = 0;
			function getSpanArr( element ){
				var tbody = element.parent(),
					_spanArr = [],
					_textArr = [],
					spanArr,
					itemNum = 0;
				// while( !tbody.hasClass("content-container") ){
				// 	tbody = tbody.parent();
				// }
				tbody = angular.element( document.getElementById( "grid-container" ) );
				tbody = angular.element( tbody.find("table")[0] ).find("tbody");
				spanArr = tbody.find("span");
				angular.forEach( spanArr, function( value, i ){
					var item = angular.element( value );
					if( item.hasClass( "searchbackground" ) ){
						_spanArr.push( item );
						_textArr.push( spanArr[i].innerHTML );
					} else {
						itemNum++;
						if ( item.hasClass("icon") ) itemNum--;
					}
				} )
				return [ _spanArr, _textArr, itemNum ]
			}
			$scope.changeBackgroundOfMatch = function(searchText, $event){
				var spanArr, textArr, _arr, patten;
				_arr = getSpanArr( $element );
				spanArr = _arr[0];
				textArr = _arr[1];
				// enter
				if ( undefined === searchText ) return;
				if ( $event && $event.which == 13 ){
					$scope.showSearchResult(searchText);
					//trigger $digest()
					$timeout(function(){},10);
					return;
				}
				if ( searchText === "" ) {
					angular.forEach( spanArr, function( value, i ){
						var td = value.parent("td");
						td.removeClass("searchbackground");
						td.parent("tr").removeClass("hide");
					} )
					return
				}
				pattern = new RegExp( searchText, "i" );
				angular.forEach( textArr, function( value, i ){
					var td = spanArr[i].parent("td"),
						tr = td.parent("tr");
					td.removeClass( "searchbackground" );
					if ( pattern.test( value ) ){
						if ( tr.hasClass("hide") ) tr.removeClass("hide");
						td.addClass( "searchbackground" );
					}
				} )
			}
			$scope.showSearchResult = function(searchText){
				if ( searchText == "" || searchText == undefined ) return;
				var spanArr, _arr, itemNum, i, len, sum;
				_arr = getSpanArr( $element );
				spanArr = _arr[0];
				itemNum = _arr[2];
				len = spanArr.length/itemNum;
				angular.forEach( spanArr, function( value, i ){
					var td = value.parent("td");
					spanArr[i] = 0;
					if( td.hasClass("searchbackground") ) spanArr[i] = 1;
					if ( (i+1)%len == 0 ) {
						sum = 0;
						do{
							sum = sum + spanArr[i];
							i--;
						}while( (i+1)%len !== 0 )
						if ( sum == 0 ) td.parent("tr").addClass("hide");
					}
				} )
				hideRowNumber = document.querySelectorAll("tbody#widget-grid-tbody tr.hide").length;
				selectedAndHideNumber = document.querySelectorAll("tbody#widget-grid-tbody tr.hide td.td-check span.checked").length;
				$rootScope.$broadcast( "resetTotalNumber", [hideRowNumber, selectedAndHideNumber]);
			}

			$scope.$on("ev_setCurFolder", function(e){
					$scope.searchText = "";
			});

			$scope.$watch( "searchText", function( nVal, oVal){
				if ( nVal !== oVal ){
					if ( nVal === "" ) {
						$scope.changeBackgroundOfMatch(nVal);
						$rootScope.$broadcast( "stopSearching" );
						$rootScope.$broadcast( "resetTotalNumber", [0, 0]);
					} else {
						$rootScope.$broadcast( "onSearching", [nVal]);
					}
				}
			} )
		}
	}
}]);



/*toolbar*/
pharosModule.directive("toolbar", ["$timeout", function($timeout){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/toolbar.html",
		scope: false,
		link: function(scope, ele, attrs){
			var defaults = {
				operator:{
					show: [],
					more: []
				},
				live: null,
				search: true,
				others: []
			}

			scope.toolbarConfig = angular.extend({}, defaults, scope.toolbarConfig);

			var gridCtn = angular.element(document.getElementById("gridbar-container"));
			gridCtn.empty();
			gridCtn.append(ele);

			/*scope.showslide = false;
			scope.showSlide = function(flag){
				if ( flag ) {
					scope.showslide = true;
					angular.forEach( ele.find("ul").find("div"), function(value, key){
						var $value = angular.element(value);
						if ( $value.hasClass("slide-item") ){
							var left = ele.find("ul")[0].offsetWidth + "px";
							$value.css({left: left});
						}
					} )
				};
			}
			scope.hideSlide = function(flag){
				if ( flag ){
					scope.showslide = false;
				}
			}*/
		}
	}
}]);

/*grid*/
pharosModule.directive("grid", ["$grid", "$timeout", "$msg", "$rootScope", function($grid, $timeout, $msg, $rootScope){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/grid.html",
		transclude: true,
		scope: {
			config: '=config',
			grid: "=grid",
			editCls: '@',
			deleteCls: '@'
		},
		link: function($scope, $element, $attrs){
			var defaults = {};
			for(var index = 0; index < $scope.config.columns.length; ++index){
				$scope.config.columns[index].index = index;
			}
			$scope.showFields = $scope.config.columns.filter(function(value){
				$scope.config.hideFields = $scope.config.hideFields || [];
				return !($scope.config.hideFields.indexOf(value.name) != -1);
			});

			$scope.showFieldSelect = function(index, selected){
				if(selected){
					$scope.showFields.splice(index, 0, $scope.config.columns[index]);
					$scope.showFields.sort(function(a, b){return a.index < b.index ? -1 : 1});
					$scope.config.setHideFields && $scope.config.setHideFields($scope.config.columns[index].name, "delete");
				}else{
					for(var jndex = 0; jndex < $scope.showFields.length; jndex++){
						if($scope.showFields[jndex].index == index){
							$scope.showFields.splice(jndex, 1);
							$scope.config.setHideFields && $scope.config.setHideFields($scope.config.columns[index].name, "add");
							break;
						}
					}
				}
				$scope.resetDeviceGridWidth();
			};
			$scope.resetDeviceGridWidth = function(){
				var width = 0;
				$scope.showFields.forEach(function(value){
					width += value.width ? value.width : 133;//default column width is 133px
				});
				width = width < 934 ? 934 : width;//min-width is 100%
				angular.element($element[0].querySelector(".widget-grid-content-container")).css("width", width + 'px');
			}
			if($scope.config.showMoreList !== false){
				$scope.resetDeviceGridWidth();
			}

			$scope.showMore = false;

			$scope.grouping = function(item){
				return angular.isDefined($scope.config.grouping) ? $scope.config.grouping(item) : true;
			}
			var preName = "";
			$scope.orderGrid = function(name, format){
				if(preName === name){
					$scope.reverse = !$scope.reverse;
				}else{
					$scope.reverse = false;
					preName = name;
				}
				$scope.order = function(data){
					if(format){
						return format(data[name].data);
					}
					return data[name].data;
				}
			};

			/*$scope.selectItem = function(event, id, rowSelect){
				for(var index = 0, len = $scope.grid.data.length; index < len; index++){
					if($scope.grid.data[index].key == id){
						if(event.ctrlKey){
							var sIndex = $scope.grid.selectedIndexs.indexOf(index);
							if(sIndex == -1){
								$scope.grid.selectedIndexs.push(index);
							}else{
								$scope.grid.selectedIndexs.splice(sIndex,1);
							}
						}else{
							$scope.grid.selectedIndexs = [index];
						}
						break;
					}
				}
			};*/

			$scope.rows = [];
			$scope.collection = [];
			// $scope.selectedKeys = [];
			$scope.config.currentGridLength = 0;
			$scope.config.showGridLength = 0;
			$scope.config.totalSelectedLength = 0;
			$scope.config.showSelectedLength = 0;
			$scope.allSelect = {data: 0};

			$scope.allSelect.changeAllHandler = function(nVal){
				nVal = nVal ? 1 : 0;
				$scope.rows.forEach(function(value){
					value.data = nVal;
				});
			}

			$scope.$watch('collection', function(nV, oV){
				var length = document.querySelectorAll("tbody#widget-grid-tbody tr td.td-check span.checked").length;
				$scope.config.totalSelectedLength = $scope.config.showSelectedLength = length;
				$scope.rows = $scope.rows.filter(function(rowValue){
					return $scope.collection.some(function(value){
						return rowValue.key == value.key;
					});
				});
			})

			$scope.$watch( 'rows', function(nV, oV){
				if ( nV !== oV ){
					var flag = false;
					flag = $scope.rows.some(function(value){
						return value.data === 0;
					});
					if($scope.rows.length == 0){
						flag = true;
					}
					$scope.allSelect.data = flag ? 0 : 1;
				}
			}, true);

			$scope.delMsg = {
				title: "FORM.CONFIRMATION",
				content: "FORM.DELGROUP",
				okBtn: {
					handler: function(){}
				},
				cancelBtn: {
					handler: function(){
						$scope.delMsg.show = false;
					}
				},
				size: "sm",
				autoClose: false
			};

			$scope.editMsg = {
				title: "FORM.ADD",
				okBtn: {
					handler: function(){
						if($scope.grid.updateIndex === ""){
							$scope.grid.insert({}, function(){
								$scope.editMsg.show = false;
							}, function(){
								$scope.editMsg.show = false;
							}, function(){
								$scope.editMsg.show = false;
							});
						}else{
							$scope.grid.update({}, function(){
								$scope.editMsg.show = false;
							}, function(){
								$scope.editMsg.show = false;
							}, function(){
								$scope.editMsg.show = false;
							});
						}
					}
				},
				cancelBtn: {
					handler: function(){
						$scope.grid.cancelEdit();
						$scope.editMsg.show = false;
						$scope.editMsg.disabled = false;
					}
				},
				autoClose: false
			};

			$scope.dbClickHandle = function(e, data, index){
				$scope.$emit( "showGridItemInfo", {index: index});
			}

			var successPrompt = $msg.create({
				type: "success",
				text: "FORM.SUCCESS"
			});

			var failurePrompt = $msg.create({
				type: "failure",
				text: "FORM.FAILED"
			});

			$scope.$on("gridEditing", function(ev, args){
				if(ev.targetScope.grid === $scope.grid && args){
					if(args.type == "edit"){
						if ( args.addonBtn ) $scope.editMsg.addonBtn = args.addonBtn;

						if(args.options && args.options.okHandlerGenerator){
								$scope.editMsg.okBtn.handler =  args.options.okHandlerGenerator($scope, $scope.editMsg);
						}

						$scope.editMsg.okBtn.text = "FORM.SAVE";
						$scope.editMsg.title = "FORM.EDIT";
						$scope.editMsg.msg_errtip = "";
						$scope.editMsg.show = true;
					}else if(args.type == "add"){
						$scope.editMsg.addonBtn = false;
						if(args.options && args.options.okHandlerGenerator){
								$scope.editMsg.okBtn.handler =  args.options.okHandlerGenerator($scope, $scope.editMsg);
						}

						$scope.editMsg.okBtn.text = "FORM.OK";
						$scope.editMsg.title = "FORM.ADD";
						$scope.editMsg.msg_errtip = "";
						$scope.editMsg.show = true;
					}else if(args.type == "remove"){
						var formData = {};
						var keyword = $scope.grid.key + "List";
						formData[keyword] = [];
						if(args.items && args.items.length){
							for(var index = 0, len = args.items.length; index < len; index++){
								formData[keyword].push($scope.grid.data[args.items[index]].key);
							}
						}

						$scope.delMsg.okBtn.handler = function(){
							$scope.grid.remove({
								"DATA": formData
							}, function(){
								$scope.delMsg.show = false;
								successPrompt.show();
							}, function(){
								$scope.delMsg.show = false;
								failurePrompt.show();
							}, function(){
								$scope.delMsg.show = false;
								failurePrompt.show();
							});
						};

						if(args.options && args.options.okHandlerGenerator){
								$scope.delMsg.okBtn.handler =  args.options.okHandlerGenerator($scope, $scope.delMsg, formData);
						}

						$scope.delMsg.show = true;
					}

				}
			});
			/*$scope.$watch("grid.isEditing", function(nVal){
				if(nVal === true){
					$scope.editMsg.show = true;
				}
			});*/
			$scope.toggleOtherList = function(type){
				if(type){
					angular.element(document.getElementById("dropdown-menu")).find('li').addClass("show");
				}else{
					angular.element(document.getElementById("dropdown-menu")).find('li').removeClass("show");
				}
			}

			var getCss = function(obj, key){
				if(key == "height" && obj.currentStyle){
					return obj.offsetHeight;
				}
			    return obj.currentStyle ?  obj.currentStyle[key] : window.getComputedStyle(obj, null)[key];
			};

			$scope.theadH = 0;
			$scope.tbodyH = 0;
			var tgrid = document.getElementById("widget-grid-content-body");
			$scope.tgridH = parseInt(getCss(tgrid, "height"));
			$scope.resizeGrid = function(type){
				if(type == "thead"){
					var thead = $element.find("thead");
					$scope.theadH = parseInt(getCss(thead[0], "height"));
				}else if(type == "tbody"){
					var tbody = $element.find("tbody")[0];
					$scope.tbodyH = parseInt(getCss(tbody, "height"));
				}

				var lasttr = document.getElementById("last-tbody-tr");
				var height = $scope.tgridH - $scope.theadH - $scope.tbodyH;
				height = height > 0 ? height : 0;
				if(height == 0){
					angular.element(lasttr).addClass("hidden");
				}else{
					angular.element(lasttr).removeClass("hidden");
				}
				angular.element(lasttr).css("height", height + 'px');
			}

			$scope.finishHandler = function(type){
				$scope.resizeGrid(type);
			}

			var MutationObserver = window.MutationObserver || window.WebkitMutationObserver || window.MozMutationObserver;
			var mutationObserverSupport = !! MutationObserver;
			var observeConfig = {
				childList: true,
				characterData: true,
				attributes: true,
				subtree: true,
				attributeFilter: ['class']
			}
			if(mutationObserverSupport){
				var observer = new MutationObserver(function(mutations){
					var resizeFlag = mutations.some(function(mutation){
						if(mutation.type == "attributes"){
							try{
								if(mutation.target.parentNode.id == "widget-grid-tbody"){
									return true;
								}
							}catch(error){
								return false;
							}
						}else{
							return true;
						}
					});
					resizeFlag && $scope.resizeGrid("tbody");
				});
				observer.observe($element[0], observeConfig);
			}else if($element[0].attachEvent){
				$scope.$watch(function(){
					return getCss($element.find("tbody")[0], "height");
				}, function(){
					$scope.resizeGrid("tbody");
				});
			}

			$rootScope.$on("resetTotalNumber", function(e, numbers){
				var hideRowNumber = numbers[0];
				var selectedAndHideNumber = numbers[1];
				$scope.config.showGridLength = $scope.config.currentGridLength - hideRowNumber;
				$scope.config.showSelectedLength = $scope.config.totalSelectedLength - selectedAndHideNumber;
			});
		}
	}
}]);

/*gridRow*/
pharosModule.directive("gridRow", ['$parse', function($parse){
	return{
		restrict: "A",
		replace: true,
		templateUrl: "components/common/gridrow.html",
		scope: false,
		controller: function($scope){
			$scope.rowSelect = {};
			$scope.rowSelect.key = $scope.data.key;
			$scope.rowSelect.data = 0;
			var exitFlag = false;
			exitFlag = $scope.$parent.rows.some(function(value, index, array){
				if(value.key == $scope.data.key){
					array[index] = $scope.rowSelect;
					return true;
				}else{
					return false;
				}
			});
			exitFlag ? 1 : $scope.$parent.rows[$scope.$parent.rows.length] = $scope.rowSelect;

			var exitFlag = false;
			var selectedIndexs = $scope.$parent.grid.selectedIndexs;
			if(selectedIndexs.length){
				for(var index = 0, len = selectedIndexs.length; index < len; index++){
					if($scope.$parent.grid.data[selectedIndexs[index]].key === $scope.data.key){
						exitFlag = true;
						break;
					}
				}
				if(exitFlag){
					$scope.rowSelect.data = 1;
				}else{
					$scope.rowSelect.data = 0;
				}
			}else{
				$scope.rowSelect.data = 0;
			}

			$scope.$watch( "$parent.grid.selectedIndexs", function( nV, oV){
				if ( nV !== oV && nV.length === 0 ){
					$scope.rowSelect.data = 0;
				}
			})

			$scope.rowSelect.changeHandler = function(nVal){
				if(nVal !== undefined){
					var index = $scope.$parent.grid.keyToIndex.indexOf($scope.data.key);
					if(index !== -1){
						if(nVal == 1){
							var sIndex = $scope.$parent.grid.selectedIndexs.indexOf(index);
							if(sIndex === -1){
								// $scope.$parent.selectedKeys.push($scope.data.key);
								$scope.$parent.grid.selectedIndexs.push(index);
								$scope.$parent.config.totalSelectedLength++;
								$scope.$parent.config.showSelectedLength++;
							}
						}else if(nVal == 0){
							var sIndex = $scope.$parent.grid.selectedIndexs.indexOf(index);
							if(sIndex !== -1){
								// $scope.$parent.selectedKeys.splice(sIndex,1);
								$scope.$parent.grid.selectedIndexs.splice(sIndex,1);
								$scope.$parent.config.totalSelectedLength--;
								$scope.$parent.config.showSelectedLength--;
							}
						}
					}
				}
			};
		},
		link: function(scope){
		}
	}
}]);

/*slotTransclude expander transclude*/
pharosModule.directive("slotTransclude", function(){
	return {
		restrict: 'EAC',
		link: function($scope, $element, $attrs, controller, $transclude){
			if($attrs.myTransclude === $attrs.$attr.myTransclude){
				$attrs.myTransclude = '';
			}

			function ngTranscludeCloneAttachFn(clone){
				if (clone.length) {
					$element.empty();
					for(var index = 0; index < clone.length; index++){
						if(clone[index].nodeType == 1 && clone[index].hasAttribute("data-operator")){
							if(clone[index].attributes["data-operator"].value == slotName){
								$element.append(clone[index]);
								break;
							}
						}
					}
				}
			}

			if(!$transclude){
				throw new Error('error');
			}

			var slotName = $attrs.slotTransclude;
			$transclude(ngTranscludeCloneAttachFn);
		}
	}
});

/*labelField*/
pharosModule.directive("labelField", function(){
	var innerHtml =	"<label class=\"widget-label control-label\" ng-class=\"[(label !== undefined ? '' : 'sr-only hidden'), (labelCls || 'm')]\">{{label | translate}}{{label ? ':' : ''}} </label>";
	return {
		restrict: "A",
		replace: true,
		template: innerHtml,
		scope: false,
		link: function(){

		}
	}
});

/*unitField*/
pharosModule.directive("unitField", function(){
	var innerHtml =  "<div class=\"widget-unit-container\"><span>{{unit | translate}}</span></div>";
	return {
		restrict: "A",
		replace: true,
		template: innerHtml,
		scope: false,
		link: function(){

		}
	}
});

/*tipField*/
pharosModule.directive("tipField", function(){
	var innerHtml =  "<div class=\"widget-tip-container\" ng-class=\"[(tipCls || 'xs'), (tip ? '' : 'empty'), (inputCls === 'null' ? 'hidden' : '')]\"><span>{{tip | translate}}</span></div>";
	return {
		restrict: "A",
		replace: true,
		template: innerHtml,
		scope: false,
		link: function(){

		}
	}
});

/*errorField*/
pharosModule.directive("errorField", ["$vtype", "$translate", function($vtype, $translate){
	var innerHtml =  "<div class=\"widget-error-container\" ng-hide=\"value.valid === true\">";
		innerHtml += 	"<span class=\"icon icon-default icon-error\"></span>";
		innerHtml += 	"<span class=\"error-tip\">{{errorTip}}</span>";
		innerHtml += "</div>";

	return {
		restrict: "A",
		replace: true,
		template: innerHtml,
		scope: {
			value: "=ngModel",
			validationChange: "="
		},
		link: function(scope, ele, attrs){
			// scope.errmsg.visible = false;
			scope.$watch("validationChange", function(nVal, oVal){
				if(nVal == true){
					var value = (angular.isDefined(scope.value.encryption) || scope.value.encryption === null) ? scope.value.inputData : scope.value.data;
					var vtype = scope.value.vtype;

					if(value === ""){
						if(scope.value.allowBlank === false){
							scope.value.valid = false;
							scope.errorTip = $translate.instant("ERROR_TIPS.NO_BLANK");
							return ;
						}
					}else{
						if(scope.value.minLength !== -1){
							if(angular.isString(value) && value.length < scope.value.minLength){
								scope.value.valid = false;
								scope.errorTip = $translate.instant("ERROR_TIPS.NO_LESS_THAN") + " " + scope.value.minLength;
								return;
							}
						}
						if(scope.value.maxLength !== -1){
							if(angular.isString(value) && value.length > scope.value.maxLength){
								scope.value.valid = false;
								scope.errorTip = $translate.instant("ERROR_TIPS.NO_GREATER_THAN") + " " +scope.value.maxLength;
								return;
							}
						}
						if(vtype !== null){
							if(angular.isString(vtype)){
								var vResult = $vtype[vtype](value);
								if( vResult !== true){
									scope.value.valid = false;
									scope.errorTip = $translate.instant( vResult );
									return ;
								}
							}else if(angular.isObject(vtype)){
								var vResult = $vtype[vtype.vtype](value, vtype.config);
								if( vResult !== true){
									scope.value.valid = false;
									// scope.errorTip = vResult;
									return ;
								}
							}
						}
						if(scope.value.validate !== null){
							if(angular.isFunction(scope.value.validate) && scope.value.validate() !== true){
								scope.value.valid = false;
								scope.errorTip = scope.value.validate.errorTip ? scope.value.validate.errorTip : '';
								return ;
							}
						}
					}
					scope.value.valid = true;
				} else {
					scope.errorTip = '';
				}
			});
		}
	}
}]);

/*formatData*/
pharosModule.directive('formatData', ['$filter', "$parse",function($filter, $parse) {
    return {
    	restrict: "A",
    	require: "ngModel",
        link: function(scope, ele, attrs, ctrl) {
            /*function formatter(value) {
            	ctrl.$modelValue = dateFilter(value,1);
                return ctrl.$modelValue;
            }

            function parser() {
            	ctrl.$viewValue = dateFilter(ctrl.$viewValue,1);
                return ctrl.$viewValue;
            }

            ctrl.$formatters.push(formatter);
            scope.$watch(function(){
            	var value = $parse(attrs.ngModel)(scope);
            	if(ctrl.$viewValue !== ctrl.$modelValue){
            		ctrl.$modelValue = dateFilter(value, 1);
            	}
            	return value;
            });
            ctrl.$parsers.unshift(parser); */

            var viewFlag = false;
			var dataFilter, config;
			var dataFormat = scope.textField ? scope.textField.format : null;

			if(dataFormat !== null){
				if(angular.isFunction(dataFormat)){
					dataFilter = dataFormat;
				}else if(angular.isObject(dataFormat)){
					dataFilter = $filter(dataFormat.format);
					config = dataFormat.config;
				}else if(angular.isString(dataFormat)){
					dataFilter = $filter(dataFormat);
				}
			}

            var viewFlag = false;
            var ngModelGet = $parse(attrs.ngModel);
            var ngModelSet = ngModelGet.assign;

            ele.bind("focus", function(){
            	viewFlag = true;
            }).bind("blur", function(){
            	if(dataFilter){
            		var value = ngModelGet(scope);
            		value = dataFilter(value, config);
            		ngModelSet(scope, value);
            	}
            	viewFlag = false;
            });
            scope.$watch(function(){
            	var value = ngModelGet(scope);
            	return value;
            }, function(nVal){
            	if(viewFlag !== true && dataFilter){
            		var value = dataFilter(nVal, config);
            		ngModelSet(scope, value);
            	}
            });
        }
    };
}]);

/*textField*/
pharosModule.directive("textField", ["$filter", function($filter){
	return {
		restrict: "AE",
		replace: true,
		templateUrl: "components/common/textfield.html",
		scope: {
			textField: "=ngModel",
			type: "@",
			placeholder: "@",
			label: "@",
			unit: "@",
			tip: "=",
			cls: "@",
			labelCls: "@",
			inputCls: "@",
			tipCls: "@",
			iconCls: "@"
		},
		link: function(scope, ele, attrs, ctrl){

			angular.element(ele.find("input")[0]).bind("focus", function(){
				scope.validationChange = false;
				// scope.textField.setNormal();
				scope.$apply();
			});
			angular.element(ele.find("input")[0]).bind("blur", function(){
				scope.validationChange = true;
				scope.$apply();
			});
		}
	}
}]);

/*password*/
pharosModule.directive("password", ["$encrypt", function($encrypt){
	return {
		restrict: "AE",
		replace: true,
		templateUrl: "components/common/password.html",
		scope: {
			password: "=ngModel",
			label: "@",
			placeholder: "@",
			unit: "@",
			tip: "@",
			cls: "@",
			labelCls: "@",
			inputCls: "@",
			tipCls: "@",
			iconCls: "@"
		},
		link: function(scope, ele, attrs, ctrl){
			scope.password.inputData = "";

			var enterDown = false;
			angular.element(ele.find("input")[0]).bind("focus", function(){
				scope.validationChange = false;
				// scope.textField.setNormal();
				scope.$apply();
			});
			angular.element(ele.find("input")[0]).bind("blur", function(e){
				if(enterDown){
					enterDown = false;
					return;
				}
				scope.validationChange = true;
				scope.$apply();
			});
			angular.element(ele.find("input")[0]).bind("keydown", function(e){
				if(e.keyCode == 13 || e.keyCode == "Enter"){
					scope.validationChange = true;
					scope.$apply();
					enterDown = true;
					scope.$parent.login && scope.$parent.login();
				}
			});
		}
	}
}]);

/*textarea*/
pharosModule.directive("textarea", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/textarea.html",
		scope:{
			textarea: "=ngModel",
			label: "@",
			cls: "@",
			labelCls: "@",
			inputCls: "@"
		},
		link: function(scope){

		}
	}
});

/*comboField*/
pharosModule.directive("comboField", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/combofield.html",
		scope: {
			combo: "=ngModel",
			label: "@",
			cls: "@",
			labelCls: "@",
			inputCls: "@"
		},
		link: function(scope, ele, attrs){
			scope.$watch("combo.data", function(nVal, oVal){
				if(scope.combo && angular.isFunction(scope.combo.changeHandler)){
					scope.combo.changeHandler(nVal);
				}
			});
			scope.change = function(){
			}
		}
	}
});

/*displayField*/
pharosModule.directive("displayField", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/displayfield.html",
		scope: {
			display: "=ngModel",
			label: "@",
			cls: "@",
			labelCls: "@",
			inputCls: "@"
		},
		link: function(scope, ele, attrs){
		}
	}
});

/*checkbox*/
pharosModule.directive("checkbox", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/checkbox.html",
		scope:{
			checkbox: "=ngModel",
			label: "@",
			tip: "@",
			onChange: "&",
			cls: "@",
			labelCls: "@",
			inputCls: "@"
		},
		link: function(scope, ele, attrs){
			var defaults = {
				onVal: 1,
				offVal: 0
			};
			var config = scope.checkbox ? angular.extend({}, defaults, scope.checkbox.options) : defaults;

			scope.$watch("checkbox.data",function(nVal, oVal){
				if(nVal === config.onVal){
					scope.inputData = true;
				}else if(nVal === config.offVal){
					scope.inputData = false;
				}

				if(scope.checkbox && angular.isFunction(scope.checkbox.changeHandler)){
					scope.checkbox.changeHandler(nVal, oVal);
				}
			});
			scope.change = function(){
				if(scope.checkbox){
					scope.onChange();
					if(scope.inputData == false){
						scope.checkbox.data = config.offVal;
					}else{
						scope.checkbox.data = config.onVal;
					}
				}
			};
			scope.updateCheck = function(e){
				var target = e.target;
				var parent = angular.element(target).parent();
				var checkbox = parent.find("input");
				if(parent.hasClass("disabled")){
					return false;
				}else{
					scope.inputData = !scope.inputData;
					if(ele.hasClass("all-checkbox") && scope.checkbox && angular.isFunction(scope.checkbox.changeAllHandler)){
						scope.checkbox.changeAllHandler(scope.inputData);
					}
				}
			}
		}
	}
});

/*radioGroup*/
pharosModule.directive("radioGroup", function(){
	return {
		restrict: "A",
		replace: true,
		transclude: true,
		templateUrl: "components/common/radiogroup.html",
		scope: {
			label: "@label",
			value: "=ngModel",
			cls: "@",
			labelCls: "@",
			display: "@"
		},
		link: function(scope, element, attrs){
			scope.selected = function(radioValue){
				scope.value.data = radioValue;
			}
		}
	}
});

/*progressBar*/
pharosModule.directive("progressBar", ["$timeout", function($timeout){
	return {
		restrict: "AE",
		replace: true,
		templateUrl: "components/common/progressbar.html",
		scope: {
			progress: "=ngModel",
			cls: "@",
			label: "@label",
			labelCls: "@"
		},
		link: function(scope, ele, attrs){
			scope.completion = "0%";
			function findProg(){
				var divArr = angular.element(ele.find("div"));
				var i, len = divArr.length;
				for ( i = 0; i < len; i ++ ){
					if( angular.element( divArr[i] ).hasClass( "progress-bar" ) ){
						return divArr[i];
					}
				}
			}
			function updateProg(value){
				if ( value < 0 ) value = 0;
				if ( value > 100 ) value = 100;
				var progBar = findProg();
				if ( progBar ){
					progBar = angular.element( progBar );
					progBar.css("width", value + "%");
					// progBar.text( value + "%" );
					scope.completion = value + "%";
				}
			}
			scope.$watch( "progress.progress", function(nV, oV){
				if ( nV !== oV ){
					updateProg(nV);
				}
			});
		}
	}
}]);

/*button*/
pharosModule.directive("button", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/button.html",
		scope: {
			config: "=ngModel",
			text: "@",
			onClick: "&",
			cls: "@"
		},
		link: function(scope, ele, attrs){}
	}
});

/*noteField*/
pharosModule.directive("noteField", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/notefield.html",
		scope:{
			content: "@",
			note: "@",
			title: "@",
			cls: "@"
		},
		link: function(){}
	}
});

/*conditionField*/
pharosModule.directive("conditionField", function(){
	return {
		restrict: "AE",
		replace: true,
		templateUrl: "components/common/conditionfield.html",
		scope: {
			expression: "=ngModel",
			cls: "@"
		},
		link: function(scope, ele, attrs){

		}
	}
});

/*condition*/
pharosModule.directive("condition", ["$timeout", function($timeout){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/condition.html",
		scope:{
			condition: "=condition",
			ngModel: "=",
			cls: "@",
			operateCls: "@",
			inputCls: "@"
		},
		controller: function( $scope ){
			$scope.conditionArr = [];
			$scope.operatorArr = [];
			$scope.seperate = function( expression ){
				var conditionArr = [],
					operatorArr = [];
				while( expression.type == "complex" ){
					operatorArr.push( expression.operator );
					conditionArr.push( expression.condition[1] );
					expression = expression.condition[0];
				}
				conditionArr.push( expression );
				return [ conditionArr, operatorArr ]
			}
			$scope.deleteItem = function( conditionArr, operatorArr, delitem, index ){
				if ( index == 0 ) {
					$scope.conditionArr.shift();
					$scope.operatorArr.shift();
				} else {
					$scope.conditionArr.splice( index, 1);
					$scope.operatorArr.splice( index-1, 1);
				}
				return [ conditionArr, operatorArr ]
			}
			function setDisplayName( conditionArr ){
				var fields = $scope.condition.options.fields,
					i, len = fields.length, item,
					hash = {};
				for ( i = 0; i < len; i++ ) {
					item = fields[i];
					hash[ item.value ] = item.name;
				};
				for ( i = 0, len = conditionArr.length; i < len; i++ ){
					item = conditionArr[i];
					item.fieldDisplayName = hash[ item.field ];
				}
			}
			$scope.merge = function( conditionArr, operatorArr ){
				var expression,
					_conditionArr = angular.copy( conditionArr ),
					_operatorArr = angular.copy( operatorArr );
				setDisplayName( _conditionArr );
				if ( _operatorArr.length != 0 ) {
					expression = _conditionArr.shift();
				} else {
					expression = _conditionArr[0];
				}
				while( _operatorArr.length ){
					expression = {
						"condition": [ expression, _conditionArr.shift() ],
						"type": "complex",
						"operator": _operatorArr.shift()
					}
				}
				return expression
			}
			$scope.addCondition = function(){
				$scope.operatorArr.push("&&");
				$scope.conditionArr.push({
					"comparator"		: "contains",
					"field"				: "deviceName",
					"fieldDisplayName"	: "Device name",
					"type"				: "simple",
					"value"				: ""
				})
				$scope.condition.data = $scope.merge( $scope.conditionArr, $scope.operatorArr );
			}
			$scope.delCondition = function( expression, index ){
				if ( index == 0 && $scope.operatorArr.length == 0 ) {
					$scope.conditionArr[0].value = "";
				} else {
					var arr = $scope.deleteItem( $scope.conditionArr, $scope.operatorArr, expression, index );
					$scope.conditionArr = arr[0];
					$scope.operatorArr = arr[1];
				}
				$scope.condition.data = $scope.merge( $scope.conditionArr, $scope.operatorArr );
			}
		},
		link: function( $scope, element, attr ){
			function generateArrs( data ){
				var arr = $scope.seperate( data );
				$scope.conditionArr = arr[0].reverse();
				$scope.operatorArr = arr[1].reverse();
			}
			$scope.$watch( "condition.data", function( newV, oldV){
				if ( newV !== oldV ){
					generateArrs( newV );
					$scope.ngModel.data = angular.copy( $scope.condition.data );
				}
			})
			$scope.$watch( "conditionArr", function( newV, oldV){
				if ( newV !== oldV ){
					$timeout(function(){
						$scope.ngModel.data = $scope.merge( newV, $scope.operatorArr );
					}, 0);
				}
			}, true);
			$scope.$watch( "operatorArr", function( newV, oldV){
				if ( newV !== oldV ){
					$timeout(function(){
						$scope.ngModel.data = $scope.merge( $scope.conditionArr, newV );
					}, 0);
				}
			}, true);
		}
	}
}]);

/*deviceList*/
pharosModule.directive("deviceList", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/devicelist.html",
		scope: {
			list: "=deviceList",
			ngModel: "=",
			isSingle: "@",
			cls: "@",
			inputCls: "@",
			tableCls: "@"
		},
		link: function($scope, $element, $attrs){
			$scope.singleSelection = $scope.isSingle === "true" ? true : false;
			$scope.list.data = [];
			var getOption = function(index, initFlag){
				var validFlag = true;
				var option = {};
				var fields = $scope.list.dataFields ? $scope.list.dataFields.fields : [];
				if(fields && fields.length !== 0 && fields.length !== 1){
					for(var findex = 0, len = fields.length; findex < len; findex++){
						var name = fields[findex];
						if($scope.list.options[index][name] && angular.isDefined($scope.list.options[index][name].data)){
							option[name] = $scope.list.options[index][name].data;
						}else{
							option[name] = $scope.list.options[index][name];
						}
						if(!option[name] && $scope.list.dataFields.allowBlank === false && (!initFlag || $scope.list.dataFields.initBlank == false)){
							validFlag = false;
						}
					}
				}else{
					option = (fields && fields.length === 1) ? $scope.list.options[index][fields[0]] : $scope.list.options[index].key;
				}
				return validFlag ? option : "";
			};
			$scope.init = function(index){
				$scope.allSelect.data = 0;
				var option = getOption(index, true);
				if(option !== ""){
					// $scope.list.data.push(option);
				}
			};
			$scope.updateSelection = function(isSelected, index){
				var option = getOption(index);
				var flag = false;
				//exsting no-checked box
				flag = $scope.list.options.some(function(value, index){
					return value.isSelected === false;
				});
				$scope.allSelect.data = flag ? 0 : 1;

				if(isSelected){

					if($scope.singleSelection){
							for(var i = 0, len = $scope.list.options.length; i<len; i++){
								if(i === index){
									$scope.list.options[i].isSelected = isSelected;
								}else{
									$scope.list.options[i].isSelected = false;
								}
							}
							$scope.list.data = [];
							$scope.list.data.push(option);
							return;
					}


					if(option !== ""){
						$scope.list.data.push(option);
					}
				}else{
					if(angular.isObject(option)){
						var key = $scope.list.dataFields.key;
						if(key){
							var keyIndex = -1;
							for(var index = 0, len = $scope.list.data.length; index < len; index++){
								if(option[key] === $scope.list.data[index][key]){
									keyIndex = index;
									break;
								}
							}
						}
					}else{
						var keyIndex = $scope.list.data.indexOf(option);
					}
					if(keyIndex !== -1){
						$scope.list.data.splice(keyIndex, 1);
					}
				}
			};

			$scope.allSelect = {};
			$scope.allSelect.changeAllHandler = function(nVal){
				var index, len;
				if(nVal == 1){
					for(index = 0, len = $scope.list.options.length; index < len; index++){
						if ( $scope.list.options[index].isSelected == true ) continue;
						$scope.list.options[index].isSelected = true;
						$scope.updateSelection(true, index);
					}
				}else if(nVal == 0){
					for(index = 0, len = $scope.list.options.length; index < len; index++){
						$scope.list.options[index].isSelected = false;
					}
					$scope.list.data = [];
				}
			}

			$scope.$watch("list.options.length", function(nVal){
				if(!nVal){
					$scope.list.data = [];
				}
			});

			$scope.$watch("list.data", function(nVal, oVal){
				if(nVal.length){
					for(var oIndex = 0, oLen = $scope.list.options.length; oIndex < oLen; oIndex++){
						$scope.list.options[oIndex].isSelected = false;
					}

					var objectFlag = false;
					keyField = ($scope.list.dataFields && $scope.list.dataFields.key) ? $scope.list.dataFields.key : "key";
					if(angular.isObject($scope.list.data[0])){
						objectFlag = true;
					}
					for(var index = 0, len = $scope.list.data.length; index < len; index++){
						var keyData = objectFlag ? $scope.list.data[index][keyField] : $scope.list.data[index];
						for(var oIndex = 0, oLen = $scope.list.options.length; oIndex < oLen; oIndex++){
							if(keyData == $scope.list.options[oIndex][keyField]){
								$scope.list.options[oIndex].isSelected = true;
								break;
							}
						}
					}
				}else if(oVal.length){
					for(var oIndex = 0, oLen = $scope.list.options.length; oIndex < oLen; oIndex++){
						$scope.list.options[oIndex].isSelected = false;
					}
				}

				if ( $scope.ngModel ) {
					$scope.ngModel = $scope.list;
				};
			},true);

			var getCss = function(obj, key){
				if(key == "height" && obj.currentStyle){
					return obj.offsetHeight;
				}
			    return obj.currentStyle ?  obj.currentStyle[key] : window.getComputedStyle(obj, null)[key];
			};

			$scope.theadH = 0;
			$scope.tbodyH = 0;
			$scope.resizeGrid = function(type){
				if(type == "thead"){
					var thead = $element.find("thead");
					$scope.theadH = parseInt(getCss(thead[0], "height")) || 40;
				}else if(type == "tbody"){
					var tbody = $element.find("tbody")[0];
					$scope.tbodyH = parseInt(getCss(tbody, "height")) || 0;
				}
				$scope.tgridH = $scope.tgridH || parseInt(getCss($element[0], "height")) || 288;
				var lasttr = $element.find("tbody")[1];
				var height = $scope.tgridH - $scope.theadH - $scope.tbodyH - 4;
				height = height > 0 ? height : 0;
				if(height == 0){
					angular.element(lasttr).addClass("hidden");
				}else{
					angular.element(lasttr).removeClass("hidden");
				}
				angular.element(lasttr).find("tr").css("height", height + 'px');
			}

			$scope.finishHandler = function(type){
				$scope.resizeGrid(type);
			}

			var MutationObserver = window.MutationObserver || window.WebkitMutationObserver || window.MozMutationObserver;
			var mutationObserverSupport = !! MutationObserver;
			if(mutationObserverSupport){
				var observer = new MutationObserver(function(mutations){
					$scope.resizeGrid("tbody");
				});
				observer.observe($element[0], {
					childList: true,
					subtree: true,
					characterData: true
				});
				$scope.$watch( function(){
					return getCss($element.find("tbody")[0], "height");
				}, function(nV, oV){
					$scope.resizeGrid("tbody");
				} );
			}else if($element[0].attachEvent){
				$scope.$watch(function(){
					return getCss($element.find("tbody")[0], "height");
				}, function(){
					$scope.resizeGrid("tbody");
				});
			}

			$scope.updateCheck = function(e, option){
				var target = e.target;
				var parent = angular.element(target).parent();
				var checkbox = parent.find("input");
				if(parent.hasClass("disabled")){
					return false;
				}else{
					option.isSelected = !option.isSelected;
				}
			}
		}
	}
});

pharosModule.directive("pingList", function(){
	return{
		restrict: "A",
		replace: true,
		templateUrl: "components/common/pinglist.html",
		transclude: true,
		scope: {
			list: "=pingList",
			onClick: "&onClick",
			cls: "@",
			inputCls: "@"
		},
		link: function($scope){
			$scope.list.selectedIndex = 0;
			$scope.selectItem = function(index){
				$scope.list.selectedIndex = index;
				// $scope.list.options[selectedIndex].result
				$scope.itemname = $scope.list.options[index].name;
			};
			$scope.deleteItem = function(){
				var options = $scope.list.options,
					len = options.length,
					i, item, name;
				if ( !len ) return;
				if($scope.name == undefined){
					$scope.selectItem($scope.list.selectedIndex);
				}
				for ( i = 0; i < len; i++ ){
					item = options[i];
					name = item["name"];
					if ( name == $scope.itemname ) {
						$scope.list.options.splice( i, 1 );

						if(i === 0){
							$scope.selectItem(0);
						} else if(i === len-1){
							$scope.selectItem(len - 2);
						} else {
							$scope.selectItem(i - 1);
						}
						break;
					}
				}
			}
		}
	}
});

/*dateField*/
pharosModule.directive("dateField", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/datefield.html",
		scope:{
			dateField: "=ngModel",
			label: "@",
			cls: "@",
			labelCls: "@",
			inputCls: "@"
		},
		link: function($scope){

			// $scope.dt = new Date();
			var setCurrentTime = function(){
				var temp = new Date();
				$scope.dateField.data = {};
				$scope.dateField.data.time = Date.parse(temp);
				$scope.dateField.data.timezoneOffset = temp.getTimezoneOffset();
			};

			if(!$scope.dateField.data){
				setCurrentTime();
				/*var temp = new Date();
				$scope.dateField.data = {};
				$scope.dateField.data.time = Date.parse(temp);
				$scope.dateField.data.timezoneOffset = temp.getTimezoneOffset();*/
			}

			/*$scope.dateOptions = {
				formatYear: 'yy',
				startingDay: 0
			};*/
			// $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
			// $scope.format = $scope.formats[1];
			$scope.format = angular.isString($scope.dateField.format) ? $scope.dateField.format : "yyyy-MM-dd";

			$scope.disabled = function(date, mode) {
				// return ( mode === 'day' && ( date.getDay() === 0 || date.getDay() === 6 ) );
			};

			$scope.setNormal = function(){
				$scope.dateField.valid = true;
			}

			$scope.open = function($event) {
				$event.preventDefault();
				$event.stopPropagation();
				$scope.dateField.valid = true;
				$scope.opened = true;
			};

			$scope.$watch("dateField.data", function(nVal){
				if(nVal && nVal.time){
					$scope.dt = new Date(nVal.time);
				}else if(nVal === ""){
					setCurrentTime();
					// $scope.dt = "";
				}
			}, true);



			$scope.changeToData = function(){
				var newDate = $scope.dt;
				if(newDate){
					$scope.dateField.data = {};
					$scope.dateField.data.time = Date.parse(newDate);
					$scope.dateField.data.timezoneOffset = newDate.getTimezoneOffset();
				}else{
					$scope.dateField.data = {};
				}
			};
		}
	}
});

/*buttonGroup*/
pharosModule.directive("buttonGroup", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/buttongroup.html",
		scope: {
			buttonGroup: "=ngModel",
			cls: "@"
		},
		link: function(scope, ele, attrs){
			if(scope.buttonGroup.data){
				scope.buttonGroup.data = scope.buttonGroup.options[0].value;
			}
			scope.touchHandler = function(index){
				scope.selectedIndex = index;
				scope.buttonGroup.data = scope.buttonGroup.options[index].value;
			}
			scope.$watch("buttonGroup.data", function(nVal){
				if(nVal){
					for(var index = 0, len = scope.buttonGroup.options.length; index < len; index++){
						if(nVal === scope.buttonGroup.options[index].value){
							scope.selectedIndex = index;
							break;
						}
					}
				}
			});
			scope.buttonGroup.data ? null : scope.buttonGroup.data = scope.buttonGroup.options[0].value;
		}
	}
});

pharosModule.directive("showStep", function(){
	return {
		restrict: "A",
		replace: true,
		templateUrl: "components/common/showstep.html",
		scope: {
			steparr: "=showStep"
		},
		link: function(scope, ele, attrs){
		}
	}
});

pharosModule.directive("windowResize", ["$window", "$timeout", function($window, $timeout){
	return {
		restrict: "A",
		replace: true,
		link: function(scope, ele, attrs){
			var timeoutId = false;
			angular.element($window).on("resize load", function(){
				if(timeoutId){
					$timeout.cancel(timeoutId);
					timeoutId = false;
				}
				timeoutId = $timeout(function(){
					doLayout();
				},100);
			});
			var doLayout = function(){
				var thead = document.getElementById("top-header");
				var tfoot = document.getElementById("top-footer");
				var tmainWrap = document.getElementById("top-main-wrap");
				var theadH = parseInt(getCss(thead, "height"));
				var tfootH = parseInt(getCss(tfoot, "height"));

				var windowHeight = window.innerHeight ? window.innerHeight : document.body.clientHeight;
				var tmainH = windowHeight - theadH;
				var minH = tmainH - tfootH - 4;
				angular.element(document.getElementById("top-main")).css("height", tmainH + "px");
				angular.element(tmainWrap).css("min-height", minH + 'px');
			}
			var getCss = function(obj, key){
				if(key == "height" && obj.currentStyle){
					return obj.offsetHeight;
				}
			    return obj.currentStyle ?  obj.currentStyle[key] : window.getComputedStyle(obj, null)[key];
			};
		}
	}
}]);

pharosModule.directive('repeatFinish',["$timeout", function($timeout){
    return {
        link: function(scope, element, attr){
        	if(element.attr("parent") && !element.parent().scope().$last){
        		return;
        	}
            if(scope.$last == true){
            	//50ms for ng-switch
            	$timeout(function(){
            		scope.finishHandler && scope.finishHandler(attr.repeatType);
            	},50);
            }
        }
    }
}]);

pharosModule.directive('radio', function(){
	var innerHtml  = "<div class=\"widget-container widget-radio-container\">";
		innerHtml += 	"<label>";
		innerHtml += 		"<input type=\"radio\" ng-model=\"radioData\" name=\"{{name}}\" value=\"{{value}}\" hidden>";
		innerHtml +=		"<span class=\"icon\" ng-click=\"selected();\" ng-class=\"[(radioData == value ? 'selected' : 'unselected')]\"></span>";
		innerHtml += 		"<span class=\"radio-text\" translate>{{label}}</span>";
		innerHtml += 	"</label>";
		innerHtml += "</div>";
	return {
		replace: true,
		restrict: 'EA',
		template: innerHtml,
		scope: {
			radioData: "=ngModel",
			name: "@",
			value: "@",
			label: "@"
		},
		link: function(scope, element, attrs){
			scope.selected = function(){
				scope.radioData = scope.value;
			}
		}
	}
});

/*gridCount*/
pharosModule.directive("gridCount", ['$parse', function($parse){
	return{
		restrict: "A",
		replace: false,
		scope: false,
		link: function(scope, elements, attrs){
			var me = scope.$parent;
			if(!me.countWatch){
				var expression = attrs.ngRepeat;
	        	var match = expression.match(/^\s*([\s\S]+?)\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?\s*$/);
	        	var rhs = match[2];
				me.$watchCollection(rhs, function(collection){
					me.collection = collection;
					var length = $parse(rhs)(me).length;//or collection.length
					me.config.showGridLength = length;
					me.config.currentGridLength = length;
				});
				me.countWatch = true;
			}
		}
	}
}]);

/*chart*/
/*pharosModule.directive("chart", ["$interval","$window", function($interval, $window){
	var innerHtml =  "<div class=\"widget-container widget-chart-container\">";
		innerHtml += 	"<div class=\"widget-title-container\">";
		innerHtml += 		"<button class=\"btn btn-default\" ng-click=\"playStopChart()\"><span class=\"glyphicon glyphicon-play\"></span></button>";
		innerHtml +=		"<div combo-field ng-model=\"graphConfig\"></div>";
		innerHtml += 	"</div>";
		innerHtml +=	"<div class=\"widget-content-container\">";
		innerHtml += 		"<div class=\"widget-legend-container\"></div>";
		innerHtml += 		"<canvas style=\"width: 400px; height:400px\"></canvas>";
		innerHtml += 	"</div>";
		innerHtml += "</div>";

	return {
		restrict: "A",
		replace: true,
		template: innerHtml,
		scope: false,
		link: function(scope, ele, attrs){

			var colors = ["rgb(220,220,220)","rgb(151,187,205)", "rgb(123,18,205)"];
			var data = {
				labels : ["0","1"],
				datasets : [
					{
						// label: "Byte",
						strokeColor : "rgb(220,220,220)",
						pointColor : "rgb(220,220,220,1)",
						pointStrokeColor : "#fff",
						data : [0,2]
					},
					{
						// label: "GB",
						strokeColor : "rgb(151,187,205)",
						pointColor : "rgb(151,187,205)",
						pointStrokeColor : "#fff",
						data : [0,1]
					}
				]
			};
			var config = {
				datasetFill: false,
				scaleOverlay: false,
				pointDot: true,
				bezierCurve: false,
				responsive: false,
				scaleShowLabels: true,
				scaleBeginAtZero: true
			};

			if (angular.isDefined($window.G_vmlCanvasManager)){
				Chart.defaults.global.animation = false;
				G_vmlCanvasManager.init_(document);
			}

			var canvas = ele.find("canvas")[0];
			var ctx = canvas.getContext("2d");
			var lineChart = new Chart(ctx).Line(data, config);

			var playFlag = false;
			var chartAnimation;
			var attrs = [];

			var startOrStopDraw = function(){
				if(attrs.length){
					playFlag = !playFlag;
					if(playFlag){
						chartAnimation = $interval(function(){
							var drawAttrsData = [];
							if(lineChart.scale.xLabels.length >= 6){
								lineChart.removeData();
							}
							for(var index = 0, len = attrs.length; index < len; index++){
								drawAttrsData.push(scope.grid.data[scope.graphIndex][attrs[index]].data);
							}
							var crrentTime = new Date();
							lineChart.addData(drawAttrsData, crrentTime.getHours()+":"+crrentTime.getMinutes()+":"+crrentTime.getSeconds());
						},1000);
					}else{
						$interval.cancel(chartAnimation);
					}
				}
			};

			scope.playStopChart = function(){
				startOrStopDraw();
			};

			scope.graphConfig.changeHandler = function(nVal){
				if(nVal || nVal === 0){

					var option = scope.graphOption.options[nVal];
					attrs = option ? option.attrs : [];

					var data = {
						labels: ["0", "1"],
						datasets: []
					};
					if(attrs.length){
						for(var index = 0, len = attrs.length; index < len; index++){
							data.datasets[index] = {
								label: attrs[index],
								strokeColor : colors[index],
								pointColor : colors[index],
								fillColor: colors[index],
								pointStrokeColor : "#fff",
								data : [0,index+1]
							};
						}
					}
					lineChart.clear();
					lineChart.initialize(data);
					lineChart.update();

					var legend = lineChart.generateLegend();
					angular.element(ele.find("div")[5]).html(legend);

					$interval.cancel(chartAnimation);
					playFlag = false;
					startOrStopDraw();
				}
			},
			scope.$watch("chartMsg.show", function(nVal){
				if(nVal == false){
					if(chartAnimation){
						$interval.cancel(chartAnimation);
						playFlag = false;
					}
				}
			});
		}
	}
}]);*/
